unit CadApi;

interface
uses
  Windows, SysUtils;

const

CAD_FALSE = 0;
CAD_TRUE = 1;
CAD_GL_SHOWSYSCURSOR = 1;
CAD_GL_CROSSSIZE = 2;
CAD_GL_SHOWCROSS = 3;
CAD_GL_CURVEQUALITY = 4;
CAD_GL_CHARQUALITY = 5;
CAD_GL_MINCHARSIZE = 6;
CAD_GL_MINCHARFSIZE = 7;
CAD_GL_MINENTSIZE = 8;
CAD_GL_DRAWSTEP = 9;
CAD_GL_MITERLIMIT = 10;
CAD_GL_AUTOSEL = 11;
CAD_GL_AUTOSELRECT = 12;
CAD_GL_SELSHIFTADD = 13;
CAD_GL_SELINSIDE = 14;
CAD_GL_SELBYLAYER = 15;
CAD_GL_UNSELAFTEREDIT = 16;
CAD_GL_SELLINE = 17;
CAD_GL_PICKBOXSIZE = 18;
CAD_GL_USEGRIPS = 19;
CAD_GL_GRIPSIZE = 20;
CAD_GL_IMAGEBORDER = 21;
CAD_GL_DXFDECPREC = 22;
CAD_GL_DXFVER = 23;
CAD_GL_DWGVER = 24;
CAD_GL_ANGUNITS = 25;
CAD_GL_FILEEXT = 26;
CAD_GL_SHOWEMPTY = 27;
CAD_GL_BLINKTIME = 28;
CAD_GL_NAVRTIME = 29;
CAD_GL_ENUMDELENTS = 30;
CAD_GL_ACADCONVERT = 31;
CAD_GL_FASTCURSOR = 32;
CAD_GL_DELSCROLLBARS = 33;
CAD_GL_SHOWEMPTYBLKS = 34;
CAD_GL_GETINVISIBLE = 35;
CAD_GL_SELINPLINE = 36;
CAD_GL_SELDRAWHATCH = 37;
CAD_GL_SNAPSHOWAPER = 38;
CAD_GL_SNAPSHOWMARK = 39;
CAD_GL_SNAPAPERSIZE = 40;
CAD_GL_SNAPMARKSIZE = 41;
CAD_GL_SMOOTHSCROLL = 42;
CAD_GL_SHOWCOMPASS = 43;
CAD_GL_EXTMARGIN = 44;
CAD_GL_MBUTTONPAN = 45;
CAD_GL_IMPDIMASBLOCK = 46;
CAD_GL_IMPHATCHEXPLODE = 47;
CAD_GL_NOACADWARNING = 48;
CAD_GL_HIDESOMEPROPS = 51;
CAD_GL_PRNUSEDOC = 52;
CAD_ENT_POINT = 1;
CAD_ENT_LINE = 2;
CAD_ENT_POLYLINE = 3;
CAD_ENT_ARC = 4;
CAD_ENT_TEXT = 5;
CAD_ENT_INSBLOCK = 6;
CAD_ENT_SHAPE = 7;
CAD_ENT_3DFACE = 8;
CAD_ENT_SOLID = 9;
CAD_ENT_IMAGE = 10;
CAD_ENT_DIM = 11;
CAD_ENT_HATCH = 12;
CAD_ENT_LEADER = 13;
CAD_ENT_MLINE = 14;
CAD_ENT_VPORT = 15;
CAD_ENT_ATTRIB = 17;
CAD_ENT_RECT = 18;
CAD_ENT_MTEXT = 19;
CAD_ENT_WINTEXT = 20;
CAD_ENT_CUSTOM = 77;
CAD_ENT_RPLAN = 81;
CAD_ENT_RPROF = 82;
CAD_CIRCLE = 1;
CAD_ARC = 2;
CAD_ELLIPSE = 3;
CAD_DIM_HOR = 1;
CAD_DIM_VER = 2;
CAD_DIM_ALIGNED = 3;
CAD_DIM_ORDX = 4;
CAD_DIM_ORDY = 5;
CAD_DIM_ANGULAR = 6;
CAD_DIM_ANG3P = 7;
CAD_DIM_RADIUS = 8;
CAD_DIM_DIAMETER = 9;
CAD_PLINE_LINEAR = 0;
CAD_PLINE_QUAD = 5;
CAD_PLINE_CUBIC = 6;
CAD_PLINE_BEZIER = 8;
CAD_PLINE_SPLINE = 99;
CAD_PLINE_ROUND = 201;
CAD_PLINE_LINQUAD = 202;
CAD_ATTRIB_INVIS = 1;
CAD_ATTRIB_CONST = 2;
CAD_ATTRIB_VERIFY = 4;
CAD_ATTRIB_PRESET = 8;
CAD_PAPER_UNLIMITED = 0;
CAD_PAPER_A0 = 1;
CAD_PAPER_A1 = 2;
CAD_PAPER_A2 = 3;
CAD_PAPER_A3 = 4;
CAD_PAPER_A4 = 5;
CAD_PAPER_A5 = 6;
CAD_PAPER_A6 = 7;
CAD_PAPER_B0 = 11;
CAD_PAPER_B1 = 12;
CAD_PAPER_B2 = 13;
CAD_PAPER_B3 = 14;
CAD_PAPER_B4 = 15;
CAD_PAPER_B5 = 16;
CAD_PAPER_B6 = 17;
CAD_PAPER_C0 = 21;
CAD_PAPER_C1 = 22;
CAD_PAPER_C2 = 23;
CAD_PAPER_C3 = 24;
CAD_PAPER_C4 = 25;
CAD_PAPER_C5 = 26;
CAD_PAPER_C6 = 27;
CAD_PAPER_ANSI_A = 31;
CAD_PAPER_ANSI_B = 32;
CAD_PAPER_ANSI_C = 33;
CAD_PAPER_ANSI_D = 34;
CAD_PAPER_ANSI_E = 35;
CAD_PAPER_LETTER = 36;
CAD_PAPER_LEGAL = 37;
CAD_PAPER_EXECUTIVE = 38;
CAD_PAPER_LEDGER = 39;
CAD_PAPER_USER = 255;
CAD_PAPER_PORTRAIT = 1;
CAD_PAPER_BOOK = 1;
CAD_PAPER_LANDSCAPE = 2;
CAD_PAPER_ALBUM = 2;
CAD_TA_BOTLEFT = 0;
CAD_TA_LEFBOT = 0;
CAD_TA_BOTCENTER = 1;
CAD_TA_CENBOT = 1;
CAD_TA_BOTRIGHT = 2;
CAD_TA_RIGBOT = 2;
CAD_TA_MIDLEFT = 3;
CAD_TA_LEFCEN = 3;
CAD_TA_MIDCENTER = 4;
CAD_TA_CENCEN = 4;
CAD_TA_MIDRIGHT = 5;
CAD_TA_RIGCEN = 5;
CAD_TA_TOPLEFT = 6;
CAD_TA_LEFTOP = 6;
CAD_TA_TOPCENTER = 7;
CAD_TA_CENTOP = 7;
CAD_TA_TOPRIGHT = 8;
CAD_TA_RIGTOP = 8;
CAD_COLOR_RED = 1;
CAD_COLOR_YELLOW = 2;
CAD_COLOR_GREEN = 3;
CAD_COLOR_CYAN = 4;
CAD_COLOR_BLUE = 5;
CAD_COLOR_MAGENTA = 6;
CAD_COLOR_WHITE = 7;
CAD_COLOR_GRAY = 8;
CAD_COLOR_LTGRAY = 9;
CAD_COLOR_BROWN = 32;
CAD_COLOR_SALAD = 60;
CAD_COLOR_WHITE2 = 247;
CAD_COLOR_BLACK = 248;
CAD_COLOR_LTBLACK = 249;
CAD_COLOR_GRAY0 = 250;
CAD_COLOR_GRAY1 = 251;
CAD_COLOR_GRAY2 = 252;
CAD_COLOR_GRAY3 = 253;
CAD_COLOR_GRAY4 = 254;
CAD_COLOR_GRAY5 = 255;
CAD_COLOR_BYBLOCK = 0;
CAD_COLOR_BYLAYER = 256;
CAD_COLOR_WINBKG = 0;
CAD_COLOR_CURSOR = 256;
CAD_COLOR_PP_WINBKG = 257;
CAD_COLOR_PP_PAPER = 258;
CAD_COLOR_PP_WHITE = 259;
CAD_COLOR_PP_CURSOR = 260;
CAD_COLOR_SELECT = 261;
CAD_COLOR_GRIPS = 262;
CAD_COLOR_SNAPMARK = 263;
CAD_COLOR_NAVBKG = 264;
CAD_COLOR_NAVRECT = 265;
CAD_COLOR_NAVBOT = 266;
CAD_COLOR_NAVLINE = 267;
CAD_COLOR_NAVTEXT = 268;
CAD_COLOR_AREAIN = 269;
CAD_COLOR_AREAOUT = 270;
CAD_COLOR_TRANSPARENT = 1687050;
CAD_LT_BYLAYER = -294934529;
CAD_LT_BYBLOCK = -294934530;
CAD_LT_CONTINUOUS = -294934531;
CAD_LAYER_0 = -294934529;
CAD_TSTYLE_STANDARD = -294934529;
CAD_MLS_STANDARD = -294934529;
CAD_DIMS_STANDARD = -294934529;
CAD_PAGE_MODEL = -294934529;
CAD_LWEIGHT_DEFAULT = -3;
CAD_LWEIGHT_BYBLOCK = -2;
CAD_LWEIGHT_BYLAYER = -1;
CAD_LWEIGHT_000 = 0;
CAD_LWEIGHT_005 = 5;
CAD_LWEIGHT_009 = 9;
CAD_LWEIGHT_013 = 13;
CAD_LWEIGHT_015 = 15;
CAD_LWEIGHT_018 = 18;
CAD_LWEIGHT_020 = 20;
CAD_LWEIGHT_025 = 25;
CAD_LWEIGHT_030 = 30;
CAD_LWEIGHT_035 = 35;
CAD_LWEIGHT_040 = 40;
CAD_LWEIGHT_050 = 50;
CAD_LWEIGHT_053 = 53;
CAD_LWEIGHT_060 = 60;
CAD_LWEIGHT_070 = 70;
CAD_LWEIGHT_080 = 80;
CAD_LWEIGHT_090 = 90;
CAD_LWEIGHT_100 = 100;
CAD_LWEIGHT_106 = 106;
CAD_LWEIGHT_120 = 120;
CAD_LWEIGHT_140 = 140;
CAD_LWEIGHT_158 = 158;
CAD_LWEIGHT_200 = 200;
CAD_LWEIGHT_211 = 211;
CAD_DS_DIMLINE = 1;
CAD_DS_EXTLINE = 2;
CAD_DS_TEXT = 3;
CAD_DS_ARROW1 = 4;
CAD_DS_ARROW2 = 5;
CAD_DS_ARRLEADER = 6;
CAD_DS_TEXT_CEN = 1;
CAD_DS_TEXT_ABOVE = 2;
CAD_DS_TEXT_ALIGN = 4;
CAD_DS_TEXT_HOR = 8;
CAD_DS_UNIT_SCIENTIFIC = 1;
CAD_DS_UNIT_DECIMAL = 2;
CAD_DS_UNIT_ENGINEER = 3;
CAD_DS_UNIT_DEGREE = 10;
CAD_DS_UNIT_DEGMINSEC = 11;
CAD_DS_UNIT_GRAD = 12;
CAD_DS_UNIT_RADIAN = 13;
CAD_DECSEP_POINT = 0;
CAD_DECSEP_COMMA = 1;
CAD_DECSEP_NONE = 2;
CAD_ARROW_CLOSEDF = 0;
CAD_ARROW_CLOSEDB = 1;
CAD_ARROW_CLOSED = 2;
CAD_ARROW_DOT = 3;
CAD_ARROW_ARCHTICK = 4;
CAD_ARROW_OBLIQUE = 5;
CAD_ARROW_OPEN = 6;
CAD_ARROW_ORIGIN = 7;
CAD_ARROW_ORIGIN2 = 8;
CAD_ARROW_OPEN90 = 9;
CAD_ARROW_OPEN30 = 10;
CAD_ARROW_DOTSMALL = 11;
CAD_ARROW_DOTB = 12;
CAD_ARROW_DOTSMALLB = 13;
CAD_ARROW_BOX = 14;
CAD_ARROW_BOXF = 15;
CAD_ARROW_DATUM = 16;
CAD_ARROW_DATUMF = 17;
CAD_ARROW_INTEGRAL = 18;
CAD_ARROW_NONE = 19;
CAD_CURSOR_ARROW = 2000777001;
CAD_CURSOR_HELP = 2000777002;
CAD_CURSOR_WAIT = 2000777003;
CAD_CURSOR_APPSTART = 2000777004;
CAD_CURSOR_UPARROW = 2000777005;
CAD_CURSOR_NO = 2000777006;
CAD_CURSOR_CROSS = 2000777007;
CAD_CURSOR_HAND = 2000777008;
CAD_CMD_ZOOM_EXT = 102;
CAD_CMD_ZOOM_IN = 103;
CAD_CMD_ZOOM_OUT = 104;
CAD_CMD_ZOOM_PREV = 105;
CAD_CMD_ZOOM_WIN = 106;
CAD_CMD_ZOOM_RTIME = 107;
CAD_CMD_ZOOM_SEL = 108;
CAD_CMD_PAN_RTIME = 111;
CAD_CMD_PAN_POINT = 112;
CAD_CMD_PAN_LEFT = 113;
CAD_CMD_PAN_RIGHT = 114;
CAD_CMD_PAN_UP = 115;
CAD_CMD_PAN_DOWN = 116;
CAD_CMD_PAGE_NEXT = 121;
CAD_CMD_PAGE_PREV = 122;
CAD_CMD_PAGE_FIRST = 123;
CAD_CMD_PAGE_LAST = 124;
CAD_CMD_PAGE_SELECT = 125;
CAD_CMD_VIEW_TOP = 131;
CAD_CMD_VIEW_BOTTOM = 132;
CAD_CMD_VIEW_LEFT = 133;
CAD_CMD_VIEW_RIGHT = 134;
CAD_CMD_VIEW_FRONT = 135;
CAD_CMD_VIEW_BACK = 136;
CAD_CMD_VIEW_SW = 137;
CAD_CMD_VIEW_SE = 138;
CAD_CMD_VIEW_NE = 139;
CAD_CMD_VIEW_NW = 130;
CAD_CMD_VIEW_VPOINT = 141;
CAD_CMD_SW_VIEW_CURLAYER = 142;
CAD_CMD_SW_MAGNIFIER = 143;
CAD_CMD_MBUTTONPAN = 144;
CAD_CMD_IDFIX = 145;
CAD_CMD_DRAW_POINT = 201;
CAD_CMD_DRAW_LINE = 205;
CAD_CMD_DRAW_RAY = 206;
CAD_CMD_DRAW_XLINE = 207;
CAD_CMD_DRAW_MLINE = 208;
CAD_CMD_DRAW_POLYLINE = 209;
CAD_CMD_DRAW_POLYGON = 210;
CAD_CMD_DRAW_ELLIPSE = 211;
CAD_CMD_DRAW_RECT = 212;
CAD_CMD_DRAW_CIRCLE = 220;
CAD_CMD_DRAW_CIRC_CR = 221;
CAD_CMD_DRAW_CIRC_CD = 222;
CAD_CMD_DRAW_CIRC_2P = 223;
CAD_CMD_DRAW_CIRC_3P = 224;
CAD_CMD_DRAW_ARC3P = 227;
CAD_CMD_DRAW_ARC = 228;
CAD_CMD_DRAW_ARC_3P = 229;
CAD_CMD_DRAW_ARC_SCE = 230;
CAD_CMD_DRAW_ARC_SCA = 231;
CAD_CMD_DRAW_ARC_SCL = 232;
CAD_CMD_DRAW_ARC_SEA = 233;
CAD_CMD_DRAW_ARC_SED = 234;
CAD_CMD_DRAW_ARC_SER = 235;
CAD_CMD_DRAW_ARC_CSE = 236;
CAD_CMD_DRAW_ARC_CSA = 237;
CAD_CMD_DRAW_ARC_CSL = 238;
CAD_CMD_DRAW_ARC_CONT = 239;
CAD_CMD_DRAW_SPLINE = 242;
CAD_CMD_DRAW_TEXT = 245;
CAD_CMD_DRAW_HATCH = 246;
CAD_CMD_DRAW_LEADER = 247;
CAD_CMD_DRAW_CENMARK = 248;
CAD_CMD_DRAW_MTEXT = 249;
CAD_CMD_DRAW_WTEXT = 250;
CAD_CMD_INSERT_BLOCK = 252;
CAD_CMD_INSERT_IMAGE = 253;
CAD_CMD_INSERT_XREF = 254;
CAD_CMD_IMAGE_MANAGER = 255;
CAD_CMD_XREF_MANAGER = 256;
CAD_CMD_CREATE_BLOCK = 257;
CAD_CMD_CREATE_ATTRIB = 258;
CAD_CMD_PLINE_ENTER = 261;
CAD_CMD_PLINE_CLOSE = 262;
CAD_CMD_PLINE_POLYGON = 263;
CAD_CMD_PLINE_CANCEL = 264;
CAD_CMD_PLINE_UNDO = 265;
CAD_CMD_PLINE_ARC = 266;
CAD_CMD_PLINE_LINE = 267;
CAD_CMD_SPLINE_ENTER = 271;
CAD_CMD_SPLINE_CLOSE = 272;
CAD_CMD_SPLINE_POLYGON = 273;
CAD_CMD_SPLINE_CANCEL = 274;
CAD_CMD_SPLINE_UNDO = 275;
CAD_CMD_MLINE_ENTER = 281;
CAD_CMD_MLINE_CLOSE = 282;
CAD_CMD_MLINE_CANCEL = 283;
CAD_CMD_MLINE_UNDO = 284;
CAD_CMD_DRAW_DIM_LIN = 290;
CAD_CMD_DRAW_DIM_ALIGN = 291;
CAD_CMD_DRAW_DIM_ORD = 292;
CAD_CMD_DRAW_DIM_RAD = 293;
CAD_CMD_DRAW_DIM_DIAM = 294;
CAD_CMD_DRAW_DIM_ANG = 295;
CAD_CMD_UNDO = 301;
CAD_CMD_REDO = 302;
CAD_CMD_CBCUT = 303;
CAD_CMD_CBCOPY = 304;
CAD_CMD_CBPASTE = 305;
CAD_CMD_ENTPROP = 306;
CAD_CMD_ERASE = 311;
CAD_CMD_COPY = 312;
CAD_CMD_MOVE = 313;
CAD_CMD_ROTATE = 314;
CAD_CMD_SCALE = 315;
CAD_CMD_MIRROR = 316;
CAD_CMD_EXPLODE = 317;
CAD_CMD_JOIN = 318;
CAD_CMD_TRIM = 319;
CAD_CMD_EXTEND = 320;
CAD_CMD_ATTEDIT = 321;
CAD_CMD_ATTMAN = 322;
CAD_CMD_DEP = 323;
CAD_CMD_PLINE_INSVER = 331;
CAD_CMD_PLINE_DELVER = 332;
CAD_CMD_PLINE_EDITVER = 333;
CAD_CMD_PLINE_CONTINUE = 334;
CAD_CMD_PROF_INSVER = 341;
CAD_CMD_PROF_DELVER = 342;
CAD_CMD_PROF_EDITVER = 343;
CAD_CMD_SNAP_POINT = 401;
CAD_CMD_SNAP_NODE = 401;
CAD_CMD_SNAP_ENDPOINT = 402;
CAD_CMD_SNAP_MIDPOINT = 403;
CAD_CMD_SNAP_CENTER = 404;
CAD_CMD_SNAP_NEAREST = 405;
CAD_CMD_SNAP_INTER = 406;
CAD_CMD_SNAP_PERPEND = 407;
CAD_CMD_SNAP_TANGENT = 408;
CAD_CMD_SNAP_GRIP = 409;
CAD_CMD_SNAP_NONE = 410;
CAD_CMD_SNAP_DLG = 411;
CAD_CMD_SW_SHOWGRID = 421;
CAD_CMD_SW_SNAPGRID = 422;
CAD_CMD_SW_OSNAPON = 423;
CAD_CMD_GRID_DLG = 425;
CAD_CMD_POLAR_DLG = 426;
CAD_CMD_SW_POLARON = 427;
CAD_CMD_SEL_BYPOINT = 501;
CAD_CMD_SEL_BYRECT = 502;
CAD_CMD_SEL_BYPOLYGON = 503;
CAD_CMD_SEL_BYPOLYLINE = 504;
CAD_CMD_SEL_BYDIST = 505;
CAD_CMD_SEL_BYID = 507;
CAD_CMD_SEL_BYHANDLER = 507;
CAD_CMD_SEL_BYLAYER = 508;
CAD_CMD_SEL_BYTEXT = 509;
CAD_CMD_SEL_BYKEY = 510;
CAD_CMD_SEL_BYUSERDATA = 510;
CAD_CMD_LAYER = 801;
CAD_CMD_LAYERS_ORDER = 802;
CAD_CMD_COLOR = 803;
CAD_CMD_LINETYPE = 804;
CAD_CMD_LINEWEIGHT = 805;
CAD_CMD_TEXTSTYLE = 806;
CAD_CMD_DIMSTYLE = 807;
CAD_CMD_PNTSTYLE = 808;
CAD_CMD_MLINESTYLE = 809;
CAD_CMD_PAGE = 810;
CAD_CMD_BLOCK = 811;
CAD_CMD_SW_LINEWEIGHT = 812;
CAD_CMD_SW_RASTER = 813;
CAD_CMD_PRINT = 901;
CAD_CMD_PRINT_NODIALOG = 902;
CAD_CMD_PRINTPREVIEW = 903;
CAD_CMD_PRINTPREVIEW_END = 904;
CAD_CMD_RESET = 911;
CAD_CMD_REGEN = 912;
CAD_CMD_REPEAT = 913;
CAD_CMD_SETFOCUS = 914;
CAD_CMD_SETVAR = 915;
CAD_CMD_HELP = 918;
CAD_CMD_F3 = 921;
CAD_CMD_EXPORT_AVSHP = 931;
CAD_CMD_IMPORT_AVSHP = 941;
CAD_CMD_RASTERIZE = 942;
CAD_CMD_OPTIONS = 951;
CAD_CMD_DISTANCE = 952;
CAD_CMD_AREA = 953;
CAD_CMD_CALIBRATE = 954;
CAD_CMD_DWGINFO = 955;
CAD_CMD_DRAFT_AIDS = 956;
CAD_CMD_LATLONG = 962;
CAD_CMD_AREAIP = 963;
CAD_CMD_DISTPLINE = 964;
CAD_CMD_CUSTOM = 11000;
CAD_CCS_LBUTTON = 1;
CAD_CCS_RBUTTON = 2;
CAD_CCS_STRING = 3;
CAD_CCS_ESCAPE = 4;
CAD_MENU_PRINTPREVIEW = 1;
CAD_MENU_EDIT = 2;
CAD_MENU_DEFAULT = 3;
CAD_MENU_POLYLINE = 4;
CAD_MENU_SPLINE = 5;
CAD_MENU_MLINE = 6;
CAD_MENU_PLINEEDIT = 7;
CAD_MENU_SNAP = 8;
CAD_MENU_PROFEDIT = 9;
CAD_RM_BOTH = 0;
CAD_RM_VECTOR = 1;
CAD_RM_RASTER = 2;
CAD_RM_MAX = 2;
CAD_PS_DRAW_NONE = 0;
CAD_PS_DRAW_BLOCK = 1;
CAD_PS_DRAW_TEXT = 2;
CAD_PS_DRAW_ALL = 3;
CAD_PNT_PIXEL = 0;
CAD_PNT_NONE = 1;
CAD_PNT_PLUS = 2;
CAD_PNT_X = 3;
CAD_PNT_TICK = 4;
CAD_PNT_CIRCLE = 32;
CAD_PNT_SQUARE = 64;
CAD_PLANE_XY = 0;
CAD_PLANE_TOP = 0;
CAD_PLANE_XZ = 1;
CAD_PLANE_FRONT = 1;
CAD_PLANE_YZ = 2;
CAD_PLANE_RIGHT = 2;
CAD_LBUTTON = 1;
CAD_RBUTTON = 2;
CAD_MBUTTON = 4;
CAD_SHIFT = 1;
CAD_CTRL = 2;
CAD_ALT = 4;
CAD_ACAD25 = 0;
CAD_ACAD26 = 1;
CAD_ACAD9 = 2;
CAD_ACAD10 = 3;
CAD_ACAD11 = 4;
CAD_ACAD13 = 5;
CAD_ACAD14 = 6;
CAD_ACAD2000 = 7;
CAD_ACAD2004 = 8;
CAD_ACAD2007 = 9;
CAD_ACADMAX = 9;
CAD_FILTER_VEC = 0;
CAD_FILTER_DWGDXF = 1;
CAD_FILTER_DWG = 2;
CAD_FILTER_DXF = 3;
CAD_FILTER_SFP = 4;
CAD_CLEAR_ALL = 0;
CAD_CLEAR_ENTITIES = 1;
CAD_CLEAR_LAYER = 2;
CAD_CLEAR_DELETED = 3;
CAD_CLEAR_SELECTED = 4;
CAD_CLEAR_PAGE = 5;
CAD_WS_HSCROLL = 1;
CAD_WS_VSCROLL = 2;
CAD_WS_BORDER = 4;
CAD_WS_SUNKEN = 8;
CAD_WS_DEFAULT = 3;
CAD_PST_LEFTOP = 0;
CAD_PST_CENTOP = 1;
CAD_PST_RIGTOP = 2;
CAD_PST_LEFBOT = 3;
CAD_PST_CENBOT = 4;
CAD_PST_RIGBOT = 5;
CAD_PST_LEFTOP90 = 6;
CAD_PST_LEFCEN90 = 7;
CAD_PST_LEFBOT90 = 8;
CAD_PST_RIGTOP90 = 9;
CAD_PST_RIGCEN90 = 10;
CAD_PST_RIGBOT90 = 11;
CAD_CP_1250 = 1;
CAD_CP_1251 = 2;
CAD_CP_1252 = 3;
CAD_CP_1253 = 4;
CAD_CP_1254 = 5;
CAD_CP_1255 = 6;
CAD_CP_1256 = 7;
CAD_CP_1257 = 8;
CAD_CP_874 = 9;
CAD_CP_932 = 101;
CAD_CP_936 = 102;
CAD_CP_949 = 103;
CAD_CP_950 = 104;
CAD_MLS_SHOW_MITERS = 2;
CAD_MLS_START_SQUARE = 16;
CAD_MLS_START_ROUND = 64;
CAD_MLS_END_SQUARE = 256;
CAD_MLS_END_ROUND = 1024;
CAD_MLINE_JUST_TOP = 0;
CAD_MLINE_JUST_ZERO = 1;
CAD_MLINE_JUST_BOTTOM = 2;
CAD_ERROR_INVALID_ID = 1;
CAD_ERROR_ONE_PAGE = 101;
CAD_ERROR_PAGE_NOT_EMPTY = 102;
CAD_ERROR_DEL_LAYER0 = 111;
CAD_ERROR_DEL_CURLAYER = 112;
CAD_ERROR_LAYER_NOT_EMPTY = 113;
CAD_ERROR_DEL_DIMSSTD = 121;
CAD_ERROR_DEL_DIMSREF = 122;
CAD_ERROR_DEL_LTYPESTD = 131;
CAD_ERROR_DEL_LTYPEREF = 132;
CAD_ERROR_DEL_TXTSSTD = 141;
CAD_ERROR_DEL_TXTSREF = 142;
CAD_ERROR_DEL_PNTSSTD = 151;
CAD_ERROR_DEL_PNTSREF = 152;
CAD_ERROR_DEL_MLSSTD = 161;
CAD_ERROR_DEL_MLSREF = 162;
CAD_ERROR_DEL_BLKREF = 163;
CAD_GRID_POINT = 0;
CAD_GRID_LINE = 1;
CAD_GRID_DOTLINE = 2;
CAD_GRID_BELOW = 0;
CAD_GRID_ABOVE = 1;
CAD_SNAP_POINT = 1;
CAD_SNAP_NODE = 1;
CAD_SNAP_ENDPOINT = 2;
CAD_SNAP_MIDPOINT = 4;
CAD_SNAP_CENTER = 8;
CAD_SNAP_NEAREST = 16;
CAD_SNAP_INTER = 32;
CAD_SNAP_PERPEND = 64;
CAD_SNAP_TANGENT = 128;
CAD_SNAP_GRIP = 256;
CAD_SNAP_ALL = 511;
CAD_SNAP_POLAR = 1000;
CAD_SNAP_IPOLAR = 1001;
CAD_POLAR_90 = 0;
CAD_POLAR_45 = 1;
CAD_POLAR_30 = 2;
CAD_POLAR_23 = 3;
CAD_POLAR_18 = 4;
CAD_POLAR_15 = 5;
CAD_POLAR_10 = 6;
CAD_POLAR_5 = 7;
CAD_ANGLE_DEGREE = 0;
CAD_ANGLE_RADIAN = 3;
CAD_ANGLE_GRAD = 4;
CAD_CBOX_LAYER = 101;
CAD_CBOX_COLOR = 102;
CAD_CBOX_LINETYPE = 103;
CAD_CBOX_LWEIGHT = 104;
CAD_CBOX_DIMSTYLE = 105;
CAD_MAG_LEFBOT = 0;
CAD_MAG_LEFTOP = 1;
CAD_MAG_RIGBOT = 2;
CAD_MAG_RIGTOP = 3;
CAD_NAV_LEFT = 0;
CAD_NAV_TOP = 1;
CAD_NAV_WIDTH = 2;
CAD_NAV_HEIGHT = 3;
CAD_NAV_EXIST = 4;
CAD_NAV_CHILD = 256;
CAD_NAV_SUNKEN = 512;
CAD_NAV_CPANEL = 1024;
CAD_CE_CLEARVERS = 0;
CAD_CE_KEEPVERS = 1;
CAD_CE_BRUSH = 2;
CAD_CE_COLOR = 3;
CAD_PROP_VALUE = 1;
CAD_PROP_YESNO = 2;
CAD_PROP_LIST = 3;
CAD_PROP_SEPARATOR = 4;
CAD_PROP_READONLY = 256;
CAD_XREF_NOXREF = 0;
CAD_XREF_LOADED = 1;
CAD_XREF_NOTLOADED = 2;
CAD_XREF_NOTFOUND = 3;
STR_VECAD = 1;
STR_VECAD_PRINT = 3;
STR_FILTER_VDFILE = 9;
STR_VEC_EXT = 10;
STR_FILTER_VEC = 11;
STR_OLD_VEC_FORMAT = 101;
STR_UNKNOWN_VEC_FORMAT = 102;
STR_NEWER_VEC_FORMAT = 103;
STR_NEWFILENAME = 104;
STR_SAVE_CHANGES = 105;
STR_SAVE_AS = 106;
STR_UNDO_EMPTY = 107;
STR_REDO_EMPTY = 108;
STR_DID_YOU_KNOW = 109;
STR_NO_TIP_FILE = 110;
STR_NO_TIPS = 111;
STR_REGEN = 112;
STR_YES = 113;
STR_NO = 114;
STR_REWRITE_FILE = 115;
STR_NO_BLOCKS = 116;
STR_INVALID_LATITUDE = 117;
STR_INVALID_LONGITUDE = 118;
STR_BULGE_TITLE = 121;
STR_BULGE_PROMPT = 122;
STR_SELECT_OBJECT = 123;
STR_N_ENT_SELECTED = 124;
STR_ENTER_HANDLER = 125;
STR_ENTER_USERDATA = 126;
STR_ENTER_TEXT = 127;
STR_LAYERS_ORDER = 128;
STR_CANT_OPEN_FILE = 131;
STR_CANT_LOAD_FILE = 132;
STR_IS_BIGFONT = 133;
STR_ISNOT_BIGFONT = 134;
STR_UNDEFINED = 135;
STR_UNKNOWN = 136;
STR_SHX_UNDEFINED = 137;
STR_VCF_FILEEXIST = 138;
STR_VCF_CREATED = 139;
STR_VCF_REPLFONT1 = 140;
STR_VCF_REPLFONT2 = 141;
STR_VCF_REPL_TSTYLE = 142;
STR_VCF_REPL_PSTYLE = 143;
STR_UNITS_METERS = 151;
STR_UNITS_DEGREES = 152;
STR_UNITS_FEET = 153;
STR_SELECT_ENTITIES = 301;
STR_SELECTION = 302;
STR_PICK_ENTITY = 303;
STR_NOT_LATLONG_ENTITY = 304;
STR_MENU_EXIT = 401;
STR_MENU_PRINT = 402;
STR_MENU_ZOOMEXT = 403;
STR_MENU_ZOOMRT = 404;
STR_MENU_PANRT = 405;
STR_MENU_UNSELALL = 406;
STR_MENU_PROPS = 407;
STR_MENU_COPY = 408;
STR_MENU_MOVE = 409;
STR_MENU_ROTATE = 410;
STR_MENU_SCALE = 411;
STR_MENU_MIRROR = 412;
STR_MENU_EXPLODE = 413;
STR_MENU_JOIN = 414;
STR_MENU_ERASE = 415;
STR_MENU_CREBLOCK = 416;
STR_MENU_REPEAT = 417;
STR_MENU_ZOOMWIN = 418;
STR_MENU_ZOOMPREV = 419;
STR_MENU_UNDO = 420;
STR_MENU_REDO = 421;
STR_MENU_AIDS = 422;
STR_MENU_OPTIONS = 423;
STR_MENU_ENTER = 424;
STR_MENU_CLOSED = 425;
STR_MENU_POLYGON = 426;
STR_MENU_LINE = 427;
STR_MENU_ARC = 428;
STR_MENU_CANCEL = 430;
STR_MENU_INSVER = 431;
STR_MENU_DELVER = 432;
STR_MENU_EDITVER = 433;
STR_MENU_MAGNIFIER = 434;
STR_MENU_CONTINUE = 435;
STR_MENU_SNAP_ENDPOINT = 441;
STR_MENU_SNAP_MIDPOINT = 442;
STR_MENU_SNAP_CENTER = 443;
STR_MENU_SNAP_NEAREST = 444;
STR_MENU_SNAP_INTER = 445;
STR_MENU_SNAP_PERPEND = 446;
STR_MENU_SNAP_TANGENT = 447;
STR_MENU_SNAP_GRIP = 448;
STR_MENU_SNAP_POINT = 449;
STR_MENU_SNAP_DLG = 451;
STR_MENU_POLAR_DLG = 452;
STR_NAV_TITLE = 501;
STR_NAV_IN = 502;
STR_NAV_OUT = 503;
STR_PRINT_ALBUM = 27151;
STR_PRINT_BOOK = 27152;
STR_PRINT_INCH = 27153;
STR_PRINT_MM = 27154;
STR_PRINT_PREVIEW = 27155;
STR_PST_LEFTOP = 27161;
STR_PST_CENTOP = 27162;
STR_PST_RIGTOP = 27163;
STR_PST_LEFBOT = 27164;
STR_PST_CENBOT = 27165;
STR_PST_RIGBOT = 27166;
STR_PST_LEFTOP90 = 27167;
STR_PST_LEFCEN90 = 27168;
STR_PST_LEFBOT90 = 27169;
STR_PST_RIGTOP90 = 27170;
STR_PST_RIGCEN90 = 27171;
STR_PST_RIGBOT90 = 27172;
STR_NO_EFF_RECT = 27182;
STR_CREATE_PREVIEW = 27183;
STR_PAPERSIZE = 27184;
STR_SCALE = 27185;
STR_BYLAYER = 27203;
STR_BYBLOCK = 27204;
STR_DEFAULT = 27205;
STR_WARNING = 27207;
STR_DELETE_TEXT_STYLE = 27210;
STR_NEW_TEXT_STYLE = 27211;
STR_RENAME_TEXT_STYLE = 27212;
STR_STYLE_NAME = 27213;
STR_STYLE_NAME_EXIST = 27214;
STR_OPT_TITLE = 27301;
STR_OPT_DISPLAY = 27302;
STR_OPT_EXPORT = 27303;
STR_OPT_SELECTION = 27304;
STR_OPT_USERPREF = 27305;
STR_OPT_PROFILES = 27306;
STR_OPT_DRAFTING = 27307;
STR_OPT_PLUGINS = 27308;
STR_OPT_ACADVER2007 = 27319;
STR_OPT_ACADVER2004 = 27320;
STR_OPT_ACADVER2000 = 27321;
STR_OPT_ACADVER14 = 27322;
STR_OPT_ACADVER13 = 27323;
STR_OPT_ACADVER11 = 27324;
STR_OPT_ACADVER10 = 27325;
STR_OPT_ACADVER9 = 27326;
STR_OPT_ACADVER26 = 27327;
STR_OPT_ACADVER25 = 27328;
STR_PRF_ADD = 27331;
STR_PRF_RENAME = 27332;
STR_PRF_NAMEEXIST = 27333;
STR_SEL_SOLID = 27341;
STR_SEL_DASH = 27342;
STR_SEL_DOT = 27343;
STR_LAYER_0 = 27400;
STR_LAY_HDRNAME = 27401;
STR_LAY_HDRON = 27402;
STR_LAY_HDRLOCK = 27403;
STR_LAY_HDRCOLOR = 27404;
STR_LAY_HDRLTYPE = 27405;
STR_LAY_HDRLWEIGHT = 27406;
STR_LAY_HDRPRINT = 27407;
STR_LAY_CURRENT = 27411;
STR_LAY_STATUS = 27412;
STR_LAY_SHOW_ALL = 27415;
STR_LAY_SHOW_USED = 27416;
STR_LAY_SHOW_UNUSED = 27417;
STR_LT_HDRNAME = 27431;
STR_LT_HDRAPPEAR = 27432;
STR_LT_HDRDESC = 27433;
STR_LT_CURRENT = 27434;
STR_LT_SHOW_ALL = 27435;
STR_LT_SHOW_USED = 27436;
STR_LT_SHOW_UNUSED = 27437;
STR_LT_EXIST = 27438;
STR_LT_CONTINUOUS = 27441;
STR_IMG_HDRNAME = 27451;
STR_IMG_HDRSTATUS = 27452;
STR_IMG_HDRREF = 27453;
STR_IMG_HDRSIZE = 27454;
STR_IMG_HDRTYPE = 27455;
STR_IMG_HDRDATE = 27456;
STR_IMG_HDRPATH = 27457;
STR_IMG_LOADED = 27458;
STR_IMG_UNREF = 27459;
STR_IMG_NOTFOUND = 27460;
STR_IMG_UNLOADED = 27461;
STR_BLK_NSEL = 27465;
STR_BLK_NSEL0 = 27466;
STR_BLK_NONAME = 27468;
STR_BLK_NOTHING = 27469;
STR_BLK_EXIST = 27470;
STR_BLK_SELFREF = 27471;
STR_BLK_DRAWING = 27475;
STR_BLK_RENAME = 27476;
STR_BLK_NEWNAME = 27477;
STR_BLK_DUPNAME = 27478;
STR_BLK_NUMDELETED = 27479;
STR_PS_HDR_NAME = 27481;
STR_PS_HDR_STATE = 27482;
STR_PS_HDR_BLOCK = 27483;
STR_PS_HDR_SCALE = 27484;
STR_PS_HDR_FONT = 27485;
STR_PS_HDR_HEIGHT = 27486;
STR_PS_HDR_WIDTH = 27487;
STR_PS_HDR_SNAP = 27488;
STR_PS_HDR_MOVE = 27489;
STR_PS_SHOW_ALL = 27491;
STR_PS_SHOW_USED = 27492;
STR_PS_SHOW_UNUSED = 27493;
STR_PS_CURRENT = 27495;
STR_PS_DRAW_NONE = 27501;
STR_PS_DRAW_SYMBOL = 27502;
STR_PS_DRAW_TEXT = 27503;
STR_PS_DRAW_ALL = 27504;
STR_PS_SIMPLE = 27511;
STR_PS_PDMODE_POINT = 27514;
STR_PS_PDMODE_PLUS = 27515;
STR_PS_PDMODE_X = 27516;
STR_PS_PDMODE_TICK = 27517;
STR_PS_PDMODE_CIRCLE = 27518;
STR_PS_PDMODE_RECT = 27519;
STR_TSTYLE_STANDARD = 27531;
STR_PAGE_MODEL = 27535;
STR_MLS_STANDARD = 27541;
STR_MLS_TOP = 27543;
STR_MLS_CENTER = 27544;
STR_MLS_BOTTOM = 27545;
STR_MLS_OFF_TITLE = 27546;
STR_MLS_OFF_PROMPT = 27547;
STR_DIMS_STANDARD = 27561;
STR_DIMS_NONE = 27562;
STR_DIMS_MARK = 27563;
STR_DIMS_LINE = 27564;
STR_DIMS_ARR_0 = 27570;
STR_DIMS_ARR_1 = 27571;
STR_DIMS_ARR_2 = 27572;
STR_DIMS_ARR_3 = 27573;
STR_DIMS_ARR_4 = 27574;
STR_DIMS_ARR_5 = 27575;
STR_DIMS_ARR_6 = 27576;
STR_DIMS_ARR_7 = 27577;
STR_DIMS_ARR_8 = 27578;
STR_DIMS_ARR_9 = 27579;
STR_DIMS_ARR_10 = 27580;
STR_DIMS_ARR_11 = 27581;
STR_DIMS_ARR_12 = 27582;
STR_DIMS_ARR_13 = 27583;
STR_DIMS_ARR_14 = 27584;
STR_DIMS_ARR_15 = 27585;
STR_DIMS_ARR_16 = 27586;
STR_DIMS_ARR_17 = 27587;
STR_DIMS_ARR_18 = 27588;
STR_DIMS_ARR_19 = 27589;
STR_DIMS_SCIENTIFIC = 27600;
STR_DIMS_DECIMAL = 27601;
STR_DIMS_ENGINEER = 27602;
STR_DIMS_ARCHITEC = 27603;
STR_DIMS_FRACTION = 27604;
STR_DIMS_DECDEGREE = 27610;
STR_DIMS_DEGMINSEC = 27611;
STR_DIMS_GRAD = 27612;
STR_DIMS_RADIAN = 27613;
STR_DIMS_CENTERED = 27615;
STR_DIMS_ABOVE = 27616;
STR_DIMS_HORIZ = 27621;
STR_DIMS_ALIGNED = 27622;
STR_DIMS_ISOSTD = 27623;
STR_DIMS_PERIOD = 27631;
STR_DIMS_COMMA = 27632;
STR_DIMS_SPACE = 27633;
STR_PROP_TITLE = 28481;
STR_PROP_NOFILE = 28482;
STR_PROP_NOSEL = 28483;
STR_PROP_ALL = 28485;
STR_PROP_POINT = 28501;
STR_PROP_LINE = 28502;
STR_PROP_POLYLINE = 28503;
STR_PROP_CIRCLE = 28504;
STR_PROP_ARC = 28505;
STR_PROP_ELLIPSE = 28506;
STR_PROP_TEXT = 28507;
STR_PROP_INSBLOCK = 28508;
STR_PROP_SHAPE = 28509;
STR_PROP_3DFACE = 28510;
STR_PROP_SOLID = 28511;
STR_PROP_IMAGE = 28512;
STR_PROP_DIM = 28513;
STR_PROP_HATCH = 28514;
STR_PROP_LEADER = 28515;
STR_PROP_MLINE = 28516;
STR_PROP_3DMESH = 28517;
STR_PROP_POLYFACE = 28518;
STR_PROP_XLINE = 28519;
STR_PROP_RAY = 28520;
STR_PROP_XREF = 28521;
STR_PROP_VPORT = 28522;
STR_PROP_ATTRIB = 28523;
STR_PROP_RECT = 28524;
STR_PROP_MTEXT = 28525;
STR_PROP_WINTEXT = 28526;
STR_PROP_CUSTOM = 28529;
STR_PROP_EXTENTS = 28531;
STR_PROP_XMIN = 28532;
STR_PROP_YMIN = 28533;
STR_PROP_ZMIN = 28534;
STR_PROP_XMAX = 28535;
STR_PROP_YMAX = 28536;
STR_PROP_ZMAX = 28537;
STR_PROP_VIEW = 28538;
STR_PROP_XCEN = 28539;
STR_PROP_YCEN = 28540;
STR_PROP_ZCEN = 28541;
STR_PROP_WIDTH = 28542;
STR_PROP_HEIGHT = 28543;
STR_PROP_GENERAL = 28601;
STR_PROP_HANDLER = 28602;
STR_PROP_COLOR = 28603;
STR_PROP_LAYER = 28604;
STR_PROP_LINETYPE = 28605;
STR_PROP_LTSCALE = 28606;
STR_PROP_LWEIGHT = 28607;
STR_PROP_TEXTSTYLE = 28608;
STR_PROP_PNTSTYLE = 28609;
STR_PROP_MLINESTYLE = 28610;
STR_PROP_DIMSTYLE = 28611;
STR_PROP_FILLED = 28615;
STR_PROP_BORDER = 28616;
STR_PROP_USERDATA = 28617;
STR_PROP_BCOLOR = 28618;
STR_PROP_GEOMETRY = 28651;
STR_PROP_STARTX = 28652;
STR_PROP_STARTY = 28653;
STR_PROP_STARTZ = 28654;
STR_PROP_ENDX = 28655;
STR_PROP_ENDY = 28656;
STR_PROP_ENDZ = 28657;
STR_PROP_DX = 28658;
STR_PROP_DY = 28659;
STR_PROP_DZ = 28660;
STR_PROP_LENGTH = 28661;
STR_PROP_AREA = 28662;
STR_PROP_ANGLE = 28663;
STR_PROP_RADIUS = 28664;
STR_PROP_RAD_H = 28665;
STR_PROP_RAD_V = 28666;
STR_PROP_ANG_START = 28667;
STR_PROP_ANG_ARC = 28668;
STR_PROP_ANG_ROT = 28669;
STR_PROP_SECTOR = 28670;
STR_PROP_CONTENTS = 28677;
STR_PROP_STYLE = 28678;
STR_PROP_ALIGNMENT = 28679;
STR_PROP_ROTANG = 28681;
STR_PROP_WIDFACTOR = 28682;
STR_PROP_OBLIQUE = 28683;
STR_PROP_POSX = 28684;
STR_PROP_POSY = 28685;
STR_PROP_POSZ = 28686;
STR_PROP_UPSIDEDOWN = 28687;
STR_PROP_BACKWARD = 28688;
STR_PROP_HOLLOW = 28689;
STR_PROP_SCALE = 28690;
STR_PROP_SCALEX = 28691;
STR_PROP_SCALEY = 28692;
STR_PROP_SCALEZ = 28693;
STR_PROP_IMGSCALEX = 28694;
STR_PROP_IMGSCALEY = 28695;
STR_PROP_IMGSCALEX2 = 28696;
STR_PROP_IMGSCALEY2 = 28697;
STR_PROP_NAME = 28698;
STR_PROP_PATH = 28699;
STR_PROP_BLKANGLE = 28701;
STR_PROP_TEXTANGLE = 28702;
STR_PROP_TEXTDX = 28703;
STR_PROP_TEXTDY = 28704;
STR_PROP_FIXED = 28705;
STR_PROP_DUPLICATE = 28708;
STR_PROP_BLOCKNAME = 28709;
STR_PROP_COLUMNS = 28710;
STR_PROP_COLDIST = 28711;
STR_PROP_ROWS = 28712;
STR_PROP_ROWDIST = 28713;
STR_PROP_CLOSED = 28714;
STR_PROP_NVERS = 28715;
STR_PROP_FITTYPE = 28716;
STR_PROP_STARTVECX = 28717;
STR_PROP_STARTVECY = 28718;
STR_PROP_STARTVECZ = 28719;
STR_PROP_ENDVECX = 28720;
STR_PROP_ENDVECY = 28721;
STR_PROP_ENDVECZ = 28722;
STR_PROP_GWIDTH = 28723;
STR_PROP_GZ = 28724;
STR_PROP_BASEX = 28725;
STR_PROP_BASEY = 28726;
STR_PROP_BASEZ = 28727;
STR_PROP_DIRX = 28728;
STR_PROP_DIRY = 28729;
STR_PROP_DIRZ = 28730;
STR_PROP_JUST = 28731;
STR_PROP_PATNAME = 28732;
STR_PROP_POSLEF = 28735;
STR_PROP_POSTOP = 28736;
STR_PROP_POSRIG = 28737;
STR_PROP_POSBOT = 28738;
STR_PROP_PIXW = 28739;
STR_PROP_PIXH = 28740;
STR_PROP_COMPRATE = 28741;
STR_PROP_NBANDS = 28742;
STR_PROP_DATUM = 28743;
STR_PROP_PROJECTION = 28744;
STR_PROP_UNITS = 28745;
STR_PROP_MEASUREMENT = 28751;
STR_PROP_TEXTOVER = 28752;
STR_PROP_SPLINE = 28753;
STR_PROP_ANNOTATION = 28754;
STR_PROP_TAG = 28761;
STR_PROP_PROMPT = 28762;
STR_PROP_DEFVALUE = 28763;
STR_PROP_ATTRIBUTES = 28764;
STR_PROP_TEXTDZ = 28771;
STR_PROP_LINESPACE = 28772;
STR_PROP_MIDX = 28781;
STR_PROP_MIDY = 28782;
STR_PROP_MIDZ = 28783;
STR_PROP_ARC3P = 28785;
STR_PROP_DSTYLE = 28786;
STR_PROP_TSTYLE = 28787;
STR_PROP_DCOLOR = 28788;
STR_PROP_ARSIZE = 28789;
STR_PROP_DIMGAP = 28790;
STR_PROP_THEIGHT = 28791;
STR_PROP_VISIBLE = 28792;
STR_PROP_ITALIC = 28793;
STR_PROP_STRIKEOUT = 28794;
STR_PROP_UNDERLINE = 28795;
STR_PROP_TTFONT = 28796;
STR_PROP_TRANSP = 28797;
STR_PROP_RGBCOLOR = 28798;
STR_PROP_CODE = 28801;
STR_PROP_RPLAN_AREA = 28901;
STR_PROP_RPLAN_IZO = 28902;
STR_PROP_RPLAN_IZB = 28903;
STR_PROP_RPLAN_ROAD = 28904;
STR_PROP_RPLAN_GPT = 28905;
STR_PROP_RPROF_HSCALE = 28911;
STR_PROP_RPROF_VSCALE = 28912;
STR_PROP_RPROF_DRAWLINE = 28913;
STR_PROP_RPROF_DRAWCURVE = 28914;
STR_PROP_RPROF_LINECOLOR = 28915;
STR_PROP_RPROF_LINELW = 28916;
STR_AID_TITLE = 29001;
STR_GRID_TITLE = 29002;
STR_SNAP_TITLE = 29003;
STR_POLAR_TITLE = 29004;
STR_POLAR_ADD_ANGLE = 29005;
STR_POLAR_ENTER_ANGLE = 29006;
STR_POLAR_ANGLE_EXIST = 29007;
STR_POLAR_ANGLES_FULL = 29008;
STR_POLAR_ANGLE_OUTRANGE = 29009;
STR_LEADER_CREATE = 29011;
STR_LEADER_ENTER_TEXT = 29012;
STR_COMMAND = 29052;
STR_UNKNOWN_COMMAND = 29053;
STR_INVALID_VALUE = 29054;
STR_CMD_ZOOMWIN = 29101;
STR_CMD_ZOOMPAN = 29102;
STR_CMD_ZOOMRT = 29103;
STR_CMD_PANRT = 29104;
STR_CMD_PRINT = 29105;
STR_CMD_DIST = 29106;
STR_CMD_AREA = 29107;
STR_CMD_CALIBRATE = 29108;
STR_CMD_EXPBMP = 29109;
STR_CMD_LINE = 29111;
STR_CMD_CIRCLE = 29112;
STR_CMD_CIRC_CR = 29112;
STR_CMD_CIRC_CD = 29113;
STR_CMD_CIRC_2P = 29114;
STR_CMD_CIRC_3P = 29115;
STR_CMD_ARC = 29117;
STR_CMD_ATTDEF = 29118;
STR_CMD_ATTEDIT = 29119;
STR_CMD_ATTMAN = 29120;
STR_CMD_ELLIPSE = 29123;
STR_CMD_POLYLINE = 29125;
STR_CMD_SPLINE = 29128;
STR_CMD_IMAGES = 29129;
STR_CMD_IMAGE_ATTACH = 29130;
STR_CMD_TEXT = 29131;
STR_CMD_BLOCK = 29132;
STR_CMD_INSERT = 29133;
STR_CMD_POINT = 29134;
STR_CMD_RAY = 29135;
STR_CMD_XLINE = 29136;
STR_CMD_MLINE = 29137;
STR_CMD_POLYGON = 29138;
STR_CMD_RECT = 29139;
STR_CMD_XREFS = 29140;
STR_CMD_XREF_ATTACH = 29141;
STR_CMD_HATCH = 29142;
STR_CMD_DIMLIN = 29143;
STR_CMD_DIMALI = 29144;
STR_CMD_DIMORD = 29145;
STR_CMD_DIMRAD = 29146;
STR_CMD_DIMDIA = 29147;
STR_CMD_DIMANG = 29148;
STR_CMD_CENMARK = 29149;
STR_CMD_LEADER = 29150;
STR_CMD_ERASE = 29151;
STR_CMD_COPY = 29152;
STR_CMD_MOVE = 29153;
STR_CMD_ROTATE = 29154;
STR_CMD_SCALE = 29155;
STR_CMD_MIRROR = 29156;
STR_CMD_ENTPROP = 29157;
STR_CMD_CONVERT = 29161;
STR_CMD_EXPLODE = 29162;
STR_CMD_JOIN = 29163;
STR_CMD_CBCUT = 29164;
STR_CMD_CBCOPY = 29165;
STR_CMD_CBPASTE = 29166;
STR_CMD_SELBYPOINT = 29171;
STR_CMD_SELBYRECT = 29172;
STR_CMD_SELBYPGON = 29173;
STR_CMD_SELBYPLINE = 29174;
STR_CMD_SELBYDIST = 29175;
STR_CMD_TRIM = 29181;
STR_CMD_EXTEND = 29182;
STR_CMD_DEP = 29183;
STR_CMD_MTEXT = 29190;
STR_CMD_WTEXT = 29191;
STR_CMD_REPEAT = 29199;
STR_PNT_POINT = 29201;
STR_LINE_FIRST = 29202;
STR_LINE_NEXT = 29203;
STR_LINE_START = 29204;
STR_LINE_BASE = 29205;
STR_LINE_TROUGH = 29206;
STR_MLINE_NEXT = 29207;
STR_PLINE_FIRST = 29211;
STR_PLINE_NEXT = 29212;
STR_SPLINE_NEXT = 29213;
STR_SPLINE_STARTTAN = 29214;
STR_SPLINE_ENDTAN = 29215;
STR_PGON_CENTER = 29216;
STR_PGON_START = 29217;
STR_RECT_CORNER1 = 29218;
STR_RECT_CORNER2 = 29219;
STR_CIRC_CENTER = 29221;
STR_CIRC_RADIUS = 29222;
STR_CIRC_DIAMETER = 29223;
STR_CIRC_D1 = 29224;
STR_CIRC_D2 = 29225;
STR_CIRC_P1 = 29226;
STR_CIRC_P2 = 29227;
STR_CIRC_P3 = 29228;
STR_ARC_START = 29231;
STR_ARC_SECOND = 29232;
STR_ARC_END = 29233;
STR_ARC_CENTER = 29271;
STR_ARC_CENTER2 = 29272;
STR_ARC_START2 = 29273;
STR_ARC_END2 = 29274;
STR_ARC_ANGLE = 29275;
STR_ARC_DIRANG = 29276;
STR_ARC_RADIUS = 29277;
STR_ARC3_START = 29281;
STR_ARC3_SECOND = 29282;
STR_ELLIP_CENTER = 29234;
STR_ELLIP_RAD1ANG = 29235;
STR_ELLIP_RAD2 = 29236;
STR_IMAGE_INSPNT = 29241;
STR_IMAGE_SCALE = 29242;
STR_TEXT_INSPNT = 29243;
STR_TEXT_HEIGHT = 29244;
STR_TEXT_ANGLE = 29245;
STR_TEXT_TEXT = 29246;
STR_MTEXT_CORNER1 = 29247;
STR_MTEXT_CORNER2 = 29248;
STR_BLK_BASE = 29250;
STR_INS_INSPNT = 29251;
STR_INS_SCALE = 29252;
STR_INS_ANGLE = 29253;
STR_XREF_INSPNT = 29258;
STR_XREF_SCALE = 29259;
STR_HAT_PICKPOINT = 29263;
STR_HAT_NOBOUNDARY = 29264;
STR_HAT_PICKENT = 29265;
STR_MOVE_1 = 29301;
STR_MOVE_2 = 29302;
STR_MOVE_3 = 29303;
STR_ROTATE_BASE = 29304;
STR_ROTATE_ANGLE = 29305;
STR_SCALE_BASE = 29306;
STR_SCALE_SCALE = 29307;
STR_MIRROR_1 = 29308;
STR_MIRROR_2 = 29309;
STR_TRIM_1 = 29311;
STR_TRIM_2 = 29312;
STR_EXTEND_1 = 29313;
STR_EXTEND_2 = 29314;
STR_DEP_DELTA = 29321;
STR_ZOOM_CORNER1 = 29401;
STR_ZOOM_CORNER2 = 29402;
STR_ZOOM_RT = 29403;
STR_PAN_BASE = 29405;
STR_PAN_DISP = 29406;
STR_PAN_RT = 29407;
STR_PRINT_CORNER1 = 29410;
STR_PRINT_CORNER2 = 29411;
STR_DIM_EXT1 = 29420;
STR_DIM_EXT2 = 29421;
STR_DIM_LINE = 29422;
STR_DIM_ORD1 = 29423;
STR_DIM_ORD2 = 29424;
STR_DIM_SELARC = 29425;
STR_DIM_SELALINE = 29426;
STR_DIM_ANGEND = 29427;
STR_DIM_LINE2 = 29428;
STR_DIM_ARC = 29429;
STR_LEADER_FIRST = 29430;
STR_LEADER_NEXT = 29431;
STR_LEADER_ANNTEXT = 29432;
STR_ATT_SELBLOCK = 29441;
STR_ATT_NOATTBLOCK = 29442;
STR_ATT_NOATTBLOCK2 = 29443;
STR_ATT_NOBLOCK = 29444;
STR_ATT_NOENT = 29445;
STR_AREA_INPNT = 29451;
STR_AREA_RESULT = 29452;
STR_AREA_PT1 = 29453;
STR_AREA_PT2 = 29454;
STR_AREA_PT3 = 29455;
STR_DIST_PT1 = 29456;
STR_DIST_PT2 = 29457;
STR_DIST_RESULT = 29458;
STR_DIST_PLINE = 29459;
STR_TA_BOTLEFT = 29601;
STR_TA_BOTCENTER = 29602;
STR_TA_BOTRIGHT = 29603;
STR_TA_MIDLEFT = 29604;
STR_TA_MIDCENTER = 29605;
STR_TA_MIDRIGHT = 29606;
STR_TA_TOPLEFT = 29607;
STR_TA_TOPCENTER = 29608;
STR_TA_TOPRIGHT = 29609;
STR_FITTYPE_NONE = 29611;
STR_FITTYPE_QUAD = 29612;
STR_FITTYPE_CUBIC = 29613;
STR_FITTYPE_BEZIER = 29614;
STR_FITTYPE_SPLINE = 29615;
STR_FITTYPE_ROUND = 29616;
STR_FITTYPE_LINQUAD = 29617;
STR_PAPER_UNLIMITED = 29621;
STR_PAPER_A0 = 29622;
STR_PAPER_A1 = 29623;
STR_PAPER_A2 = 29624;
STR_PAPER_A3 = 29625;
STR_PAPER_A4 = 29626;
STR_PAPER_A5 = 29627;
STR_PAPER_A6 = 29628;
STR_PAPER_B0 = 29629;
STR_PAPER_B1 = 29630;
STR_PAPER_B2 = 29631;
STR_PAPER_B3 = 29632;
STR_PAPER_B4 = 29633;
STR_PAPER_B5 = 29634;
STR_PAPER_B6 = 29635;
STR_PAPER_C0 = 29636;
STR_PAPER_C1 = 29637;
STR_PAPER_C2 = 29638;
STR_PAPER_C3 = 29639;
STR_PAPER_C4 = 29640;
STR_PAPER_C5 = 29641;
STR_PAPER_C6 = 29642;
STR_PAPER_ANSI_A = 29643;
STR_PAPER_ANSI_B = 29644;
STR_PAPER_ANSI_C = 29645;
STR_PAPER_ANSI_D = 29646;
STR_PAPER_ANSI_E = 29647;
STR_PAPER_LETTER = 29648;
STR_PAPER_LEGAL = 29649;
STR_PAPER_EXECUTIVE = 29650;
STR_PAPER_LEDGER = 29651;
STR_PAPER_USER = 29652;
STR_ERROR_INVALID_ID = 1001;
STR_ERROR_ONE_PAGE = 1002;
STR_ERROR_PAGE_NOT_EMPTY = 1003;
STR_ERROR_DEL_LAYER0 = 1011;
STR_ERROR_DEL_CURLAYER = 1012;
STR_ERROR_LAYER_NOT_EMPTY = 1013;
STR_ERROR_DEL_LTYPESTD = 1014;
STR_ERROR_DEL_LTYPEREF = 1015;
STR_ERROR_DEL_DIMSSTD = 1016;
STR_ERROR_DEL_DIMSREF = 1017;
STR_ERROR_DEL_TXTSSTD = 1018;
STR_ERROR_DEL_TXTSREF = 1019;
STR_ERROR_DEL_PNTSSTD = 1020;
STR_ERROR_DEL_PNTSREF = 1021;
STR_ERROR_DEL_MLSSTD = 1022;
STR_ERROR_DEL_MLSREF = 1023;
STR_DG_OK = 3001;
STR_DG_CANCEL = 3002;
STR_DG_HELP = 3003;
STR_DG_NEW = 3004;
STR_DG_DELETE = 3005;
STR_DG_EXIT = 3006;
STR_DG_CLOSE = 3007;
STR_DG_OPENFILE = 3051;
STR_DG_OF_PREVIEW = 3052;
STR_DG_CREBLOCK = 3101;
STR_DG_BLK_NAME = 3102;
STR_DG_BLK_BASEPNT = 3103;
STR_DG_BLK_PICKBASE = 3104;
STR_DG_BLK_OBJECTS = 3105;
STR_DG_BLK_SELECT = 3106;
STR_DG_BLK_RETAIN = 3107;
STR_DG_BLK_CONVERT = 3108;
STR_DG_BLK_DELETE = 3109;
STR_DG_BLK_DESCR = 3110;
STR_DG_BLK_PREVIEW = 3111;
STR_DG_BLOCKS = 3121;
STR_DG_BLK_NAME2 = 3122;
STR_DG_BLK_OBJREF = 3123;
STR_DG_BLK_NREFS = 3124;
STR_DG_BLK_NENTS = 3125;
STR_DG_BLK_VIEW = 3126;
STR_DG_BLK_SHOWBASE = 3127;
STR_DG_BLK_RENAME = 3128;
STR_DG_BLK_EDIT = 3129;
STR_DG_BLK_ADD = 3130;
STR_DG_BLK_INSERT = 3131;
STR_DG_BLK_PATHNAME = 3132;
STR_DG_BLK_STATUS = 3133;
STR_DG_BLK_XREF = 3134;
STR_DG_BLK_RELOAD = 3135;
STR_DG_BLK_LOADED = 3136;
STR_DG_BLK_NOTLOADED = 3137;
STR_DG_BLK_NOTFOUND = 3138;
STR_DG_DELBLOCK = 3141;
STR_DG_BLK_ASKDELETE = 3142;
STR_DG_BLK_DELUNUSED = 3145;
STR_DG_ADDBLOCKF = 3151;
STR_DG_BLF_NSEL = 3152;
STR_DG_BLF_SELALL = 3153;
STR_DG_BLF_UNSELALL = 3154;
STR_DG_BLF_FILEBLOCK = 3155;
STR_DG_GRID_SIZE = 3201;
STR_DG_GRID_BOLDSTEP = 3202;
STR_DG_GRID_SNAP = 3203;
STR_DG_GRID_SHOW = 3204;
STR_DG_GRID_LEVEL = 3210;
STR_DG_GRID_ABOVE = 3211;
STR_DG_GRID_BELOW = 3212;
STR_DG_GRID_COLOR = 3213;
STR_DG_GRID_BCOLOR = 3214;
STR_DG_GRID_TYPE = 3215;
STR_DG_GRID_BTYPE = 3216;
STR_DG_GRID_POINT = 3221;
STR_DG_GRID_LINE = 3222;
STR_DG_GRID_DOTLINE = 3223;
STR_DG_SNAP_ON = 3231;
STR_DG_SNAP_MODES = 3235;
STR_DG_SNAP_END = 3236;
STR_DG_SNAP_MID = 3237;
STR_DG_SNAP_CENTER = 3238;
STR_DG_SNAP_POINT = 3239;
STR_DG_SNAP_INTER = 3240;
STR_DG_SNAP_NEAR = 3241;
STR_DG_SNAP_GRIP = 3242;
STR_DG_SNAP_PERP = 3243;
STR_DG_SNAP_TANG = 3244;
STR_DG_SNAP_SELALL = 3251;
STR_DG_SNAP_CLEAR = 3252;
STR_DG_POLAR_ON = 3271;
STR_DG_POLAR_SETTINGS = 3272;
STR_DG_POLAR_ANGLE = 3273;
STR_DG_POLAR_ADDANG = 3274;
STR_DG_POLAR_NEW = 3275;
STR_DG_POLAR_DELETE = 3276;
STR_DG_POLAR_MEASURE = 3277;
STR_DG_POLAR_ABS = 3278;
STR_DG_POLAR_REL = 3279;
STR_DG_POLAR_DIST = 3280;
STR_DG_POLAR_DISTON = 3281;
STR_DG_DIS_CURSOR = 3301;
STR_DG_DIS_SHOWSYSCUR = 3302;
STR_DG_DIS_SHOWCROSS = 3303;
STR_DG_DIS_CROSSSIZE = 3304;
STR_DG_DIS_CROSSCOLOR = 3305;
STR_DG_DIS_PERFORM = 3310;
STR_DG_DIS_SEGCURVE = 3311;
STR_DG_DIS_SEGTEXT = 3312;
STR_DG_DIS_CHARFRAME = 3313;
STR_DG_DIS_ENTMINSIZE = 3314;
STR_DG_DIS_REDRAWSTEP = 3315;
STR_DG_DIS_MITERLIMIT = 3316;
STR_DG_DIS_IMGBORDER = 3317;
STR_DG_DIS_MAG = 3318;
STR_DG_DIS_MAGSIZE = 3319;
STR_DG_DIS_MAGSCALE = 3320;
STR_DG_DIS_MAGPOS = 3321;
STR_DG_DIS_MAGLEFBOT = 3322;
STR_DG_DIS_MAGLEFTOP = 3323;
STR_DG_DIS_MAGRIGBOT = 3324;
STR_DG_DIS_MAGRIGTOP = 3325;
STR_DG_DIS_COLORS = 3326;
STR_DG_DIS_NAVRTIME = 3327;
STR_DG_DIS_FASTCROSS = 3328;
STR_DG_DIS_DELSCROLLBARS = 3329;
STR_DG_DIS_EMPTYBLKS = 3330;
STR_DG_DIS_SMOOTHSCROLL = 3306;
STR_DG_SEL_MODES = 3331;
STR_DG_SEL_POINT = 3332;
STR_DG_SEL_RECT = 3333;
STR_DG_SEL_SHIFT = 3334;
STR_DG_SEL_CURLAYER = 3335;
STR_DG_SEL_INNER = 3336;
STR_DG_SEL_UNSELECT = 3337;
STR_DG_SEL_ENTS = 3338;
STR_DG_SEL_COLOR = 3339;
STR_DG_SEL_PENSTYLE = 3340;
STR_DG_SEL_BOXSIZE = 3341;
STR_DG_SEL_GRIPS = 3342;
STR_DG_SEL_SHOWGRIPS = 3343;
STR_DG_SEL_GRIPSIZE = 3345;
STR_DG_SEL_INPLINE = 3346;
STR_DG_SEL_HATCHPGON = 3347;
STR_DG_DRAF_SNAPSET = 3351;
STR_DG_DRAF_MARKER = 3352;
STR_DG_DRAF_MAGNET = 3353;
STR_DG_DRAF_SNAPBOX = 3354;
STR_DG_DRAF_MARKCOLOR = 3355;
STR_DG_DRAF_TRACKSET = 3356;
STR_DG_DRAF_TRACKVECTOR = 3357;
STR_DG_DRAF_TRACKTTIP = 3358;
STR_DG_DRAF_MARKSIZE = 3359;
STR_DG_DRAF_APERSIZE = 3360;
STR_DG_EXP_DWGVER = 3371;
STR_DG_EXP_DXFVER = 3372;
STR_DG_EXP_DXFDEC = 3373;
STR_DG_EXP_EXPORT = 3374;
STR_DG_EXP_IMPORT = 3375;
STR_DG_EXP_DIMASBLOCK = 3376;
STR_DG_EXP_HATCHEXPL = 3377;
STR_DG_PRF_CURRENT = 3381;
STR_DG_PRF_LIST = 3382;
STR_DG_PRF_SETCUR = 3383;
STR_DG_PRF_ADD = 3384;
STR_DG_PRF_RENAME = 3385;
STR_DG_PRF_DELETE = 3386;
STR_DG_PRF_RESET = 3387;
STR_DG_PRF_NAME = 3391;
STR_DG_PRF_DESC = 3392;
STR_DG_CALIBRATE = 3401;
STR_DG_CAL_SCALE = 3402;
STR_DG_CAL_INTERACT = 3403;
STR_DG_CAL_PICK = 3404;
STR_DG_CAL_MDIST = 3405;
STR_DG_CAL_RDIST = 3406;
STR_DG_COLOR = 3501;
STR_DG_COL_STANDARD = 3502;
STR_DG_COL_GRAY = 3503;
STR_DG_COL_LOGICAL = 3504;
STR_DG_COL_BYLAYER = 3505;
STR_DG_COL_BYBLOCK = 3506;
STR_DG_COL_PALETTE = 3507;
STR_DG_COL_COLOR = 3508;
STR_DG_PALETTE = 3521;
STR_DG_PAL_FILE = 3522;
STR_DG_PAL_LIST = 3523;
STR_DG_PAL_COLOR = 3524;
STR_DG_PAL_INDEX = 3525;
STR_DG_PAL_RED = 3526;
STR_DG_PAL_GREEN = 3527;
STR_DG_PAL_BLUE = 3528;
STR_DG_PAL_NAME = 3529;
STR_DG_PAL_SAVE = 3530;
STR_DG_PAL_SETCOLOR = 3531;
STR_DG_PAL_SAVEQUEST = 3532;
STR_DG_PLVERTEX = 3601;
STR_DG_PLV_VERTEX = 3602;
STR_DG_PLV_RAD = 3603;
STR_DG_PLV_ONCURVE = 3604;
STR_DG_PLV_SEGMENT = 3605;
STR_DG_PLV_BULGE = 3606;
STR_DG_PLV_WIDTH1 = 3607;
STR_DG_PLV_WIDTH2 = 3608;
STR_DT_PLV_BEZIER = 3609;
STR_DT_PLV_BEZOFF1 = 3610;
STR_DT_PLV_BEZOFF2 = 3611;
STR_DT_PLV_BEZANG1 = 3612;
STR_DT_PLV_BEZANG2 = 3613;
STR_DG_POLYGON = 3701;
STR_DG_PGON_NVERS = 3702;
STR_DG_PGON_IN = 3703;
STR_DG_PGON_ABOUT = 3704;
STR_DG_PGON_CENTER = 3705;
STR_DG_PGON_ONSCR = 3706;
STR_DG_PGON_RADIUSGR = 3707;
STR_DG_PGON_RADIUS = 3709;
STR_DG_PGON_ROTATION = 3710;
STR_DG_PGON_ANGLE = 3712;
STR_DG_BMPEXPORT = 3801;
STR_DG_BMP_FILE = 3802;
STR_DG_BMP_AREA = 3803;
STR_DG_BMP_ALL = 3804;
STR_DG_BMP_DISP = 3805;
STR_DG_BMP_WIN = 3806;
STR_DG_BMP_PICK = 3807;
STR_DG_BMP_RES = 3808;
STR_DG_BMP_SIZE = 3809;
STR_DG_VCFONTS = 3901;
STR_DG_VCF_FONT = 3902;
STR_DG_VCF_FILENAME = 3903;
STR_DG_VCF_SYMBOLS = 3904;
STR_DG_VCF_VIEW = 3905;
STR_DG_VCF_UNICODE = 3906;
STR_DG_VCF_SUBSET = 3907;
STR_DG_TTF2VCF = 4001;
STR_DG_T2V_FONT = 4002;
STR_DG_T2V_SYMBOLS = 4003;
STR_DG_T2V_LOAD = 4004;
STR_DG_T2V_VIEW = 4005;
STR_DG_T2V_UNICODE = 4006;
STR_DG_T2V_SUBSET = 4007;
STR_DG_T2V_VCFONT = 4008;
STR_DG_T2V_VCFONTNAME = 4009;
STR_DG_T2V_VCFILENAME = 4010;
STR_DG_T2V_VCFSAVE = 4011;
STR_DG_SHX2VCF = 4101;
STR_DG_S2V_FONT = 4102;
STR_DG_S2V_FILE = 4103;
STR_DG_S2V_SHAPES = 4104;
STR_DG_S2V_VIEW = 4105;
STR_DG_S2V_BIG = 4106;
STR_DG_S2V_USEBIG = 4107;
STR_DG_S2V_VCFONT = 4110;
STR_DG_S2V_VCFONTNAME = 4111;
STR_DG_S2V_VCFILENAME = 4112;
STR_DG_S2V_SAVE = 4113;
STR_DG_SHXVIEW = 4151;
STR_DG_SHX_FILE = 4152;
STR_DG_SHX_SYMBOLS = 4153;
STR_DG_SHX_VIEW = 4154;
STR_DG_SHX_CODE = 4155;
STR_DG_FONTREPLACE = 4201;
STR_DG_FREP_NOTFOUND = 4202;
STR_DG_FREP_LIST = 4203;
STR_DG_FREP_FILE = 4204;
STR_DG_HATCH = 4301;
STR_DG_HAT_FILE = 4302;
STR_DG_HAT_PATTERN = 4303;
STR_DG_HAT_VIEW = 4304;
STR_DG_HAT_ANGLE = 4305;
STR_DG_HAT_SCALE = 4306;
STR_DG_HAT_PICK = 4307;
STR_DG_HAT_PICKENT = 4308;
STR_DG_IMAGE = 4401;
STR_DG_IMG_NAME = 4402;
STR_DG_IMG_PATH = 4403;
STR_DG_IMG_INSPNT = 4404;
STR_DG_IMG_ONSCR = 4405;
STR_DG_IMG_SCALE = 4406;
STR_DG_IMG_NEW = 4407;
STR_DG_IMG_MANAGER = 4408;
STR_DG_IMG_INSERT = 4409;
STR_DG_IMG_CB = 4420;
STR_DG_IMG_CB_FAIL = 4421;
STR_DG_IMAGEMAN = 4451;
STR_DG_IMM_NAME = 4452;
STR_DG_IMM_PATH = 4453;
STR_DG_IMM_REFS = 4454;
STR_DG_IMM_STATUS = 4455;
STR_DG_IMM_DATE = 4456;
STR_DG_IMM_FILESIZE = 4457;
STR_DG_IMM_IMGSIZE = 4458;
STR_DG_IMM_COLORS = 4459;
STR_DG_IMM_EDIT = 4460;
STR_DG_IMM_RELOAD = 4461;
STR_DG_IMM_REPLACE = 4462;
STR_DG_IMM_INSERT = 4463;
STR_DG_TEXT = 4501;
STR_DG_TXT_ENTER = 4502;
STR_DG_TXT_ALIGN = 4503;
STR_DG_TXT_STYLE = 4504;
STR_DG_TXT_HEIGHT = 4505;
STR_DG_TXT_ROTANG = 4506;
STR_DG_TXT_WIDTH = 4507;
STR_DG_TXT_OBLIQ = 4508;
STR_DG_TXT_INSPNT = 4509;
STR_DG_TXT_UPDOWN = 4510;
STR_DG_TXT_BACKWARD = 4511;
STR_DG_TXT_ITALIC = 4512;
STR_DG_TXT_UNDER = 4513;
STR_DG_TXT_STRIKE = 4514;
STR_DG_INSBLOCK = 4601;
STR_DG_INS_NAME = 4602;
STR_DG_INS_BROWSE = 4603;
STR_DG_INS_INSPNT = 4604;
STR_DG_INS_ONSCR = 4605;
STR_DG_INS_SCALE = 4606;
STR_DG_INS_UNISCALE = 4607;
STR_DG_INS_ROT = 4608;
STR_DG_INS_ANGLE = 4609;
STR_DG_INS_EXPLODE = 4610;
STR_DG_INS_MULTI = 4611;
STR_DG_INS_NCOLS = 4612;
STR_DG_INS_NROWS = 4613;
STR_DG_LAYER = 4701;
STR_DG_LAY_NEW = 4702;
STR_DG_LAY_DELETE = 4703;
STR_DG_LAY_CURRENT = 4704;
STR_DG_LAY_DETAILS = 4705;
STR_DG_LAY_NAME = 4706;
STR_DG_LAY_COLOR = 4707;
STR_DG_LAY_LWEIGHT = 4708;
STR_DG_LAY_LTYPE = 4709;
STR_DG_LAY_OFF = 4710;
STR_DG_LAY_LOCK = 4711;
STR_DG_LAY_NOPRINT = 4712;
STR_DG_LAY_NENTS = 4713;
STR_DG_LINETYPE = 4801;
STR_DG_LT_LOAD = 4802;
STR_DG_LT_DELETE = 4803;
STR_DG_LT_CURRENT = 4804;
STR_DG_LT_DETAILS = 4805;
STR_DG_LT_NAME = 4807;
STR_DG_LT_DESC = 4808;
STR_DG_LT_FORMAT = 4809;
STR_DG_LT_SCALE = 4810;
STR_DG_LT_PREVIEW = 4811;
STR_DG_LT_NEW = 4812;
STR_DG_LTLOAD = 4831;
STR_DG_LT_FILE = 4832;
STR_DG_LT_AVAILABLE = 4833;
STR_DG_LT_NSEL = 4834;
STR_DG_LT_SELALL = 4835;
STR_DG_LT_UNSELALL = 4836;
STR_DG_LTSELECT = 4851;
STR_DG_LWEIGHT = 4901;
STR_DG_LW_LIST = 4902;
STR_DG_LW_UNITS = 4903;
STR_DG_LW_MM = 4904;
STR_DG_LW_INCH = 4905;
STR_DG_LW_DISPLAY = 4906;
STR_DG_LW_DEFAULT = 4907;
STR_DG_LW_SCALE = 4908;
STR_DG_LW_MIN = 4909;
STR_DG_LW_MAX = 4910;
STR_DG_LW_APPLY = 4911;
STR_DG_LW_CURRENT = 4912;
STR_DG_LWSELECT = 4951;
STR_DG_MLSTYLE = 5001;
STR_DG_MLS_CURRENT = 5002;
STR_DG_MLS_CSCALE = 5003;
STR_DG_MLS_CJUST = 5004;
STR_DG_MLS_NAME = 5005;
STR_DG_MLS_JOINTS = 5006;
STR_DG_MLS_CAPS = 5007;
STR_DG_MLS_START = 5008;
STR_DG_MLS_END = 5009;
STR_DG_MLS_LINE = 5010;
STR_DG_MLS_OUTARC = 5011;
STR_DG_MLS_ADD = 5012;
STR_DG_MLS_DELETE = 5013;
STR_DG_MLS_BTNCUR = 5014;
STR_DG_MLS_PREVIEW = 5015;
STR_DG_MLS_ELEMENTS = 5016;
STR_DG_MLS_OFFSET = 5017;
STR_DG_MLS_COLOR = 5018;
STR_DG_MLS_LINETYPE = 5019;
STR_DG_MLS_ADDLINE = 5020;
STR_DG_MLS_DELLINE = 5021;
STR_DG_PAGE = 5101;
STR_DG_PG_CURRENT = 5102;
STR_DG_PG_NEW = 5103;
STR_DG_PG_DELETE = 5104;
STR_DG_PG_BTNCUR = 5105;
STR_DG_PG_NAME = 5106;
STR_DG_PG_SIZE = 5107;
STR_DG_PG_WIDTH = 5108;
STR_DG_PG_HEIGHT = 5109;
STR_DG_PG_ORIENT = 5110;
STR_DG_PG_BOOK = 5111;
STR_DG_PG_ALBUM = 5112;
STR_DG_PAGESELECT = 5151;
STR_DG_PNTSTYLE = 5201;
STR_DG_PS_NEW = 5202;
STR_DG_PS_DELETE = 5203;
STR_DG_PS_CURRENT = 5204;
STR_DG_PS_DETAILS = 5205;
STR_DG_PS_NAME = 5207;
STR_DG_PS_PDMODE = 5208;
STR_DG_PS_STATE = 5209;
STR_DG_PS_PDSIZE = 5210;
STR_DG_PS_BLOCK = 5211;
STR_DG_PS_SCALE = 5212;
STR_DG_PS_FONT = 5213;
STR_DG_PS_HEIGHT = 5214;
STR_DG_PS_WIDTH = 5215;
STR_DG_PS_PREVIEW = 5216;
STR_DG_PS_SNAP = 5217;
STR_DG_PS_FIXED = 5218;
STR_DG_DIMSTYLE = 5231;
STR_DG_DIMSTYLE2 = 5232;
STR_DG_DS_CAPLIST = 5233;
STR_DG_DS_CAPGEOM = 5234;
STR_DG_DS_CAPTEXT = 5235;
STR_DG_DS_CAPUNIT = 5236;
STR_DG_DS_STYLES = 5241;
STR_DG_DS_NAME = 5242;
STR_DG_DS_CURRENT = 5243;
STR_DG_DS_PREVIEW = 5244;
STR_DG_DS_SETCUR = 5245;
STR_DG_DS_DIMLINE = 5251;
STR_DG_DS_DIMCOLOR = 5252;
STR_DG_DS_DIMLW = 5253;
STR_DG_DS_EXT = 5254;
STR_DG_DS_EXTCOLOR = 5255;
STR_DG_DS_EXTLW = 5256;
STR_DG_DS_EXTEXT = 5257;
STR_DG_DS_EXTOFF = 5258;
STR_DG_DS_CMARK = 5259;
STR_DG_DS_CMARKTYPE = 5261;
STR_DG_DS_CMARKSIZE = 5262;
STR_DG_DS_ARROW = 5263;
STR_DG_DS_ARR1 = 5264;
STR_DG_DS_ARR2 = 5265;
STR_DG_DS_ARRLEADER = 5266;
STR_DG_DS_ARRSIZE = 5267;
STR_DG_DS_TEXT = 5271;
STR_DG_DS_TSTYLE = 5272;
STR_DG_DS_TCOLOR = 5273;
STR_DG_DS_TH = 5274;
STR_DG_DS_TRECT = 5275;
STR_DG_DS_TPLACE = 5276;
STR_DG_DS_TVERT = 5277;
STR_DG_DS_TALIGN = 5278;
STR_DG_DS_TOFF = 5279;
STR_DG_DS_LUNIT = 5285;
STR_DG_DS_LUFMT = 5286;
STR_DG_DS_LUPREC = 5287;
STR_DG_DS_LUDEC = 5288;
STR_DG_DS_ROUND = 5289;
STR_DG_DS_PREFIX = 5291;
STR_DG_DS_SUFFIX = 5292;
STR_DG_DS_MSCALE = 5293;
STR_DG_DS_SUPZERO = 5294;
STR_DG_DS_AUNITS = 5295;
STR_DG_DS_AUFMT = 5296;
STR_DG_DS_AUPREC = 5297;
STR_DG_DS_SCALE = 5298;
STR_DG_PRINT = 5301;
STR_DG_PRN_DEVICE = 5302;
STR_DG_PRN_NAME = 5303;
STR_DG_PRN_RES = 5304;
STR_DG_PRN_PAPERSIZE = 5305;
STR_DG_PRN_PRINTABLE = 5306;
STR_DG_PRN_INCH = 5307;
STR_DG_PRN_MM = 5308;
STR_DG_PRN_CHANGE = 5309;
STR_DG_PRN_AREA = 5310;
STR_DG_PRN_EXTENTS = 5311;
STR_DG_PRN_DISPLAY = 5312;
STR_DG_PRN_PAPER = 5313;
STR_DG_PRN_WINDOW = 5314;
STR_DG_PRN_PICK = 5315;
STR_DG_PRN_SCALE = 5316;
STR_DG_PRN_DRWUNITS = 5317;
STR_DG_PRN_SCALEFIT = 5318;
STR_DG_PRN_SCALELW = 5319;
STR_DG_PRN_OFFSET = 5320;
STR_DG_PRN_CENTER = 5321;
STR_DG_PRN_NCOPIES = 5322;
STR_DG_PRN_NOCOLOR = 5323;
STR_DG_PRN_PREVIEW = 5324;
STR_DG_PRN_STAMP = 5325;
STR_DG_PRINTSTAMP = 5351;
STR_DG_PST_POSITION = 5352;
STR_DG_PST_ON = 5353;
STR_DG_PST_FIELDS = 5354;
STR_DG_PST_DWGNAME = 5355;
STR_DG_PST_DATE = 5356;
STR_DG_PST_DEVNAME = 5357;
STR_DG_PST_PAPER = 5358;
STR_DG_PST_SCALE = 5359;
STR_DG_PST_PREVIEW = 5360;
STR_DG_PST_USERTEXT = 5361;
STR_DG_PST_HEIGHT = 5362;
STR_DG_RECENT = 5401;
STR_DG_MRU_FILE = 5402;
STR_DG_MRU_PATH = 5403;
STR_DG_MRU_SIZE = 5404;
STR_DG_MRU_DATE = 5405;
STR_DG_MRU_SHOW = 5406;
STR_DG_MRU_BROWSE = 5407;
STR_DG_MRU_NEW = 5408;
STR_DG_MRU_PREVIEW = 5409;
STR_DG_CODEPAGE = 5501;
STR_DG_CP_UNDEF = 5502;
STR_DG_CP_SELECT = 5503;
STR_DG_TXTSTYLE = 5601;
STR_DG_TS_CURRENT = 5602;
STR_DG_TS_NEW = 5603;
STR_DG_TS_RENAME = 5604;
STR_DG_TS_DELETE = 5605;
STR_DG_TS_FONT = 5606;
STR_DG_TS_NAME = 5607;
STR_DG_TS_HEIGHT = 5608;
STR_DG_TS_FONTS = 5609;
STR_DG_TS_VIEW = 5610;
STR_DG_TS_BTNVIEW = 5611;
STR_DG_TS_EFFECT = 5612;
STR_DG_TS_UPDOWN = 5613;
STR_DG_TS_BACK = 5614;
STR_DG_TS_WIDTH = 5615;
STR_DG_TS_ANGLE = 5616;
STR_DG_TS_TTF = 5617;
STR_DG_TIPDAY = 5701;
STR_DG_TIP_SHOW = 5702;
STR_DG_TIP_NEXT = 5703;
STR_DG_VIEWPOINT = 5801;
STR_DG_VP_ANGHOR = 5802;
STR_DG_VP_ANGVER = 5803;
STR_DG_VP_STDPOS = 5804;
STR_DG_VP_PLAN = 5805;
STR_DG_VP_BOTTOM = 5806;
STR_DG_VP_BACK = 5807;
STR_DG_VP_LEFT = 5808;
STR_DG_VP_RIGHT = 5809;
STR_DG_VP_FRONT = 5810;
STR_DG_VP_NW = 5811;
STR_DG_VP_NE = 5812;
STR_DG_VP_SW = 5813;
STR_DG_VP_SE = 5814;
STR_DG_VP_APPLY = 5815;
STR_DG_XREF = 5901;
STR_DG_XREF_NAME = 5902;
STR_DG_XREF_PATH = 5903;
STR_DG_XREF_INSPNT = 5904;
STR_DG_XREF_ONSCR = 5905;
STR_DG_XREF_SCALE = 5906;
STR_DG_XREF_ROT = 5907;
STR_DG_XREF_ANGLE = 5908;
STR_DG_XREFMAN = 5951;
STR_DG_XREF_FOUND = 5952;
STR_DG_XREF_BROWSE = 5953;
STR_DG_XREF_ATTACH = 5954;
STR_DG_XREF_DETACH = 5955;
STR_DG_XREF_RELOAD = 5956;
STR_DG_XREF_UNLOAD = 5957;
STR_DG_DWGINFO = 6001;
STR_DG_INF_FILENAME = 6002;
STR_DG_INF_FILEDIR = 6003;
STR_DG_INF_ACADVER = 6004;
STR_DG_INF_VECVER = 6005;
STR_DG_INF_FILESIZE = 6006;
STR_DG_INF_CODEPAGE = 6007;
STR_DG_INF_DATECRE = 6008;
STR_DG_INF_DATEMOD = 6009;
STR_DG_INF_EDITTIME = 6010;
STR_DG_INF_MAXEXT = 6011;
STR_DG_INF_MINEXT = 6012;
STR_DG_INF_ENTS = 6013;
STR_DG_INF_BLOCKS = 6014;
STR_DG_INF_LAYERS = 6015;
STR_DG_INF_LTYPES = 6016;
STR_DG_INF_TSTYLES = 6017;
STR_DG_INF_PAGES = 6018;
STR_DG_INF_PLUGINS = 6019;
STR_DG_INF_IMGEDIT = 6020;
STR_DG_INF_RDTIME = 6021;
STR_DG_ATTDEF = 6201;
STR_DG_ATTEDIT = 6202;
STR_DG_ATTMAN = 6203;
STR_DG_ATTSYNC = 6204;
STR_DG_ATT_MODE = 6211;
STR_DG_ATT_INVIS = 6212;
STR_DG_ATT_CONST = 6213;
STR_DG_ATT_PRESET = 6214;
STR_DG_ATT_ATTRIB = 6215;
STR_DG_ATT_ATTRIBS = 6216;
STR_DG_ATT_DATA = 6217;
STR_DG_ATT_TAG = 6218;
STR_DG_ATT_TAG2 = 6219;
STR_DG_ATT_PROMPT = 6220;
STR_DG_ATT_VALUE = 6221;
STR_DG_ATT_VALUE2 = 6222;
STR_DG_ATT_DEFAULT = 6223;
STR_DG_ATT_INSPNT = 6231;
STR_DG_ATT_PICKPNT = 6232;
STR_DG_ATT_TEXTOPTS = 6241;
STR_DG_ATT_JUST = 6242;
STR_DG_ATT_TSTYLE = 6243;
STR_DG_ATT_HEIGHT = 6244;
STR_DG_ATT_ROTANG = 6245;
STR_DG_ATT_PICKHEIGHT = 6246;
STR_DG_ATT_PICKROTANG = 6247;
STR_DG_ATT_WIDTH = 6248;
STR_DG_ATT_OBLIQ = 6249;
STR_DG_ATT_UPSIDEDOWN = 6250;
STR_DG_ATT_BACKWARD = 6251;
STR_DG_ATT_PROPS = 6261;
STR_DG_ATT_LAYER = 6262;
STR_DG_ATT_LTYPE = 6263;
STR_DG_ATT_COLOR = 6264;
STR_DG_ATT_LW = 6265;
STR_DG_ATT_BLOCKNAME = 6267;
STR_DG_ATT_SELBLOCK = 6268;
STR_DG_ATT_DISPOFF = 6271;
STR_DG_ATT_DISPNORM = 6272;
STR_DG_ATT_DISPON = 6273;
STR_DG_ATT_FOUND = 6281;
STR_DG_ATT_GLOBVIS = 6282;
STR_DG_ATT_SYNC = 6283;
STR_DG_ATT_SYNCTAG = 6291;
STR_DG_ATT_APPLY = 6292;
STR_DG_ATT_PARAMS = 6293;
STR_DG_ATT_SELALL = 6294;
STR_DG_ATT_UNSELALL = 6295;
STR_DG_PLUGINS = 6401;
STR_DG_PLG_HFUNC = 6402;
STR_DG_PLG_HVER = 6403;
STR_DG_PLG_HFILENAME = 6404;
STR_DG_PLG_HFILESIZE = 6405;
STR_DG_PLG_DETAILS = 6411;
STR_DG_PLG_FILENAME = 6412;
STR_DG_PLG_VER = 6413;
STR_DG_PLG_TIME = 6414;
STR_DG_PLG_DESC = 6415;
STR_DG_PLG_AUTHOR = 6416;
STR_DG_PLG_COPYRIGHT = 6417;
STR_DG_PLG_OPTIONS = 6421;
STR_DG_PLG_DISABLE = 6422;
STR_DG_PLG_ENABLE = 6423;
STR_DG_PLG_IMGEDITOR = 6430;
RPLAN_TURN_LEFT = 0;
RPLAN_TURN_RIGHT = 1;
RPLAN_AREA = 1;
RPLAN_IZOLINE = 2;
RPLAN_IZOLINEB = 3;
RPLAN_ROAD = 4;
RPLAN_GRPNT = 5;
RPROF_PLINE = 1;
RPROF_CURVE = 2;

vecad_dll = 'CadBox.dll';

Function  CadRegistration (RegCode: Integer): Integer; stdcall; external vecad_dll;
Function  CadGetVersion (szVer: Pointer): Integer; stdcall; external vecad_dll;
Procedure CadOnEventMouseMove (pFunc: Pointer); stdcall; external vecad_dll;
Procedure CadOnEventMouseDown (pFunc: Pointer); stdcall; external vecad_dll;
Procedure CadOnEventMouseUp (pFunc: Pointer); stdcall; external vecad_dll;
Procedure CadOnEventMouseDblClk (pFunc: Pointer); stdcall; external vecad_dll;
Procedure CadOnEventMouseWheel (pFunc: Pointer); stdcall; external vecad_dll;
Procedure CadOnEventMouseSnap (pFunc: Pointer); stdcall; external vecad_dll;
Procedure CadOnEventKeyDown (pFunc: Pointer); stdcall; external vecad_dll;
Procedure CadOnEventRegen (pFunc: Pointer); stdcall; external vecad_dll;
Procedure CadOnEventLoadSave (pFunc: Pointer); stdcall; external vecad_dll;
Procedure CadOnEventDistance (pFunc: Pointer); stdcall; external vecad_dll;
Procedure CadOnEventArea (pFunc: Pointer); stdcall; external vecad_dll;
Procedure CadOnEventPrompt (pFunc: Pointer); stdcall; external vecad_dll;
Procedure CadOnEventSelPage (pFunc: Pointer); stdcall; external vecad_dll;
Procedure CadOnEventSelCodepage (pFunc: Pointer); stdcall; external vecad_dll;
Procedure CadOnEventFontReplace (pFunc: Pointer); stdcall; external vecad_dll;
Procedure CadOnEventPaint (pFunc: Pointer); stdcall; external vecad_dll;
Procedure CadOnEventView (pFunc: Pointer); stdcall; external vecad_dll;
Procedure CadOnEventDrawImage (pFunc: Pointer); stdcall; external vecad_dll;
Procedure CadOnEventSaveDib (pFunc: Pointer); stdcall; external vecad_dll;
Procedure CadOnEventEntCreate (pFunc: Pointer); stdcall; external vecad_dll;
Procedure CadOnEventEntLoad (pFunc: Pointer); stdcall; external vecad_dll;
Procedure CadOnEventEntCopy (pFunc: Pointer); stdcall; external vecad_dll;
Procedure CadOnEventEntErase (pFunc: Pointer); stdcall; external vecad_dll;
Procedure CadOnEventEntMove (pFunc: Pointer); stdcall; external vecad_dll;
Procedure CadOnEventEntRotate (pFunc: Pointer); stdcall; external vecad_dll;
Procedure CadOnEventEntScale (pFunc: Pointer); stdcall; external vecad_dll;
Procedure CadOnEventEntChange (pFunc: Pointer); stdcall; external vecad_dll;
Procedure CadOnEventEntSelect (pFunc: Pointer); stdcall; external vecad_dll;
Procedure CadOnEventPlineInsVer (pFunc: Pointer); stdcall; external vecad_dll;
Procedure CadOnEventPlineDelVer (pFunc: Pointer); stdcall; external vecad_dll;
Procedure CadOnEventPlineEditVer (pFunc: Pointer); stdcall; external vecad_dll;
Procedure CadOnEventExecute (pFunc: Pointer); stdcall; external vecad_dll;
Procedure CadOnEventGripDrag (pFunc: Pointer); stdcall; external vecad_dll;
Procedure CadOnEventGripMove (pFunc: Pointer); stdcall; external vecad_dll;
Procedure CadOnEventCmdStart (pFunc: Pointer); stdcall; external vecad_dll;
Procedure CadOnEventCmdLBDown (pFunc: Pointer); stdcall; external vecad_dll;
Procedure CadOnEventCmdFinish (pFunc: Pointer); stdcall; external vecad_dll;
procedure CadOnExecuteProc (pFunc: Pointer); stdcall; external vecad_dll;
Procedure CadOnEventEngrave (pFunc: Pointer); stdcall; external vecad_dll;
Procedure CadOnEventPolyFill (pFunc: Pointer; bText: Integer); stdcall; external vecad_dll;
Procedure CadOnEventBlockCreate (pFunc: Pointer); stdcall; external vecad_dll;
Procedure CadOnEventCEntGetName (pFunc: Pointer); stdcall; external vecad_dll;
Procedure CadOnEventCEntGetProps (pFunc: Pointer); stdcall; external vecad_dll;
Procedure CadOnEventCEntPutProp (pFunc: Pointer); stdcall; external vecad_dll;
Procedure CadOnEventCEntGetExts (pFunc: Pointer); stdcall; external vecad_dll;
Procedure CadOnEventCEntNumGrips (pFunc: Pointer); stdcall; external vecad_dll;
Procedure CadOnEventCEntGetGrip (pFunc: Pointer); stdcall; external vecad_dll;
Procedure CadOnEventCEntMoveGrip (pFunc: Pointer); stdcall; external vecad_dll;
Procedure CadOnEventCEntMove (pFunc: Pointer); stdcall; external vecad_dll;
Procedure CadOnEventCEntRotate (pFunc: Pointer); stdcall; external vecad_dll;
Procedure CadOnEventCEntScale (pFunc: Pointer); stdcall; external vecad_dll;
Procedure CadOnEventCEntMirror (pFunc: Pointer); stdcall; external vecad_dll;
Procedure CadOnEventCEntDisplay (pFunc: Pointer); stdcall; external vecad_dll;
Procedure CadOnEventCCmdExecute (pFunc: Pointer); stdcall; external vecad_dll;
Procedure CadOnEventCCmdDrag (pFunc: Pointer); stdcall; external vecad_dll;
Procedure CadSetReturnStr (szText: Pchar); stdcall; external vecad_dll;
Procedure CadSetReturnInt (val: Integer); stdcall; external vecad_dll;
Procedure CadSetReturnDbl (val: Double); stdcall; external vecad_dll;
Function  CadGetReturnX : Double; stdcall; external vecad_dll;
Function  CadGetReturnY : Double; stdcall; external vecad_dll;
Function  CadGetReturnZ : Double; stdcall; external vecad_dll;
Function  CadGetReturnVar : Double; stdcall; external vecad_dll;
Function  CadSetParam (Param: Integer; Value: Integer): Integer; stdcall; external vecad_dll;
Function  CadGetParam (Param: Integer): Integer; stdcall; external vecad_dll;
Procedure CadSetDefaultDir (szDir: Pchar); stdcall; external vecad_dll;
Procedure CadGetDefaultDir (szDir: Pointer); stdcall; external vecad_dll;
Function  CadSetDefaultFont (szFontFile: Pchar): Integer; stdcall; external vecad_dll;
Procedure CadGetDefaultFont (szFontFile: Pointer); stdcall; external vecad_dll;
Procedure CadSetMsgTitle (szTitle: Pchar); stdcall; external vecad_dll;
Procedure CadSetViewCoefs (ZoomVal: Double; PanHor: Double; PanVer: Double); stdcall; external vecad_dll;
Procedure CadGetViewCoefs (pZoomVal: Pdouble; pPanHor: Pdouble; pPanVer: Pdouble); stdcall; external vecad_dll;
Function  CadProfileLoad (szName: Pchar): Integer; stdcall; external vecad_dll;
Function  CadProfileSave (szName: Pchar): Integer; stdcall; external vecad_dll;
Procedure CadProfileGetName (szName: Pointer); stdcall; external vecad_dll;
Function  CadSetColor (iColor: Integer; ColorRGB: COLORREF): COLORREF; stdcall; external vecad_dll;
Function  CadGetColor (iColor: Integer): COLORREF; stdcall; external vecad_dll;
Function  CadSeekColor (ColorRGB: COLORREF): Integer; stdcall; external vecad_dll;
Function  CadLoadColors (szFileName: Pchar): Integer; stdcall; external vecad_dll;
Function  CadSaveColors (szFileName: Pchar): Integer; stdcall; external vecad_dll;
Function  CadColorPutRGB (iColor: Integer; ColorRGB: COLORREF): COLORREF; stdcall; external vecad_dll;
Function  CadColorGetRGB (iColor: Integer): COLORREF; stdcall; external vecad_dll;
Function  CadColorSeek (ColorRGB: COLORREF): Integer; stdcall; external vecad_dll;
Function  CadGetBrush (iColor: Integer): HBRUSH; stdcall; external vecad_dll;
Function  CadGetPen (iColor: Integer; Width: Integer): HPEN; stdcall; external vecad_dll;
Function  CadGetLayerWndVisible : Integer; stdcall; external vecad_dll;
Procedure CadSetShowSysCursor (bShow: Integer); stdcall; external vecad_dll;
Function  CadGetShowSysCursor : Integer; stdcall; external vecad_dll;
Procedure CadSetCrossSize (Size: Integer); stdcall; external vecad_dll;
Function  CadGetCrossSize : Integer; stdcall; external vecad_dll;
Procedure CadSetShowCross (bShow: Integer); stdcall; external vecad_dll;
Function  CadGetShowCross : Integer; stdcall; external vecad_dll;
Procedure CadSetCurveQuality (Quality: Integer); stdcall; external vecad_dll;
Function  CadGetCurveQuality : Integer; stdcall; external vecad_dll;
Procedure CadSetCharQuality (Quality: Integer); stdcall; external vecad_dll;
Function  CadGetCharQuality : Integer; stdcall; external vecad_dll;
Procedure CadSetDrawCheckStep (Step: Integer); stdcall; external vecad_dll;
Function  CadGetDrawCheckStep : Integer; stdcall; external vecad_dll;
Procedure CadSetMinCharSize (Size: Integer); stdcall; external vecad_dll;
Function  CadGetMinCharSize : Integer; stdcall; external vecad_dll;
Procedure CadSetMinCharFSize (Size: Integer); stdcall; external vecad_dll;
Function  CadGetMinCharFSize : Integer; stdcall; external vecad_dll;
Procedure CadSetMinEntSize (Size: Integer); stdcall; external vecad_dll;
Function  CadGetMinEntSize : Integer; stdcall; external vecad_dll;
Procedure CadSetMiterLimit (MLimit: Integer); stdcall; external vecad_dll;
Function  CadGetMiterLimit : Integer; stdcall; external vecad_dll;
Procedure CadSetAutoSel (bAutoSel: Integer); stdcall; external vecad_dll;
Function  CadGetAutoSel : Integer; stdcall; external vecad_dll;
Procedure CadSetAutoSelRect (bAutoSelRect: Integer); stdcall; external vecad_dll;
Function  CadGetAutoSelRect : Integer; stdcall; external vecad_dll;
Procedure CadSetSelShiftAdd (bSelShiftAdd: Integer); stdcall; external vecad_dll;
Function  CadGetSelShiftAdd : Integer; stdcall; external vecad_dll;
Procedure CadSetSelInside (bSelInside: Integer); stdcall; external vecad_dll;
Function  CadGetSelInside : Integer; stdcall; external vecad_dll;
Procedure CadSetSelByLayer (bSelByLayer: Integer); stdcall; external vecad_dll;
Function  CadGetSelByLayer : Integer; stdcall; external vecad_dll;
Procedure CadSetUnselAfterEdit (bUnselAfterEdit: Integer); stdcall; external vecad_dll;
Function  CadGetUnselAfterEdit : Integer; stdcall; external vecad_dll;
Function  CadSetSelColor (SelColor: COLORREF): COLORREF; stdcall; external vecad_dll;
Function  CadGetSelColor : COLORREF; stdcall; external vecad_dll;
Procedure CadSetSelLine (SelLine: Integer); stdcall; external vecad_dll;
Function  CadGetSelLine : Integer; stdcall; external vecad_dll;
Procedure CadSetPickboxSize (PickboxSize: Integer); stdcall; external vecad_dll;
Function  CadGetPickboxSize : Integer; stdcall; external vecad_dll;
Procedure CadSetUseGrips (bUseGrips: Integer); stdcall; external vecad_dll;
Function  CadGetUseGrips : Integer; stdcall; external vecad_dll;
Function  CadSetGripColor (GripColor: COLORREF): COLORREF; stdcall; external vecad_dll;
Function  CadGetGripColor : COLORREF; stdcall; external vecad_dll;
Procedure CadSetGripSize (GripSize: Integer); stdcall; external vecad_dll;
Function  CadGetGripSize : Integer; stdcall; external vecad_dll;
Procedure CadSetImageBorder (bImgBorder: Integer); stdcall; external vecad_dll;
Function  CadGetImageBorder : Integer; stdcall; external vecad_dll;
Procedure CadSetDxfDecPrec (dec: Integer); stdcall; external vecad_dll;
Function  CadGetDxfDecPrec : Integer; stdcall; external vecad_dll;
Procedure CadSetDxfVersion (ver: Integer); stdcall; external vecad_dll;
Function  CadGetDxfVersion : Integer; stdcall; external vecad_dll;
Procedure CadSetDwgVersion (ver: Integer); stdcall; external vecad_dll;
Function  CadGetDwgVersion : Integer; stdcall; external vecad_dll;
Procedure CadSetAngleUnit (uang: Integer); stdcall; external vecad_dll;
Function  CadGetAngleUnit : Integer; stdcall; external vecad_dll;
Procedure CadSetFileFilter (ExtType: Integer); stdcall; external vecad_dll;
Function  CadGetFileFilter : Integer; stdcall; external vecad_dll;
Procedure CadShowEmptyRect (bShow: Integer); stdcall; external vecad_dll;
Procedure CadSetBlinkTime (nMSec: Integer); stdcall; external vecad_dll;
Function  CadCreate : Integer; stdcall; external vecad_dll;
Procedure CadDelete (hDwg: Integer); stdcall; external vecad_dll;
Procedure CadPurge (hDwg: Integer; Mode: Integer); stdcall; external vecad_dll;
Procedure CadFileNew (hDwg: Integer; hWin: HWND); stdcall; external vecad_dll;
Function  CadFileOpen (hDwg: Integer; hWin: HWND; szFileName: Pchar): Integer; stdcall; external vecad_dll;
Function  CadFileOpenMem (hDwg: Integer; hWin: HWND; pMem: Pointer): Integer; stdcall; external vecad_dll;
Function  CadFileSave (hDwg: Integer; hWin: HWND): Integer; stdcall; external vecad_dll;
Function  CadFileSaveAs (hDwg: Integer; hWin: HWND; szFileName: Pchar): Integer; stdcall; external vecad_dll;
Function  CadFileSaveMem (hDwg: Integer; hWin: HWND; pMem: Pointer; MaxSize: Integer): Integer; stdcall; external vecad_dll;
Function  CadRasterize (hDwg: Integer; szFileName: Pchar; Left: Double; Bottom: Double; Right: Double; Top: Double; Res: Double): Integer; stdcall; external vecad_dll;
Procedure CadFireLoadSaveEvent (hDwg: Integer; Mode: Integer; Step: Integer; Percent: Integer); stdcall; external vecad_dll;
Procedure CadPutOwner (hDwg: Integer; pObject: Pointer); stdcall; external vecad_dll;
Function  CadGetOwner (hDwg: Integer): Integer; stdcall; external vecad_dll;
Function  CadGetWindow (hDwg: Integer): HWND; stdcall; external vecad_dll;
Procedure CadPutWindow (hDwg: Integer; hWnd: HWND); stdcall; external vecad_dll;
Procedure CadPutFileName (hDwg: Integer; szFileName: Pchar); stdcall; external vecad_dll;
Procedure CadGetFileName (hDwg: Integer; szFileName: Pointer); stdcall; external vecad_dll;
Procedure CadGetShortFileName (hDwg: Integer; szFileName: Pointer); stdcall; external vecad_dll;
Function  CadGetExtentXmin (hDwg: Integer): Double; stdcall; external vecad_dll;
Function  CadGetExtentYmin (hDwg: Integer): Double; stdcall; external vecad_dll;
Function  CadGetExtentZmin (hDwg: Integer): Double; stdcall; external vecad_dll;
Function  CadGetExtentXmax (hDwg: Integer): Double; stdcall; external vecad_dll;
Function  CadGetExtentYmax (hDwg: Integer): Double; stdcall; external vecad_dll;
Function  CadGetExtentZmax (hDwg: Integer): Double; stdcall; external vecad_dll;
Function  CadGetExtentLeft (hDwg: Integer): Double; stdcall; external vecad_dll;
Function  CadGetExtentRight (hDwg: Integer): Double; stdcall; external vecad_dll;
Function  CadGetExtentTop (hDwg: Integer): Double; stdcall; external vecad_dll;
Function  CadGetExtentBottom (hDwg: Integer): Double; stdcall; external vecad_dll;
Procedure CadGetExtentRect (hDwg: Integer; pLeft: Pdouble; pBottom: Pdouble; pRight: Pdouble; pTop: Pdouble); stdcall; external vecad_dll;
Function  CadGetWinLeft (hDwg: Integer): Double; stdcall; external vecad_dll;
Function  CadGetWinRight (hDwg: Integer): Double; stdcall; external vecad_dll;
Function  CadGetWinTop (hDwg: Integer): Double; stdcall; external vecad_dll;
Function  CadGetWinBottom (hDwg: Integer): Double; stdcall; external vecad_dll;
Procedure CadGetWinRect (hDwg: Integer; pLeft: Pdouble; pBottom: Pdouble; pRight: Pdouble; pTop: Pdouble); stdcall; external vecad_dll;
Procedure CadPutDrawOnlyCurLayer (hDwg: Integer; b: Integer); stdcall; external vecad_dll;
Function  CadGetDrawOnlyCurLayer (hDwg: Integer): Integer; stdcall; external vecad_dll;
Procedure CadPutReadOnly (hDwg: Integer; b: Integer); stdcall; external vecad_dll;
Function  CadGetReadOnly (hDwg: Integer): Integer; stdcall; external vecad_dll;
Procedure CadPutDirty (hDwg: Integer; b: Integer); stdcall; external vecad_dll;
Function  CadGetDirty (hDwg: Integer): Integer; stdcall; external vecad_dll;
Procedure CadPutExData (hDwg: Integer; pData: Pointer; nBytes: Integer); stdcall; external vecad_dll;
Function  CadGetExDataSize (hDwg: Integer): Integer; stdcall; external vecad_dll;
Procedure CadGetExData (hDwg: Integer; pData: Pointer); stdcall; external vecad_dll;
Function  CadGetExDataPtr (hDwg: Integer): Integer; stdcall; external vecad_dll;
Procedure CadPutDescr (hDwg: Integer; Str: Pchar; nChars: Integer); stdcall; external vecad_dll;
Function  CadGetDescrLen (hDwg: Integer): Integer; stdcall; external vecad_dll;
Procedure CadGetDescr (hDwg: Integer; pStr: Pointer); stdcall; external vecad_dll;
Procedure CadPutPaintMark (hDwg: Integer; b: Integer); stdcall; external vecad_dll;
Procedure CadPutPointMode (hDwg: Integer; mode: Integer); stdcall; external vecad_dll;
Function  CadGetPointMode (hDwg: Integer): Integer; stdcall; external vecad_dll;
Procedure CadPutPointSize (hDwg: Integer; size: Double); stdcall; external vecad_dll;
Function  CadGetPointSize (hDwg: Integer): Double; stdcall; external vecad_dll;
Procedure CadPutDistScale (hDwg: Integer; Scal: Double); stdcall; external vecad_dll;
Function  CadGetDistScale (hDwg: Integer): Double; stdcall; external vecad_dll;
Function  CadGetNumEntities (hDwg: Integer): Integer; stdcall; external vecad_dll;
Procedure CadGridPutShow (hDwg: Integer; bShow: Integer); stdcall; external vecad_dll;
Function  CadGridGetShow (hDwg: Integer): Integer; stdcall; external vecad_dll;
Procedure CadGridPutSnap (hDwg: Integer; bSnap: Integer); stdcall; external vecad_dll;
Function  CadGridGetSnap (hDwg: Integer): Integer; stdcall; external vecad_dll;
Procedure CadGridPutSize (hDwg: Integer; dx: Double; dy: Double; dz: Double); stdcall; external vecad_dll;
Procedure CadGridGetSize (hDwg: Integer; pdx: Pdouble; pdy: Pdouble; pdz: Pdouble); stdcall; external vecad_dll;
Procedure CadGridPutBoldStep (hDwg: Integer; cx: Integer; cy: Integer; cz: Integer); stdcall; external vecad_dll;
Procedure CadGridGetBoldStep (hDwg: Integer; pcx: Pinteger; pcy: Pinteger; pcz: Pinteger); stdcall; external vecad_dll;
Procedure CadGridPutColor (hDwg: Integer; bBold: Integer; Color: COLORREF); stdcall; external vecad_dll;
Function  CadGridGetColor (hDwg: Integer; bBold: Integer): COLORREF; stdcall; external vecad_dll;
Procedure CadGridPutType (hDwg: Integer; bBold: Integer; Typ: Integer); stdcall; external vecad_dll;
Function  CadGridGetType (hDwg: Integer; bBold: Integer): Integer; stdcall; external vecad_dll;
Procedure CadGridPutLevel (hDwg: Integer; Level: Integer); stdcall; external vecad_dll;
Function  CadGridGetLevel (hDwg: Integer): Integer; stdcall; external vecad_dll;
Procedure CadPutLwDefault (hDwg: Integer; Lweight: Integer); stdcall; external vecad_dll;
Function  CadGetLwDefault (hDwg: Integer): Integer; stdcall; external vecad_dll;
Procedure CadPutLwScale (hDwg: Integer; Scal: Integer); stdcall; external vecad_dll;
Function  CadGetLwScale (hDwg: Integer): Integer; stdcall; external vecad_dll;
Procedure CadPutLwDisplay (hDwg: Integer; bDisplay: Integer); stdcall; external vecad_dll;
Function  CadGetLwDisplay (hDwg: Integer): Integer; stdcall; external vecad_dll;
Procedure CadSetCurLweight (hDwg: Integer; Lweight: Integer); stdcall; external vecad_dll;
Function  CadGetCurLweight (hDwg: Integer): Integer; stdcall; external vecad_dll;
Procedure CadSetCurColor (hDwg: Integer; Color: Integer); stdcall; external vecad_dll;
Function  CadGetCurColor (hDwg: Integer): Integer; stdcall; external vecad_dll;
Procedure CadSetSystemCursor (hDwg: Integer; hCurs: HCURSOR); stdcall; external vecad_dll;
Procedure CadPolarPutOn (hDwg: Integer; bOn: Integer); stdcall; external vecad_dll;
Function  CadPolarGetOn (hDwg: Integer): Integer; stdcall; external vecad_dll;
Procedure CadPolarPutInc (hDwg: Integer; Angle: Integer); stdcall; external vecad_dll;
Function  CadPolarGetInc (hDwg: Integer): Integer; stdcall; external vecad_dll;
Function  CadPolarAddAngle (hDwg: Integer; Angle: Double): Integer; stdcall; external vecad_dll;
Function  CadPolarDelAngle (hDwg: Integer; iAngle: Integer): Integer; stdcall; external vecad_dll;
Function  CadPolarGetAngle (hDwg: Integer; iAngle: Integer): Double; stdcall; external vecad_dll;
Function  CadPolarGetNumAng (hDwg: Integer): Integer; stdcall; external vecad_dll;
Procedure CadPolarPutAbs (hDwg: Integer; bAbs: Integer); stdcall; external vecad_dll;
Function  CadPolarGetAbs (hDwg: Integer): Integer; stdcall; external vecad_dll;
Procedure CadPolarPutDist (hDwg: Integer; Dist: Double); stdcall; external vecad_dll;
Function  CadPolarGetDist (hDwg: Integer): Double; stdcall; external vecad_dll;
Procedure CadPolarPutDistOn (hDwg: Integer; bDist: Integer); stdcall; external vecad_dll;
Function  CadPolarGetDistOn (hDwg: Integer): Integer; stdcall; external vecad_dll;
Procedure CadSnapPutOn (hDwg: Integer; bOn: Integer); stdcall; external vecad_dll;
Function  CadSnapGetOn (hDwg: Integer): Integer; stdcall; external vecad_dll;
Procedure CadSnapPutMode (hDwg: Integer; Mode: Integer); stdcall; external vecad_dll;
Function  CadSnapGetMode (hDwg: Integer): Integer; stdcall; external vecad_dll;
Function  CadSnapGetIndMode (hDwg: Integer): Integer; stdcall; external vecad_dll;
Function  CadSetPlineMark (hDwg: Integer; Id: Integer; hEnt: Integer; Start: Double; Length: Double; Color: COLORREF; Width: Integer; bBlink: Integer): Integer; stdcall; external vecad_dll;
Function  CadAddPlineMark (hDwg: Integer; hEnt: Integer; Start: Double; Length: Double): Integer; stdcall; external vecad_dll;
Procedure CadWinCreate (hDwg: Integer; hWin: HWND); stdcall; external vecad_dll;
Procedure CadWinPaint (hDwg: Integer; hWin: HWND); stdcall; external vecad_dll;
Procedure CadWinDraw (hDwg: Integer; hWin: HWND; dc: HDC; Left: Integer; Top: Integer; Right: Integer; Bottom: Integer); stdcall; external vecad_dll;
Procedure CadWinKeyDown (hDwg: Integer; hWin: HWND; Char: Integer; Flags: Integer); stdcall; external vecad_dll;
Procedure CadWinKeyUp (hDwg: Integer; hWin: HWND; Char: Integer; Flags: Integer); stdcall; external vecad_dll;
Procedure CadWinMouseMove (hDwg: Integer; hWin: HWND; Flags: Integer; x: Integer; y: Integer); stdcall; external vecad_dll;
Procedure CadWinMouseLeave (hDwg: Integer; hWnd: HWND); stdcall; external vecad_dll;
Procedure CadWinMouseWheel (hDwg: Integer; hWin: HWND; Flags: Integer; zDelta: Integer; x: Integer; y: Integer); stdcall; external vecad_dll;
Procedure CadWinLButtonDown (hDwg: Integer; hWin: HWND; Flags: Integer; x: Integer; y: Integer); stdcall; external vecad_dll;
Procedure CadWinLButtonUp (hDwg: Integer; hWin: HWND; Flags: Integer; x: Integer; y: Integer); stdcall; external vecad_dll;
Procedure CadWinLButtonDblClk (hDwg: Integer; hWin: HWND; Flags: Integer; x: Integer; y: Integer); stdcall; external vecad_dll;
Procedure CadWinRButtonDown (hDwg: Integer; hWin: HWND; Flags: Integer; x: Integer; y: Integer); stdcall; external vecad_dll;
Procedure CadWinRButtonUp (hDwg: Integer; hWin: HWND; Flags: Integer; x: Integer; y: Integer); stdcall; external vecad_dll;
Procedure CadWinMButtonDown (hDwg: Integer; hWin: HWND; Flags: Integer; x: Integer; y: Integer); stdcall; external vecad_dll;
Procedure CadWinMButtonUp (hDwg: Integer; hWin: HWND; Flags: Integer; x: Integer; y: Integer); stdcall; external vecad_dll;
Procedure CadWinHScroll (hDwg: Integer; hWin: HWND; SBCode: Integer; Pos: Integer); stdcall; external vecad_dll;
Procedure CadWinVScroll (hDwg: Integer; hWin: HWND; SBCode: Integer; Pos: Integer); stdcall; external vecad_dll;
Procedure CadWinSize (hDwg: Integer; hWin: HWND; SizeType: Integer; cx: Integer; cy: Integer); stdcall; external vecad_dll;
Procedure CadWinSetFocus (hDwg: Integer; hWin: HWND); stdcall; external vecad_dll;
Procedure CadWinKillFocus (hDwg: Integer; hWin: HWND); stdcall; external vecad_dll;
Procedure CadWinDestroy (hDwg: Integer; hWin: HWND); stdcall; external vecad_dll;
Function  CadWinClose (hDwg: Integer; hWin: HWND): Integer; stdcall; external vecad_dll;
Function  CadWinTimer (hDwg: Integer; hWin: HWND; Id: Integer): Integer; stdcall; external vecad_dll;
Procedure CadExecute (hDwg: Integer; hWin: HWND; Command: Integer); stdcall; external vecad_dll;
Procedure CadSetCmdParam (hDwg: Integer; Command: Integer; pData: Pointer); stdcall; external vecad_dll;
Procedure CadGetCmdParam (hDwg: Integer; Command: Integer; pData: Pointer); stdcall; external vecad_dll;
Procedure CadSetCmdPoint (hDwg: Integer; X: Double; Y: Double; Z: Double); stdcall; external vecad_dll;
Function  CadAddLayer (hDwg: Integer; szName: Pchar; Color: Integer; IdLtype: Integer; Lweight: Integer): Integer; stdcall; external vecad_dll;
Function  CadDeleteLayer (hDwg: Integer; hLayer: Integer): Integer; stdcall; external vecad_dll;
Function  CadCountLayers (hDwg: Integer): Integer; stdcall; external vecad_dll;
Function  CadGetCurLayer (hDwg: Integer): Integer; stdcall; external vecad_dll;
Function  CadSetCurLayer (hDwg: Integer; hLayer: Integer): Integer; stdcall; external vecad_dll;
Function  CadSetCurLayerByID (hDwg: Integer; Id: Integer): Integer; stdcall; external vecad_dll;
Function  CadSetCurLayerByName (hDwg: Integer; szLayerName: Pchar): Integer; stdcall; external vecad_dll;
Function  CadGetFirstLayer (hDwg: Integer): Integer; stdcall; external vecad_dll;
Function  CadGetNextLayer (hDwg: Integer; hLayer: Integer): Integer; stdcall; external vecad_dll;
Function  CadGetLayerByID (hDwg: Integer; Id: Integer): Integer; stdcall; external vecad_dll;
Function  CadGetLayerByName (hDwg: Integer; szName: Pchar): Integer; stdcall; external vecad_dll;
Procedure CadSortLayers (hDwg: Integer); stdcall; external vecad_dll;
Function  CadLayerGetID (hLayer: Integer): Integer; stdcall; external vecad_dll;
Procedure CadLayerGetName (hLayer: Integer; szName: Pointer); stdcall; external vecad_dll;
Procedure CadLayerPutName (hLayer: Integer; szName: Pchar); stdcall; external vecad_dll;
Function  CadLayerGetColor (hLayer: Integer): Integer; stdcall; external vecad_dll;
Procedure CadLayerPutColor (hLayer: Integer; Color: Integer); stdcall; external vecad_dll;
Function  CadLayerGetLineweight (hLayer: Integer): Integer; stdcall; external vecad_dll;
Procedure CadLayerPutLineweight (hLayer: Integer; lw: Integer); stdcall; external vecad_dll;
Function  CadLayerGetLinetypeID (hLayer: Integer): Integer; stdcall; external vecad_dll;
Procedure CadLayerPutLinetypeID (hLayer: Integer; Id: Integer); stdcall; external vecad_dll;
Function  CadLayerGetLevel (hLayer: Integer): Integer; stdcall; external vecad_dll;
Procedure CadLayerPutLevel (hLayer: Integer; Level: Integer); stdcall; external vecad_dll;
Function  CadLayerGetUserData (hLayer: Integer): Integer; stdcall; external vecad_dll;
Procedure CadLayerPutUserData (hLayer: Integer; Val: Integer); stdcall; external vecad_dll;
Function  CadLayerGetLock (hLayer: Integer): Integer; stdcall; external vecad_dll;
Procedure CadLayerPutLock (hLayer: Integer; bLock: Integer); stdcall; external vecad_dll;
Function  CadLayerGetVisible (hLayer: Integer): Integer; stdcall; external vecad_dll;
Procedure CadLayerPutVisible (hLayer: Integer; bVisible: Integer); stdcall; external vecad_dll;
Function  CadLayerGetPrintable (hLayer: Integer): Integer; stdcall; external vecad_dll;
Procedure CadLayerPutPrintable (hLayer: Integer; bPrintable: Integer); stdcall; external vecad_dll;
Function  CadLayerCountEntities (hLayer: Integer): Integer; stdcall; external vecad_dll;
Function  CadLayerGetFirstEntity (hLayer: Integer): Integer; stdcall; external vecad_dll;
Function  CadLayerGetNextEntity (hLayer: Integer; hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadLayerPutDescr (hLayer: Integer; Str: Pchar; nChars: Integer); stdcall; external vecad_dll;
Function  CadLayerGetDescrLen (hLayer: Integer): Integer; stdcall; external vecad_dll;
Procedure CadLayerGetDescr (hLayer: Integer; pStr: Pointer); stdcall; external vecad_dll;
Function  CadLayerGetDeleted (hLayer: Integer): Integer; stdcall; external vecad_dll;
Procedure CadLayerPurge (hLayer: Integer); stdcall; external vecad_dll;
Function  CadAddLinetype (hDwg: Integer; szName: Pchar; szFormat: Pchar; szPict: Pchar): Integer; stdcall; external vecad_dll;
Function  CadAddLinetypeF (hDwg: Integer; szName: Pchar; szFileName: Pchar): Integer; stdcall; external vecad_dll;
Function  CadDeleteLinetype (hDwg: Integer; hLtype: Integer): Integer; stdcall; external vecad_dll;
Function  CadCountLinetypes (hDwg: Integer): Integer; stdcall; external vecad_dll;
Function  CadGetCurLinetype (hDwg: Integer): Integer; stdcall; external vecad_dll;
Function  CadSetCurLinetype (hDwg: Integer; hLtype: Integer): Integer; stdcall; external vecad_dll;
Function  CadSetCurLinetypeByID (hDwg: Integer; Id: Integer): Integer; stdcall; external vecad_dll;
Function  CadSetCurLinetypeByName (hDwg: Integer; szLtypeName: Pchar): Integer; stdcall; external vecad_dll;
Function  CadGetFirstLinetype (hDwg: Integer): Integer; stdcall; external vecad_dll;
Function  CadGetNextLinetype (hDwg: Integer; hLtype: Integer): Integer; stdcall; external vecad_dll;
Function  CadGetLinetypeByID (hDwg: Integer; Id: Integer): Integer; stdcall; external vecad_dll;
Function  CadGetLinetypeByName (hDwg: Integer; szName: Pchar): Integer; stdcall; external vecad_dll;
Function  CadGetLinetypeByLayer (hDwg: Integer): Integer; stdcall; external vecad_dll;
Function  CadGetLinetypeByBlock (hDwg: Integer): Integer; stdcall; external vecad_dll;
Function  CadGetLinetypeContinuous (hDwg: Integer): Integer; stdcall; external vecad_dll;
Function  CadLinetypeGetID (hLtype: Integer): Integer; stdcall; external vecad_dll;
Procedure CadLinetypeGetName (hLtype: Integer; szName: Pointer); stdcall; external vecad_dll;
Procedure CadLinetypePutName (hLtype: Integer; szName: Pchar); stdcall; external vecad_dll;
Procedure CadLinetypeGetData (hLtype: Integer; szData: Pointer); stdcall; external vecad_dll;
Procedure CadLinetypePutData (hLtype: Integer; szData: Pchar); stdcall; external vecad_dll;
Function  CadLinetypePutDataF (hLtype: Integer; szFileName: Pchar): Integer; stdcall; external vecad_dll;
Procedure CadLinetypeGetDescr (hLtype: Integer; szDescr: Pointer); stdcall; external vecad_dll;
Procedure CadLinetypePutDescr (hLtype: Integer; szDescr: Pchar); stdcall; external vecad_dll;
Function  CadLinetypeGetScale (hLtype: Integer): Double; stdcall; external vecad_dll;
Procedure CadLinetypePutScale (hLtype: Integer; Scal: Double); stdcall; external vecad_dll;
Function  CadLinetypeIsByLayer (hLtype: Integer): Integer; stdcall; external vecad_dll;
Function  CadLinetypeIsByBlock (hLtype: Integer): Integer; stdcall; external vecad_dll;
Function  CadLinetypeIsContinuous (hLtype: Integer): Integer; stdcall; external vecad_dll;
Function  CadAddPage (hDwg: Integer; szName: Pchar; Size: Integer; Orient: Integer; Width: Integer; Height: Integer): Integer; stdcall; external vecad_dll;
Function  CadDeletePage (hDwg: Integer; hPage: Integer): Integer; stdcall; external vecad_dll;
Function  CadCountPages (hDwg: Integer): Integer; stdcall; external vecad_dll;
Function  CadGetCurPage (hDwg: Integer): Integer; stdcall; external vecad_dll;
Function  CadSetCurPage (hDwg: Integer; hPage: Integer): Integer; stdcall; external vecad_dll;
Function  CadSetCurPageByID (hDwg: Integer; Id: Integer): Integer; stdcall; external vecad_dll;
Function  CadSetCurPageByName (hDwg: Integer; szName: Pchar): Integer; stdcall; external vecad_dll;
Function  CadGetFirstPage (hDwg: Integer): Integer; stdcall; external vecad_dll;
Function  CadGetNextPage (hDwg: Integer; hPage: Integer): Integer; stdcall; external vecad_dll;
Function  CadGetPageByID (hDwg: Integer; Id: Integer): Integer; stdcall; external vecad_dll;
Function  CadGetPageByName (hDwg: Integer; szName: Pchar): Integer; stdcall; external vecad_dll;
Function  CadPageGetID (hPage: Integer): Integer; stdcall; external vecad_dll;
Procedure CadPageGetName (hPage: Integer; szName: Pointer); stdcall; external vecad_dll;
Procedure CadPagePutName (hPage: Integer; szName: Pchar); stdcall; external vecad_dll;
Function  CadPageGetSize (hPage: Integer): Integer; stdcall; external vecad_dll;
Procedure CadPagePutSize (hPage: Integer; Size: Integer); stdcall; external vecad_dll;
Function  CadPageGetOrient (hPage: Integer): Integer; stdcall; external vecad_dll;
Procedure CadPagePutOrient (hPage: Integer; Orient: Integer); stdcall; external vecad_dll;
Function  CadPageGetWidth (hPage: Integer): Integer; stdcall; external vecad_dll;
Procedure CadPagePutWidth (hPage: Integer; Width: Integer); stdcall; external vecad_dll;
Function  CadPageGetHeight (hPage: Integer): Integer; stdcall; external vecad_dll;
Procedure CadPagePutHeight (hPage: Integer; Height: Integer); stdcall; external vecad_dll;
Function  CadPageSave (hDwg: Integer; hPage: Integer; szFileName: Pchar): Integer; stdcall; external vecad_dll;
Function  CadPageCopy (hSrcDwg: Integer; hSrcPage: Integer; hDestDwg: Integer; hDestPage: Integer): Integer; stdcall; external vecad_dll;
Function  CadAddTStyle (hDwg: Integer; szName: Pchar; szFontName: Pchar): Integer; stdcall; external vecad_dll;
Function  CadDeleteTStyle (hDwg: Integer; hTStyle: Integer): Integer; stdcall; external vecad_dll;
Function  CadCountTStyles (hDwg: Integer): Integer; stdcall; external vecad_dll;
Function  CadGetCurTStyle (hDwg: Integer): Integer; stdcall; external vecad_dll;
Function  CadSetCurTStyle (hDwg: Integer; hTStyle: Integer): Integer; stdcall; external vecad_dll;
Function  CadSetCurTStyleByID (hDwg: Integer; Id: Integer): Integer; stdcall; external vecad_dll;
Function  CadSetCurTStyleByName (hDwg: Integer; szName: Pchar): Integer; stdcall; external vecad_dll;
Function  CadGetFirstTStyle (hDwg: Integer): Integer; stdcall; external vecad_dll;
Function  CadGetNextTStyle (hDwg: Integer; hTStyle: Integer): Integer; stdcall; external vecad_dll;
Function  CadGetTStyleByID (hDwg: Integer; Id: Integer): Integer; stdcall; external vecad_dll;
Function  CadGetTStyleByName (hDwg: Integer; szName: Pchar): Integer; stdcall; external vecad_dll;
Function  CadTStyleGetID (hTStyle: Integer): Integer; stdcall; external vecad_dll;
Procedure CadTStyleGetName (hTStyle: Integer; szName: Pointer); stdcall; external vecad_dll;
Procedure CadTStylePutName (hTStyle: Integer; szName: Pchar); stdcall; external vecad_dll;
Function  CadTStyleGetOblique (hTStyle: Integer): Double; stdcall; external vecad_dll;
Procedure CadTStylePutOblique (hTStyle: Integer; Angle: Double); stdcall; external vecad_dll;
Function  CadTStyleGetWidth (hTStyle: Integer): Double; stdcall; external vecad_dll;
Procedure CadTStylePutWidth (hTStyle: Integer; Width: Double); stdcall; external vecad_dll;
Function  CadTStyleGetHeight (hTStyle: Integer): Double; stdcall; external vecad_dll;
Procedure CadTStylePutHeight (hTStyle: Integer; Height: Double); stdcall; external vecad_dll;
Function  CadTStyleGetUpsideDown (hTStyle: Integer): Integer; stdcall; external vecad_dll;
Procedure CadTStylePutUpsideDown (hTStyle: Integer; bUpsideDown: Integer); stdcall; external vecad_dll;
Function  CadTStyleGetBackward (hTStyle: Integer): Integer; stdcall; external vecad_dll;
Procedure CadTStylePutBackward (hTStyle: Integer; bBackward: Integer); stdcall; external vecad_dll;
Procedure CadTStyleGetFont (hTStyle: Integer; szFontName: Pointer); stdcall; external vecad_dll;
Procedure CadTStylePutFont (hTStyle: Integer; szFontName: Pchar); stdcall; external vecad_dll;
Procedure CadTStyleGetTTFName (hTStyle: Integer; szTTFName: Pointer); stdcall; external vecad_dll;
Procedure CadTStylePutTTFName (hTStyle: Integer; szTTFName: Pchar); stdcall; external vecad_dll;
Function  CadAddBlock (hDwg: Integer; szName: Pchar; X: Double; Y: Double; Z: Double): Integer; stdcall; external vecad_dll;
Function  CadAddBlockFromFile (hDwg: Integer; szFileName: Pchar; szName: Pchar): Integer; stdcall; external vecad_dll;
Function  CadAddBlockFromDrw (hDwgDest: Integer; hDwgSrc: Integer; szName: Pchar): Integer; stdcall; external vecad_dll;
Function  CadAddBlockFile (hDwg: Integer; szFileName: Pchar): Integer; stdcall; external vecad_dll;
Function  CadAddBlockXref (hDwg: Integer; szFileName: Pchar): Integer; stdcall; external vecad_dll;
Function  CadAddBlockClip (hDwg: Integer; szName: Pchar; Lef: Double; Bot: Double; W: Double; H: Double): Integer; stdcall; external vecad_dll;
Function  CadDeleteBlock (hDwg: Integer; hBlock: Integer): Integer; stdcall; external vecad_dll;
Function  CadCountBlocks (hDwg: Integer): Integer; stdcall; external vecad_dll;
Function  CadGetFirstBlock (hDwg: Integer): Integer; stdcall; external vecad_dll;
Function  CadGetNextBlock (hDwg: Integer; hBlock: Integer): Integer; stdcall; external vecad_dll;
Function  CadGetBlockByID (hDwg: Integer; idBlock: Integer): Integer; stdcall; external vecad_dll;
Function  CadGetBlockByName (hDwg: Integer; szName: Pchar): Integer; stdcall; external vecad_dll;
Function  CadGetCurBlock (hDwg: Integer): Integer; stdcall; external vecad_dll;
Function  CadSetCurBlock (hDwg: Integer; hBlock: Integer): Integer; stdcall; external vecad_dll;
Function  CadBlockGetID (hBlock: Integer): Integer; stdcall; external vecad_dll;
Procedure CadBlockGetName (hBlock: Integer; szName: Pointer); stdcall; external vecad_dll;
Function  CadBlockPutName (hBlock: Integer; szName: Pchar): Integer; stdcall; external vecad_dll;
Function  CadBlockGetBaseX (hBlock: Integer): Double; stdcall; external vecad_dll;
Procedure CadBlockPutBaseX (hBlock: Integer; X: Double); stdcall; external vecad_dll;
Function  CadBlockGetBaseY (hBlock: Integer): Double; stdcall; external vecad_dll;
Procedure CadBlockPutBaseY (hBlock: Integer; Y: Double); stdcall; external vecad_dll;
Function  CadBlockGetBaseZ (hBlock: Integer): Double; stdcall; external vecad_dll;
Procedure CadBlockPutBaseZ (hBlock: Integer; Z: Double); stdcall; external vecad_dll;
Procedure CadBlockGetBase (hBlock: Integer; pX: Pdouble; pY: Pdouble; pZ: Pdouble); stdcall; external vecad_dll;
Procedure CadBlockPutBase (hBlock: Integer; X: Double; Y: Double; Z: Double); stdcall; external vecad_dll;
Function  CadBlockCountEntities (hBlock: Integer): Integer; stdcall; external vecad_dll;
Procedure CadBlockClear (hBlock: Integer); stdcall; external vecad_dll;
Procedure CadBlockAddEntity (hBlock: Integer; hEnt: Integer); stdcall; external vecad_dll;
Function  CadBlockGetFirstPtr (hBlock: Integer): Integer; stdcall; external vecad_dll;
Function  CadBlockGetNextPtr (hBlock: Integer; hPtr: Integer): Integer; stdcall; external vecad_dll;
Function  CadBlockHasAttribs (hBlock: Integer): Integer; stdcall; external vecad_dll;
Function  CadBlockGetAttrib (hBlock: Integer; szTag: Pchar): Integer; stdcall; external vecad_dll;
Function  CadBlockIsXref (hBlock: Integer): Integer; stdcall; external vecad_dll;
Procedure CadXrefGetPath (hBlock: Integer; szPathName: Pointer); stdcall; external vecad_dll;
Function  CadXrefPutPath (hBlock: Integer; szPathName: Pchar): Integer; stdcall; external vecad_dll;
Function  CadXrefReload (hBlock: Integer): Integer; stdcall; external vecad_dll;
Function  CadXrefGetStatus (hBlock: Integer): Integer; stdcall; external vecad_dll;
Procedure CadBlockPutExData (hBlock: Integer; pData: Pointer; nBytes: Integer); stdcall; external vecad_dll;
Function  CadBlockGetExDataSize (hBlock: Integer): Integer; stdcall; external vecad_dll;
Procedure CadBlockGetExData (hBlock: Integer; pData: Pointer); stdcall; external vecad_dll;
Function  CadAddPntStyle (hDwg: Integer; szName: Pchar; BlockId: Integer; BlockScale: Double; szFontName: Pchar; TxtH: Double; TxtW: Double): Integer; stdcall; external vecad_dll;
Function  CadDeletePntStyle (hDwg: Integer; hPntStyle: Integer): Integer; stdcall; external vecad_dll;
Function  CadCountPntStyles (hDwg: Integer): Integer; stdcall; external vecad_dll;
Function  CadGetCurPntStyle (hDwg: Integer): Integer; stdcall; external vecad_dll;
Function  CadSetCurPntStyle (hDwg: Integer; hPntStyle: Integer): Integer; stdcall; external vecad_dll;
Function  CadSetCurPntStyleByID (hDwg: Integer; Id: Integer): Integer; stdcall; external vecad_dll;
Function  CadSetCurPntStyleByName (hDwg: Integer; szName: Pchar): Integer; stdcall; external vecad_dll;
Function  CadGetFirstPntStyle (hDwg: Integer): Integer; stdcall; external vecad_dll;
Function  CadGetNextPntStyle (hDwg: Integer; hPntStyle: Integer): Integer; stdcall; external vecad_dll;
Function  CadGetPntStyleByID (hDwg: Integer; Id: Integer): Integer; stdcall; external vecad_dll;
Function  CadGetPntStyleByName (hDwg: Integer; szName: Pchar): Integer; stdcall; external vecad_dll;
Function  CadPntStyleGetID (hPntStyle: Integer): Integer; stdcall; external vecad_dll;
Procedure CadPntStyleGetName (hPntStyle: Integer; szName: Pointer); stdcall; external vecad_dll;
Procedure CadPntStylePutName (hPntStyle: Integer; szName: Pchar); stdcall; external vecad_dll;
Function  CadPntStyleGetBlockID (hPntStyle: Integer): Integer; stdcall; external vecad_dll;
Procedure CadPntStylePutBlockID (hPntStyle: Integer; IdBlock: Integer); stdcall; external vecad_dll;
Function  CadPntStyleGetBlockScale (hPntStyle: Integer): Double; stdcall; external vecad_dll;
Procedure CadPntStylePutBlockScale (hPntStyle: Integer; Scal: Double); stdcall; external vecad_dll;
Procedure CadPntStyleGetFont (hPntStyle: Integer; szFontName: Pointer); stdcall; external vecad_dll;
Procedure CadPntStylePutFont (hPntStyle: Integer; szFontName: Pchar); stdcall; external vecad_dll;
Function  CadPntStyleGetTextHeight (hPntStyle: Integer): Double; stdcall; external vecad_dll;
Procedure CadPntStylePutTextHeight (hPntStyle: Integer; TxtH: Double); stdcall; external vecad_dll;
Function  CadPntStyleGetTextWidth (hPntStyle: Integer): Double; stdcall; external vecad_dll;
Procedure CadPntStylePutTextWidth (hPntStyle: Integer; TxtW: Double); stdcall; external vecad_dll;
Function  CadPntStyleGetDrawMode (hPntStyle: Integer): Integer; stdcall; external vecad_dll;
Procedure CadPntStylePutDrawMode (hPntStyle: Integer; Mode: Integer); stdcall; external vecad_dll;
Function  CadPntStyleGetSnap (hPntStyle: Integer): Integer; stdcall; external vecad_dll;
Procedure CadPntStylePutSnap (hPntStyle: Integer; bSnap: Integer); stdcall; external vecad_dll;
Function  CadPntStyleGetFixed (hPntStyle: Integer): Integer; stdcall; external vecad_dll;
Procedure CadPntStylePutFixed (hPntStyle: Integer; bFixed: Integer); stdcall; external vecad_dll;
Function  CadAddMlineStyle (hDwg: Integer; szName: Pchar): Integer; stdcall; external vecad_dll;
Function  CadDeleteMlineStyle (hDwg: Integer; hMStyle: Integer): Integer; stdcall; external vecad_dll;
Function  CadCountMlineStyles (hDwg: Integer): Integer; stdcall; external vecad_dll;
Function  CadGetCurMlineStyle (hDwg: Integer): Integer; stdcall; external vecad_dll;
Function  CadSetCurMlineStyle (hDwg: Integer; hMStyle: Integer): Integer; stdcall; external vecad_dll;
Function  CadSetCurMlineStyleByID (hDwg: Integer; Id: Integer): Integer; stdcall; external vecad_dll;
Function  CadSetCurMlineStyleByName (hDwg: Integer; szName: Pchar): Integer; stdcall; external vecad_dll;
Function  CadGetFirstMlineStyle (hDwg: Integer): Integer; stdcall; external vecad_dll;
Function  CadGetNextMlineStyle (hDwg: Integer; hMStyle: Integer): Integer; stdcall; external vecad_dll;
Function  CadGetMlineStyleByID (hDwg: Integer; Id: Integer): Integer; stdcall; external vecad_dll;
Function  CadGetMlineStyleByName (hDwg: Integer; szName: Pchar): Integer; stdcall; external vecad_dll;
Function  CadMlineStyleGetID (hMStyle: Integer): Integer; stdcall; external vecad_dll;
Procedure CadMlineStyleGetName (hMStyle: Integer; szName: Pointer); stdcall; external vecad_dll;
Procedure CadMlineStylePutName (hMStyle: Integer; szName: Pchar); stdcall; external vecad_dll;
Function  CadMlineStyleGetDrawMode (hMStyle: Integer): Integer; stdcall; external vecad_dll;
Procedure CadMlineStylePutDrawMode (hMStyle: Integer; Mode: Integer); stdcall; external vecad_dll;
Function  CadMlineStyleGetNumLines (hMStyle: Integer): Integer; stdcall; external vecad_dll;
Procedure CadMlineStylePutNumLines (hMStyle: Integer; nLines: Integer); stdcall; external vecad_dll;
Function  CadMlineStyleGetColor (hMStyle: Integer; iLine: Integer): Integer; stdcall; external vecad_dll;
Procedure CadMlineStylePutColor (hMStyle: Integer; iLine: Integer; Color: Integer); stdcall; external vecad_dll;
Function  CadMlineStyleGetLtypeID (hMStyle: Integer; iLine: Integer): Integer; stdcall; external vecad_dll;
Procedure CadMlineStylePutLtypeID (hMStyle: Integer; iLine: Integer; Id: Integer); stdcall; external vecad_dll;
Function  CadMlineStyleGetOffset (hMStyle: Integer; iLine: Integer): Double; stdcall; external vecad_dll;
Procedure CadMlineStylePutOffset (hMStyle: Integer; iLine: Integer; Offset: Double); stdcall; external vecad_dll;
Function  CadAddDimStyle (hDwg: Integer; szName: Pchar): Integer; stdcall; external vecad_dll;
Function  CadDeleteDimStyle (hDwg: Integer; hStyle: Integer): Integer; stdcall; external vecad_dll;
Function  CadCountDimStyles (hDwg: Integer): Integer; stdcall; external vecad_dll;
Function  CadGetCurDimStyle (hDwg: Integer): Integer; stdcall; external vecad_dll;
Function  CadSetCurDimStyle (hDwg: Integer; hStyle: Integer): Integer; stdcall; external vecad_dll;
Function  CadSetCurDimStyleByID (hDwg: Integer; Id: Integer): Integer; stdcall; external vecad_dll;
Function  CadSetCurDimStyleByName (hDwg: Integer; szName: Pchar): Integer; stdcall; external vecad_dll;
Function  CadGetFirstDimStyle (hDwg: Integer): Integer; stdcall; external vecad_dll;
Function  CadGetNextDimStyle (hDwg: Integer; hStyle: Integer): Integer; stdcall; external vecad_dll;
Function  CadGetDimStyleByID (hDwg: Integer; Id: Integer): Integer; stdcall; external vecad_dll;
Function  CadGetDimStyleByName (hDwg: Integer; szName: Pchar): Integer; stdcall; external vecad_dll;
Function  CadDimStyleGetID (hStyle: Integer): Integer; stdcall; external vecad_dll;
Procedure CadDimStyleGetName (hStyle: Integer; szName: Pointer); stdcall; external vecad_dll;
Procedure CadDimStylePutName (hStyle: Integer; szName: Pchar); stdcall; external vecad_dll;
Function  CadDimStyleGetColor (hStyle: Integer; Item: Integer): Integer; stdcall; external vecad_dll;
Procedure CadDimStylePutColor (hStyle: Integer; Item: Integer; Color: Integer); stdcall; external vecad_dll;
Function  CadDimStyleGetLweight (hStyle: Integer; Item: Integer): Integer; stdcall; external vecad_dll;
Procedure CadDimStylePutLweight (hStyle: Integer; Item: Integer; Lweight: Integer); stdcall; external vecad_dll;
Function  CadDimStyleGetExtBeyond (hStyle: Integer): Double; stdcall; external vecad_dll;
Procedure CadDimStylePutExtBeyond (hStyle: Integer; val: Double); stdcall; external vecad_dll;
Function  CadDimStyleGetExtOffset (hStyle: Integer): Double; stdcall; external vecad_dll;
Procedure CadDimStylePutExtOffset (hStyle: Integer; val: Double); stdcall; external vecad_dll;
Function  CadDimStyleGetArrow (hStyle: Integer; Place: Integer): Integer; stdcall; external vecad_dll;
Procedure CadDimStylePutArrow (hStyle: Integer; Place: Integer; ArrType: Integer); stdcall; external vecad_dll;
Function  CadDimStyleGetArrowSize (hStyle: Integer): Double; stdcall; external vecad_dll;
Procedure CadDimStylePutArrowSize (hStyle: Integer; Size: Double); stdcall; external vecad_dll;
Function  CadDimStyleGetCenMark (hStyle: Integer): Double; stdcall; external vecad_dll;
Procedure CadDimStylePutCenMark (hStyle: Integer; Size: Double); stdcall; external vecad_dll;
Function  CadDimStyleGetTextHeight (hStyle: Integer): Double; stdcall; external vecad_dll;
Procedure CadDimStylePutTextHeight (hStyle: Integer; Height: Double); stdcall; external vecad_dll;
Function  CadDimStyleGetTextGap (hStyle: Integer): Double; stdcall; external vecad_dll;
Procedure CadDimStylePutTextGap (hStyle: Integer; Gap: Double); stdcall; external vecad_dll;
Function  CadDimStyleGetTextStyleID (hStyle: Integer): Integer; stdcall; external vecad_dll;
Procedure CadDimStylePutTextStyleID (hStyle: Integer; Id: Integer); stdcall; external vecad_dll;
Function  CadDimStyleGetTextPlace (hStyle: Integer): Integer; stdcall; external vecad_dll;
Procedure CadDimStylePutTextPlace (hStyle: Integer; Placement: Integer); stdcall; external vecad_dll;
Function  CadDimStyleGetScale (hStyle: Integer): Double; stdcall; external vecad_dll;
Procedure CadDimStylePutScale (hStyle: Integer; Scal: Double); stdcall; external vecad_dll;
Function  CadDimStyleGetRound (hStyle: Integer): Double; stdcall; external vecad_dll;
Procedure CadDimStylePutRound (hStyle: Integer; RoundOff: Double); stdcall; external vecad_dll;
Function  CadDimStyleGetUnits (hStyle: Integer; bAngular: Integer): Integer; stdcall; external vecad_dll;
Procedure CadDimStylePutUnits (hStyle: Integer; bAngular: Integer; UnitsType: Integer); stdcall; external vecad_dll;
Function  CadDimStyleGetPrecision (hStyle: Integer; bAngular: Integer): Integer; stdcall; external vecad_dll;
Procedure CadDimStylePutPrecision (hStyle: Integer; bAngular: Integer; Prec: Integer); stdcall; external vecad_dll;
Function  CadDimStyleGetZeroSup (hStyle: Integer; bAngular: Integer): Integer; stdcall; external vecad_dll;
Procedure CadDimStylePutZeroSup (hStyle: Integer; bAngular: Integer; bSuppress: Integer); stdcall; external vecad_dll;
Function  CadDimStyleGetSeparator (hStyle: Integer): Integer; stdcall; external vecad_dll;
Procedure CadDimStylePutSeparator (hStyle: Integer; DecSep: Integer); stdcall; external vecad_dll;
Procedure CadDimStyleGetPrefix (hStyle: Integer; szPrefix: Pointer); stdcall; external vecad_dll;
Procedure CadDimStylePutPrefix (hStyle: Integer; szPrefix: Pchar); stdcall; external vecad_dll;
Procedure CadDimStyleGetSuffix (hStyle: Integer; szSuffix: Pointer); stdcall; external vecad_dll;
Procedure CadDimStylePutSuffix (hStyle: Integer; szSuffix: Pchar); stdcall; external vecad_dll;
Function  CadGetEntityByCursor (hDwg: Integer): Integer; stdcall; external vecad_dll;
Procedure CadGetEntitiesByPoint (hDwg: Integer; Xwin: Integer; Ywin: Integer; phEnt: Pinteger; pnEnts: Pinteger; iMax: Integer); stdcall; external vecad_dll;
Procedure CadGetEntitiesByRect (hDwg: Integer; Lwin: Integer; Twin: Integer; Rwin: Integer; Bwin: Integer; phEnt: Pinteger; pnEnts: Pinteger; nMax: Integer); stdcall; external vecad_dll;
Function  CadGetEntityByPoint (hDwg: Integer; Xwin: Integer; Ywin: Integer): Integer; stdcall; external vecad_dll;
Function  CadGetEntityByPointIn (hDwg: Integer; Xdisp: Double; Ydisp: Double): Integer; stdcall; external vecad_dll;
Function  CadGetEntityByID (hDwg: Integer; Id: Integer): Integer; stdcall; external vecad_dll;
Function  CadGetEntityByUserData (hDwg: Integer; UserData: Integer): Integer; stdcall; external vecad_dll;
Function  CadGetEntityByPtr (hPtr: Integer): Integer; stdcall; external vecad_dll;
Function  CadGetFirstEntity (hDwg: Integer): Integer; stdcall; external vecad_dll;
Function  CadGetNextEntity (hDwg: Integer; hEnt: Integer): Integer; stdcall; external vecad_dll;
Function  CadGetPickEntity (hDwg: Integer): Integer; stdcall; external vecad_dll;
Function  CadEntityGetID (hEnt: Integer): Integer; stdcall; external vecad_dll;
Function  CadEntityGetType (hEnt: Integer): Integer; stdcall; external vecad_dll;
Function  CadEntityGetLeft (hEnt: Integer): Double; stdcall; external vecad_dll;
Function  CadEntityGetBottom (hEnt: Integer): Double; stdcall; external vecad_dll;
Function  CadEntityGetRight (hEnt: Integer): Double; stdcall; external vecad_dll;
Function  CadEntityGetTop (hEnt: Integer): Double; stdcall; external vecad_dll;
Function  CadEntityGetNumPaths (hEnt: Integer): Integer; stdcall; external vecad_dll;
Function  CadEntityGetPathSize (hEnt: Integer; iPath: Integer): Integer; stdcall; external vecad_dll;
Procedure CadEntityGetVer (hEnt: Integer; iVer: Integer; pX: Pdouble; pY: Pdouble); stdcall; external vecad_dll;
Function  CadEntityGetGrip (hEnt: Integer; iGrip: Integer; pX: Pdouble; pY: Pdouble; pZ: Pdouble): Integer; stdcall; external vecad_dll;
Function  CadEntityGetLayerID (hEnt: Integer): Integer; stdcall; external vecad_dll;
Function  CadEntityPutLayerID (hEnt: Integer; hDwg: Integer; LayerID: Integer): Integer; stdcall; external vecad_dll;
Function  CadEntityGetPageID (hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadEntityPutPageID (hEnt: Integer; PageID: Integer); stdcall; external vecad_dll;
Function  CadEntityGetLinetypeID (hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadEntityPutLinetypeID (hEnt: Integer; Id: Integer); stdcall; external vecad_dll;
Function  CadEntityGetLtScale (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadEntityPutLtScale (hEnt: Integer; lts: Double); stdcall; external vecad_dll;
Function  CadEntityGetColor (hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadEntityPutColor (hEnt: Integer; Color: Integer); stdcall; external vecad_dll;
Function  CadEntityGetLineweight (hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadEntityPutLineweight (hEnt: Integer; lw: Integer); stdcall; external vecad_dll;
Function  CadEntityGetUserData (hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadEntityPutUserData (hEnt: Integer; val: Integer); stdcall; external vecad_dll;
Function  CadEntityGetFilled (hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadEntityPutFilled (hEnt: Integer; bFilled: Integer); stdcall; external vecad_dll;
Function  CadEntityGetBorder (hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadEntityPutBorder (hEnt: Integer; bBorder: Integer); stdcall; external vecad_dll;
Function  CadEntityGetBordColor (hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadEntityPutBordColor (hEnt: Integer; Color: Integer); stdcall; external vecad_dll;
Function  CadEntityGetBlink (hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadEntityPutBlink (hEnt: Integer; bBlink: Integer); stdcall; external vecad_dll;
Function  CadEntityGetVisible (hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadEntityPutVisible (hEnt: Integer; bVisible: Integer); stdcall; external vecad_dll;
Function  CadEntityGetDeleted (hEnt: Integer): Integer; stdcall; external vecad_dll;
Function  CadEntityGetSelected (hDwg: Integer; hEnt: Integer): Integer; stdcall; external vecad_dll;
Function  CadEntityGetLocked (hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadEntityPutLocked (hEnt: Integer; bLock: Integer); stdcall; external vecad_dll;
Procedure CadEntityPutExData (hEnt: Integer; pData: Pointer; nBytes: Integer); stdcall; external vecad_dll;
Function  CadEntityGetExDataSize (hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadEntityGetExData (hEnt: Integer; pData: Pointer); stdcall; external vecad_dll;
Function  CadEntityGetExDataPtr (hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadEntityPutParkData (hEnt: Integer; szPark: Pchar; szWay: Pchar); stdcall; external vecad_dll;
Function  CadEntityGetParkData (hEnt: Integer; szPark: Pointer; szWay: Pointer): Integer; stdcall; external vecad_dll;
Procedure CadEntityErase (hEnt: Integer; bErase: Integer); stdcall; external vecad_dll;
Function  CadEntityCopy (hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadEntityMove (hEnt: Integer; dx: Double; dy: Double; dz: Double); stdcall; external vecad_dll;
Procedure CadEntityMoveGrip (hEnt: Integer; iGrip: Integer; dx: Double; dy: Double; dz: Double); stdcall; external vecad_dll;
Procedure CadEntityScale (hEnt: Integer; x0: Double; y0: Double; z0: Double; Scal: Double); stdcall; external vecad_dll;
Procedure CadEntityRotate (hEnt: Integer; x0: Double; y0: Double; z0: Double; Angle: Double); stdcall; external vecad_dll;
Procedure CadEntityMirror (hEnt: Integer; x0: Double; y0: Double; z0: Double; x1: Double; y1: Double; z1: Double); stdcall; external vecad_dll;
Function  CadEntityExplode (hEnt: Integer; pnOutEnts: Pinteger; pFirstID: Pinteger): Integer; stdcall; external vecad_dll;
Function  CadAddEdge (hEnt: Integer): Integer; stdcall; external vecad_dll;
Function  CadEntityTrim (hEnt: Integer; x: Double; y: Double): Integer; stdcall; external vecad_dll;
Function  CadEntityExtend (hEnt: Integer; x: Double; y: Double): Integer; stdcall; external vecad_dll;
Procedure CadEntityToTop (hEnt: Integer); stdcall; external vecad_dll;
Procedure CadEntityToBottom (hEnt: Integer); stdcall; external vecad_dll;
Procedure CadEntitySwap (hEnt1: Integer; hEnt2: Integer); stdcall; external vecad_dll;
Function  CadAddPoint (hDwg: Integer; X: Double; Y: Double; Z: Double): Integer; stdcall; external vecad_dll;
Function  CadPointGetStyleID (hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadPointPutStyleID (hEnt: Integer; Id: Integer); stdcall; external vecad_dll;
Function  CadPointGetX (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadPointPutX (hEnt: Integer; X: Double); stdcall; external vecad_dll;
Function  CadPointGetY (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadPointPutY (hEnt: Integer; Y: Double); stdcall; external vecad_dll;
Function  CadPointGetZ (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadPointPutZ (hEnt: Integer; Z: Double); stdcall; external vecad_dll;
Procedure CadPointGetCoord (hEnt: Integer; pX: Pdouble; pY: Pdouble; pZ: Pdouble); stdcall; external vecad_dll;
Procedure CadPointPutCoord (hEnt: Integer; X: Double; Y: Double; Z: Double); stdcall; external vecad_dll;
Procedure CadPointGetTextOffset (hEnt: Integer; pDX: Pdouble; pDY: Pdouble; pDZ: Pdouble); stdcall; external vecad_dll;
Procedure CadPointPutTextOffset (hEnt: Integer; DX: Double; DY: Double; DZ: Double); stdcall; external vecad_dll;
Function  CadPointGetTextX (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadPointPutTextX (hEnt: Integer; X: Double); stdcall; external vecad_dll;
Function  CadPointGetTextY (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadPointPutTextY (hEnt: Integer; Y: Double); stdcall; external vecad_dll;
Procedure CadPointGetText (hEnt: Integer; szText: Pointer); stdcall; external vecad_dll;
Procedure CadPointPutText (hEnt: Integer; szText: Pchar); stdcall; external vecad_dll;
Function  CadPointGetTextAngle (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadPointPutTextAngle (hEnt: Integer; Angle: Double); stdcall; external vecad_dll;
Function  CadPointGetBlockAngle (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadPointPutBlockAngle (hEnt: Integer; Angle: Double); stdcall; external vecad_dll;
Function  CadAddLine (hDwg: Integer; x1: Double; y1: Double; z1: Double; x2: Double; y2: Double; z2: Double): Integer; stdcall; external vecad_dll;
Function  CadAddXLine (hDwg: Integer; x: Double; y: Double; z: Double; dx: Double; dy: Double; dz: Double): Integer; stdcall; external vecad_dll;
Function  CadAddRay (hDwg: Integer; x: Double; y: Double; z: Double; dx: Double; dy: Double; dz: Double): Integer; stdcall; external vecad_dll;
Function  CadLineGetX1 (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadLinePutX1 (hEnt: Integer; X: Double); stdcall; external vecad_dll;
Function  CadLineGetY1 (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadLinePutY1 (hEnt: Integer; Y: Double); stdcall; external vecad_dll;
Function  CadLineGetZ1 (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadLinePutZ1 (hEnt: Integer; Z: Double); stdcall; external vecad_dll;
Function  CadLineGetX2 (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadLinePutX2 (hEnt: Integer; X: Double); stdcall; external vecad_dll;
Function  CadLineGetY2 (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadLinePutY2 (hEnt: Integer; Y: Double); stdcall; external vecad_dll;
Function  CadLineGetZ2 (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadLinePutZ2 (hEnt: Integer; Z: Double); stdcall; external vecad_dll;
Procedure CadLineGetPoint1 (hEnt: Integer; pX: Pdouble; pY: Pdouble; pZ: Pdouble); stdcall; external vecad_dll;
Procedure CadLinePutPoint1 (hEnt: Integer; X: Double; Y: Double; Z: Double); stdcall; external vecad_dll;
Procedure CadLineGetPoint2 (hEnt: Integer; pX: Pdouble; pY: Pdouble; pZ: Pdouble); stdcall; external vecad_dll;
Procedure CadLinePutPoint2 (hEnt: Integer; X: Double; Y: Double; Z: Double); stdcall; external vecad_dll;
Function  CadLineIsX (hEnt: Integer): Integer; stdcall; external vecad_dll;
Function  CadLineIsRay (hEnt: Integer): Integer; stdcall; external vecad_dll;
Function  CadAddCircle (hDwg: Integer; X: Double; Y: Double; Z: Double; Radius: Double): Integer; stdcall; external vecad_dll;
Function  CadAddCircle3P (hDwg: Integer; X1: Double; Y1: Double; Z: Double; X2: Double; Y2: Double; X3: Double; Y3: Double): Integer; stdcall; external vecad_dll;
Function  CadAddArc (hDwg: Integer; X: Double; Y: Double; Z: Double; Radius: Double; StartAngle: Double; ArcAngle: Double): Integer; stdcall; external vecad_dll;
Function  CadAddArc3P (hDwg: Integer; X1: Double; Y1: Double; Z: Double; X2: Double; Y2: Double; X3: Double; Y3: Double): Integer; stdcall; external vecad_dll;
Function  CadAddArcCSE (hDwg: Integer; Xc: Double; Yc: Double; Z: Double; Xs: Double; Ys: Double; Xe: Double; Ye: Double; bCCW: Integer): Integer; stdcall; external vecad_dll;
Function  CadAddArcSED (hDwg: Integer; Xs: Double; Ys: Double; Z: Double; Xe: Double; Ye: Double; DirAngle: Double): Integer; stdcall; external vecad_dll;
Function  CadAddArcContinue (hDwg: Integer; hEnt: Integer; Xe: Double; Ye: Double; Z: Double): Integer; stdcall; external vecad_dll;
Function  CadAddEllipse (hDwg: Integer; X: Double; Y: Double; Z: Double; RadH: Double; RadV: Double; RotAngle: Double): Integer; stdcall; external vecad_dll;
Function  CadArcGetType (hEnt: Integer): Integer; stdcall; external vecad_dll;
Function  CadArcGetCenterX (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadArcPutCenterX (hEnt: Integer; X: Double); stdcall; external vecad_dll;
Function  CadArcGetCenterY (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadArcPutCenterY (hEnt: Integer; Y: Double); stdcall; external vecad_dll;
Function  CadArcGetCenterZ (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadArcPutCenterZ (hEnt: Integer; Z: Double); stdcall; external vecad_dll;
Procedure CadArcGetCenter (hEnt: Integer; pX: Pdouble; pY: Pdouble; pZ: Pdouble); stdcall; external vecad_dll;
Procedure CadArcPutCenter (hEnt: Integer; X: Double; Y: Double; Z: Double); stdcall; external vecad_dll;
Function  CadArcGetRadius (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadArcPutRadius (hEnt: Integer; R: Double); stdcall; external vecad_dll;
Function  CadArcGetRadHor (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadArcPutRadHor (hEnt: Integer; R: Double); stdcall; external vecad_dll;
Function  CadArcGetRadVer (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadArcPutRadVer (hEnt: Integer; R: Double); stdcall; external vecad_dll;
Function  CadArcGetStartAngle (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadArcPutStartAngle (hEnt: Integer; Ang: Double); stdcall; external vecad_dll;
Function  CadArcGetAngle (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadArcPutAngle (hEnt: Integer; Ang: Double); stdcall; external vecad_dll;
Function  CadArcGetRotAngle (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadArcPutRotAngle (hEnt: Integer; Ang: Double); stdcall; external vecad_dll;
Function  CadArcGetSector (hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadArcPutSector (hEnt: Integer; bSector: Integer); stdcall; external vecad_dll;
Procedure CadArcGetStartPt (hEnt: Integer; pX: Pdouble; pY: Pdouble; pZ: Pdouble); stdcall; external vecad_dll;
Function  CadArcPutStartPt (hEnt: Integer; X: Double; Y: Double; Z: Double): Integer; stdcall; external vecad_dll;
Procedure CadArcGetEndPt (hEnt: Integer; pX: Pdouble; pY: Pdouble; pZ: Pdouble); stdcall; external vecad_dll;
Function  CadArcPutEndPt (hEnt: Integer; X: Double; Y: Double; Z: Double): Integer; stdcall; external vecad_dll;
Procedure CadArcGetMidPt (hEnt: Integer; pX: Pdouble; pY: Pdouble; pZ: Pdouble); stdcall; external vecad_dll;
Function  CadArcPutMidPt (hEnt: Integer; X: Double; Y: Double; Z: Double): Integer; stdcall; external vecad_dll;
Procedure CadArcGet3Pt (hEnt: Integer; pXsta: Pdouble; pYsta: Pdouble; pZ: Pdouble; pXmid: Pdouble; pYmid: Pdouble; pXend: Pdouble; pYend: Pdouble); stdcall; external vecad_dll;
Function  CadArcPut3Pt (hEnt: Integer; Xsta: Double; Ysta: Double; Z: Double; Xmid: Double; Ymid: Double; Xe: Double; Ye: Double): Integer; stdcall; external vecad_dll;
Procedure CadArcDivide (hEnt: Integer; nPoints: Integer; X: Pdouble; Y: Pdouble); stdcall; external vecad_dll;
Procedure CadClearVertices ; stdcall; external vecad_dll;
Procedure CadAddVertex (X: Double; Y: Double; Z: Double); stdcall; external vecad_dll;
Procedure CadAddVertex2 (X: Double; Y: Double; Z: Double; Prm: Double; StartW: Double; EndW: Double); stdcall; external vecad_dll;
Function  CadAddPolyline (hDwg: Integer; FitType: Integer; bClosed: Integer): Integer; stdcall; external vecad_dll;
Function  CadAddPolylineW (hDwg: Integer; FitType: Integer; bClosed: Integer; Width: Double): Integer; stdcall; external vecad_dll;
Function  CadAddPolygon (hDwg: Integer; Color: Integer; bBorder: Integer): Integer; stdcall; external vecad_dll;
Function  CadAddBoundPolygon (hDwg: Integer; X: Double; Y: Double; Z: Double): Integer; stdcall; external vecad_dll;
Function  CadAddBoundary (hDwg: Integer; X: Double; Y: Double; Z: Double): Integer; stdcall; external vecad_dll;
Function  CadPlineInsertVer (hEnt: Integer; iVer: Integer): Integer; stdcall; external vecad_dll;
Function  CadPlineDeleteVer (hEnt: Integer; iVer: Integer): Integer; stdcall; external vecad_dll;
Function  CadPlineGetNumVers (hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadPlinePutNumVers (hEnt: Integer; nVers: Integer); stdcall; external vecad_dll;
Function  CadPlineGetX (hEnt: Integer; iVer: Integer): Double; stdcall; external vecad_dll;
Procedure CadPlinePutX (hEnt: Integer; iVer: Integer; X: Double); stdcall; external vecad_dll;
Function  CadPlineGetY (hEnt: Integer; iVer: Integer): Double; stdcall; external vecad_dll;
Procedure CadPlinePutY (hEnt: Integer; iVer: Integer; Y: Double); stdcall; external vecad_dll;
Function  CadPlineGetZ (hEnt: Integer; iVer: Integer): Double; stdcall; external vecad_dll;
Procedure CadPlinePutZ (hEnt: Integer; iVer: Integer; Z: Double); stdcall; external vecad_dll;
Procedure CadPlineGetVer (hEnt: Integer; iVer: Integer; pX: Pdouble; pY: Pdouble; pZ: Pdouble); stdcall; external vecad_dll;
Procedure CadPlinePutVer (hEnt: Integer; iVer: Integer; X: Double; Y: Double; Z: Double); stdcall; external vecad_dll;
Function  CadPlineGetPrm (hEnt: Integer; iVer: Integer): Double; stdcall; external vecad_dll;
Procedure CadPlinePutPrm (hEnt: Integer; iVer: Integer; Prm: Double); stdcall; external vecad_dll;
Function  CadPlineGetStartW (hEnt: Integer; iVer: Integer): Double; stdcall; external vecad_dll;
Procedure CadPlinePutStartW (hEnt: Integer; iVer: Integer; Width: Double); stdcall; external vecad_dll;
Function  CadPlineGetEndW (hEnt: Integer; iVer: Integer): Double; stdcall; external vecad_dll;
Procedure CadPlinePutEndW (hEnt: Integer; iVer: Integer; Width: Double); stdcall; external vecad_dll;
Procedure CadPlinePutZ1 (hEnt: Integer; Z: Double); stdcall; external vecad_dll;
Function  CadPlineGetRadius (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadPlinePutRadius (hEnt: Integer; Rad: Double); stdcall; external vecad_dll;
Function  CadPlineGetWidth (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadPlinePutWidth (hEnt: Integer; Width: Double); stdcall; external vecad_dll;
Function  CadPlineGetClosed (hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadPlinePutClosed (hEnt: Integer; bClosed: Integer); stdcall; external vecad_dll;
Function  CadPlineGetFit (hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadPlinePutFit (hEnt: Integer; FitType: Integer); stdcall; external vecad_dll;
Procedure CadPlineGetStartTan (hEnt: Integer; pX: Pdouble; pY: Pdouble; pZ: Pdouble); stdcall; external vecad_dll;
Procedure CadPlinePutStartTan (hEnt: Integer; X: Double; Y: Double; Z: Double); stdcall; external vecad_dll;
Procedure CadPlineGetEndTan (hEnt: Integer; pX: Pdouble; pY: Pdouble; pZ: Pdouble); stdcall; external vecad_dll;
Procedure CadPlinePutEndTan (hEnt: Integer; X: Double; Y: Double; Z: Double); stdcall; external vecad_dll;
Function  CadPlineGetLength (hEnt: Integer): Double; stdcall; external vecad_dll;
Function  CadPlineGetArea (hEnt: Integer): Double; stdcall; external vecad_dll;
Function  CadPlineContainPoint (hEnt: Integer; X: Double; Y: Double): Integer; stdcall; external vecad_dll;
Function  CadPlineGetNearPoint (hEnt: Integer; X: Double; Y: Double; Z: Double; pX: Pdouble; pY: Pdouble; pZ: Pdouble; pDist: Pdouble): Double; stdcall; external vecad_dll;
Function  CadPlineGetDistPoint (hEnt: Integer; Dist: Double; pX: Pdouble; pY: Pdouble; pZ: Pdouble; pDirAngle: Pdouble): Integer; stdcall; external vecad_dll;
Function  CadPlineGetInterPoint (hEnt: Integer; x1: Double; y1: Double; x2: Double; y2: Double; pX: Pdouble; pY: Pdouble; pDist: Pdouble): Integer; stdcall; external vecad_dll;
Function  CadAddRect (hDwg: Integer; X: Double; Y: Double; Z: Double; Width: Double; Height: Double; Angle: Double): Integer; stdcall; external vecad_dll;
Procedure CadRectGetCenter (hEnt: Integer; pX: Pdouble; pY: Pdouble; pZ: Pdouble); stdcall; external vecad_dll;
Procedure CadRectPutCenter (hEnt: Integer; X: Double; Y: Double; Z: Double); stdcall; external vecad_dll;
Function  CadRectGetWidth (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadRectPutWidth (hEnt: Integer; Width: Double); stdcall; external vecad_dll;
Function  CadRectGetHeight (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadRectPutHeight (hEnt: Integer; Height: Double); stdcall; external vecad_dll;
Function  CadRectGetAngle (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadRectPutAngle (hEnt: Integer; Angle: Double); stdcall; external vecad_dll;
Function  CadRectGetRadius (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadRectPutRadius (hEnt: Integer; Radius: Double); stdcall; external vecad_dll;
Function  CadRectGetPrint (hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadRectPutPrint (hEnt: Integer; bPrnRect: Integer); stdcall; external vecad_dll;
Procedure CadRectGetName (hEnt: Integer; szName: Pointer); stdcall; external vecad_dll;
Procedure CadRectPutName (hEnt: Integer; szName: Pchar); stdcall; external vecad_dll;
Function  CadRectPrint (hDwg: Integer; hEnt: Integer; hDC: HDC): Integer; stdcall; external vecad_dll;
Function  CadAddMline (hDwg: Integer; bClosed: Integer): Integer; stdcall; external vecad_dll;
Function  CadMlineInsertVer (hEnt: Integer; iVer: Integer): Integer; stdcall; external vecad_dll;
Function  CadMlineDeleteVer (hEnt: Integer; iVer: Integer): Integer; stdcall; external vecad_dll;
Function  CadMlineGetNumVers (hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadMlinePutNumVers (hEnt: Integer; nVers: Integer); stdcall; external vecad_dll;
Procedure CadMlineGetVer (hEnt: Integer; iVer: Integer; pX: Pdouble; pY: Pdouble; pZ: Pdouble); stdcall; external vecad_dll;
Procedure CadMlinePutVer (hEnt: Integer; iVer: Integer; X: Double; Y: Double; Z: Double); stdcall; external vecad_dll;
Procedure CadMlinePutZ1 (hEnt: Integer; Z: Double); stdcall; external vecad_dll;
Function  CadMlineGetClosed (hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadMlinePutClosed (hEnt: Integer; bClosed: Integer); stdcall; external vecad_dll;
Procedure CadMlinePutScale (hEnt: Integer; Scal: Double); stdcall; external vecad_dll;
Function  CadMlineGetScale (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadMlinePutJust (hEnt: Integer; Just: Integer); stdcall; external vecad_dll;
Function  CadMlineGetJust (hEnt: Integer): Integer; stdcall; external vecad_dll;
Function  CadMlineGetLength (hEnt: Integer): Double; stdcall; external vecad_dll;
Function  CadMlineGetStyleID (hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadMlinePutStyleID (hEnt: Integer; Id: Integer); stdcall; external vecad_dll;
Function  CadSetTextAlign (hDwg: Integer; Align: Integer): Integer; stdcall; external vecad_dll;
Function  CadSetTextHeight (hDwg: Integer; Height: Double): Double; stdcall; external vecad_dll;
Function  CadSetTextWidth (hDwg: Integer; Width: Double): Double; stdcall; external vecad_dll;
Function  CadSetTextRotAngle (hDwg: Integer; Angle: Double): Double; stdcall; external vecad_dll;
Function  CadSetTextOblique (hDwg: Integer; Angle: Double): Double; stdcall; external vecad_dll;
Function  CadSetTextUpsideDown (hDwg: Integer; bUpDown: Integer): Integer; stdcall; external vecad_dll;
Function  CadSetTextBackward (hDwg: Integer; bBack: Integer): Integer; stdcall; external vecad_dll;
Function  CadAddText (hDwg: Integer; szText: Pchar; X: Double; Y: Double; Z: Double): Integer; stdcall; external vecad_dll;
Function  CadAddText2 (hDwg: Integer; szText: Pchar; X: Double; Y: Double; Z: Double; Align: Integer; H: Double; W: Double; RotAngle: Double; Oblique: Double): Integer; stdcall; external vecad_dll;
Function  CadTextGetStyleID (hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadTextPutStyleID (hEnt: Integer; Id: Integer); stdcall; external vecad_dll;
Function  CadTextGetX (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadTextPutX (hEnt: Integer; X: Double); stdcall; external vecad_dll;
Function  CadTextGetY (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadTextPutY (hEnt: Integer; Y: Double); stdcall; external vecad_dll;
Function  CadTextGetZ (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadTextPutZ (hEnt: Integer; Z: Double); stdcall; external vecad_dll;
Procedure CadTextGetPoint (hEnt: Integer; pX: Pdouble; pY: Pdouble; pZ: Pdouble); stdcall; external vecad_dll;
Procedure CadTextPutPoint (hEnt: Integer; X: Double; Y: Double; Z: Double); stdcall; external vecad_dll;
Function  CadTextGetLen (hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadTextGetText (hEnt: Integer; szText: Pointer; MaxChars: Integer); stdcall; external vecad_dll;
Procedure CadTextPutText (hEnt: Integer; szText: Pchar); stdcall; external vecad_dll;
Function  CadTextGetAngle (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadTextPutAngle (hEnt: Integer; Angle: Double); stdcall; external vecad_dll;
Function  CadTextGetHeight (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadTextPutHeight (hEnt: Integer; Height: Double); stdcall; external vecad_dll;
Function  CadTextGetWidth (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadTextPutWidth (hEnt: Integer; Width: Double); stdcall; external vecad_dll;
Function  CadTextGetOblique (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadTextPutOblique (hEnt: Integer; Angle: Double); stdcall; external vecad_dll;
Function  CadTextGetAlign (hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadTextPutAlign (hEnt: Integer; Align: Integer); stdcall; external vecad_dll;
Function  CadTextGetBackward (hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadTextPutBackward (hEnt: Integer; bBackward: Integer); stdcall; external vecad_dll;
Function  CadTextGetUpsideDown (hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadTextPutUpsideDown (hEnt: Integer; bUpsideDown: Integer); stdcall; external vecad_dll;
Function  CadTextGetBoxWidth (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadTextGetPoint0 (hEnt: Integer; pX: Pdouble; pY: Pdouble; pZ: Pdouble); stdcall; external vecad_dll;
Function  CadAddMText (hDwg: Integer; szText: Pchar; RectWidth: Double; X: Double; Y: Double; Z: Double; Align: Integer; RotAngle: Double): Integer; stdcall; external vecad_dll;
Function  CadMTextGetStyleID (hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadMTextPutStyleID (hEnt: Integer; Id: Integer); stdcall; external vecad_dll;
Procedure CadMTextGetPoint (hEnt: Integer; pX: Pdouble; pY: Pdouble; pZ: Pdouble); stdcall; external vecad_dll;
Procedure CadMTextPutPoint (hEnt: Integer; X: Double; Y: Double; Z: Double); stdcall; external vecad_dll;
Function  CadMTextGetLen (hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadMTextGetText (hEnt: Integer; szText: Pointer; MaxChars: Integer); stdcall; external vecad_dll;
Procedure CadMTextPutText (hEnt: Integer; szText: Pchar); stdcall; external vecad_dll;
Function  CadMTextGetRectWidth (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadMTextPutRectWidth (hEnt: Integer; RectWidth: Double); stdcall; external vecad_dll;
Function  CadMTextGetAlign (hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadMTextPutAlign (hEnt: Integer; Align: Integer); stdcall; external vecad_dll;
Function  CadMTextGetHeight (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadMTextPutHeight (hEnt: Integer; Height: Double); stdcall; external vecad_dll;
Function  CadMTextGetAngle (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadMTextPutAngle (hEnt: Integer; Angle: Double); stdcall; external vecad_dll;
Function  CadMTextGetWidth (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadMTextPutWidth (hEnt: Integer; Width: Double); stdcall; external vecad_dll;
Function  CadMTextGetLineSpace (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadMTextPutLineSpace (hEnt: Integer; LineSpace: Double); stdcall; external vecad_dll;
Function  CadMTextGetAW (hEnt: Integer): Double; stdcall; external vecad_dll;
Function  CadMTextGetAH (hEnt: Integer): Double; stdcall; external vecad_dll;
Function  CadAddWText (hDwg: Integer; szText: Pchar; X: Double; Y: Double; Z: Double): Integer; stdcall; external vecad_dll;
Function  CadAddWText2 (hDwg: Integer; szText: Pchar; X: Double; Y: Double; Z: Double; Align: Integer; H: Double; RotAngle: Double; bItalic: Integer; bUnderline: Integer; bStrikeout: Integer): Integer; stdcall; external vecad_dll;
Function  CadWTextGetStyleID (hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadWTextPutStyleID (hEnt: Integer; Id: Integer); stdcall; external vecad_dll;
Procedure CadWTextGetPoint (hEnt: Integer; pX: Pdouble; pY: Pdouble; pZ: Pdouble); stdcall; external vecad_dll;
Procedure CadWTextPutPoint (hEnt: Integer; X: Double; Y: Double; Z: Double); stdcall; external vecad_dll;
Function  CadWTextGetLen (hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadWTextGetText (hEnt: Integer; szText: Pointer; MaxChars: Integer); stdcall; external vecad_dll;
Procedure CadWTextPutText (hEnt: Integer; szText: Pchar); stdcall; external vecad_dll;
Function  CadWTextGetAngle (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadWTextPutAngle (hEnt: Integer; Angle: Double); stdcall; external vecad_dll;
Function  CadWTextGetHeight (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadWTextPutHeight (hEnt: Integer; Height: Double); stdcall; external vecad_dll;
Function  CadWTextGetAlign (hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadWTextPutAlign (hEnt: Integer; Align: Integer); stdcall; external vecad_dll;
Function  CadWTextGetItalic (hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadWTextPutItalic (hEnt: Integer; bItalic: Integer); stdcall; external vecad_dll;
Function  CadWTextGetStrikeout (hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadWTextPutStrikeout (hEnt: Integer; bStrikeout: Integer); stdcall; external vecad_dll;
Function  CadWTextGetUnderline (hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadWTextPutUnderline (hEnt: Integer; bUnderline: Integer); stdcall; external vecad_dll;
Function  CadAddInsBlock (hDwg: Integer; idBlock: Integer; X: Double; Y: Double; Z: Double; Scal: Double; Angle: Double): Integer; stdcall; external vecad_dll;
Function  CadAddInsBlockM (hDwg: Integer; idBlock: Integer; X: Double; Y: Double; Z: Double; Scal: Double; Angle: Double; NumCols: Integer; NumRows: Integer; ColDist: Double; RowDist: Double): Integer; stdcall; external vecad_dll;
Function  CadInsBlockGetBlockID (hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadInsBlockPutBlockID (hEnt: Integer; Id: Integer); stdcall; external vecad_dll;
Function  CadInsBlockGetX (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadInsBlockPutX (hEnt: Integer; X: Double); stdcall; external vecad_dll;
Function  CadInsBlockGetY (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadInsBlockPutY (hEnt: Integer; Y: Double); stdcall; external vecad_dll;
Function  CadInsBlockGetZ (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadInsBlockPutZ (hEnt: Integer; Z: Double); stdcall; external vecad_dll;
Procedure CadInsBlockGetPoint (hEnt: Integer; pX: Pdouble; pY: Pdouble; pZ: Pdouble); stdcall; external vecad_dll;
Procedure CadInsBlockPutPoint (hEnt: Integer; X: Double; Y: Double; Z: Double); stdcall; external vecad_dll;
Function  CadInsBlockGetScale (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadInsBlockPutScale (hEnt: Integer; Scal: Double); stdcall; external vecad_dll;
Function  CadInsBlockGetScaleX (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadInsBlockPutScaleX (hEnt: Integer; Sx: Double); stdcall; external vecad_dll;
Function  CadInsBlockGetScaleY (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadInsBlockPutScaleY (hEnt: Integer; Sy: Double); stdcall; external vecad_dll;
Function  CadInsBlockGetScaleZ (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadInsBlockPutScaleZ (hEnt: Integer; Sz: Double); stdcall; external vecad_dll;
Function  CadInsBlockGetAngle (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadInsBlockPutAngle (hEnt: Integer; Angle: Double); stdcall; external vecad_dll;
Function  CadInsBlockGetNumRows (hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadInsBlockPutNumRows (hEnt: Integer; NumRows: Integer); stdcall; external vecad_dll;
Function  CadInsBlockGetNumCols (hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadInsBlockPutNumCols (hEnt: Integer; NumCols: Integer); stdcall; external vecad_dll;
Function  CadInsBlockGetRowDist (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadInsBlockPutRowDist (hEnt: Integer; RowDist: Double); stdcall; external vecad_dll;
Function  CadInsBlockGetColDist (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadInsBlockPutColDist (hEnt: Integer; ColDist: Double); stdcall; external vecad_dll;
Function  CadInsBlockHasAttribs (hEnt: Integer): Integer; stdcall; external vecad_dll;
Function  CadInsBlockGetFirstAtt (hEnt: Integer): Integer; stdcall; external vecad_dll;
Function  CadInsBlockGetNextAtt (hEnt: Integer; hAtt: Integer): Integer; stdcall; external vecad_dll;
Function  CadAddAttrib (hDwg: Integer; szTag: Pchar; szDefValue: Pchar; X: Double; Y: Double; Z: Double): Integer; stdcall; external vecad_dll;
Function  CadAttGetStyleID (hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadAttPutStyleID (hEnt: Integer; Id: Integer); stdcall; external vecad_dll;
Procedure CadAttGetPoint (hEnt: Integer; pX: Pdouble; pY: Pdouble; pZ: Pdouble); stdcall; external vecad_dll;
Procedure CadAttPutPoint (hEnt: Integer; X: Double; Y: Double; Z: Double); stdcall; external vecad_dll;
Procedure CadAttGetTag (hEnt: Integer; szText: Pointer; MaxChars: Integer); stdcall; external vecad_dll;
Procedure CadAttPutTag (hEnt: Integer; szText: Pchar); stdcall; external vecad_dll;
Procedure CadAttGetPrompt (hEnt: Integer; szText: Pointer; MaxChars: Integer); stdcall; external vecad_dll;
Procedure CadAttPutPrompt (hEnt: Integer; szText: Pchar); stdcall; external vecad_dll;
Procedure CadAttGetDefValue (hEnt: Integer; szText: Pointer; MaxChars: Integer); stdcall; external vecad_dll;
Procedure CadAttPutDefValue (hEnt: Integer; szText: Pchar); stdcall; external vecad_dll;
Procedure CadAttGetValue (hEnt: Integer; szText: Pointer; MaxChars: Integer); stdcall; external vecad_dll;
Procedure CadAttPutValue (hEnt: Integer; szText: Pchar); stdcall; external vecad_dll;
Function  CadAttGetAngle (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadAttPutAngle (hEnt: Integer; Angle: Double); stdcall; external vecad_dll;
Function  CadAttGetHeight (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadAttPutHeight (hEnt: Integer; Height: Double); stdcall; external vecad_dll;
Function  CadAttGetWidth (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadAttPutWidth (hEnt: Integer; Width: Double); stdcall; external vecad_dll;
Function  CadAttGetOblique (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadAttPutOblique (hEnt: Integer; Angle: Double); stdcall; external vecad_dll;
Function  CadAttGetAlign (hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadAttPutAlign (hEnt: Integer; Align: Integer); stdcall; external vecad_dll;
Function  CadAttGetBackward (hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadAttPutBackward (hEnt: Integer; bBackward: Integer); stdcall; external vecad_dll;
Function  CadAttGetUpsideDown (hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadAttPutUpsideDown (hEnt: Integer; bUpsideDown: Integer); stdcall; external vecad_dll;
Function  CadAttGetMode (hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadAttPutMode (hEnt: Integer; Mode: Integer); stdcall; external vecad_dll;
Function  CadAddImage (hDwg: Integer; szFileName: Pchar; X: Double; Y: Double; Z: Double; Scal: Double): Integer; stdcall; external vecad_dll;
Function  CadAddImagePlace (hDwg: Integer; Id: Integer; Width: Integer; Height: Integer; X: Double; Y: Double; Z: Double; Scal: Double): Integer; stdcall; external vecad_dll;
Procedure CadImageGetFile (hEnt: Integer; szFileName: Pointer); stdcall; external vecad_dll;
Procedure CadImagePutFile (hEnt: Integer; szFileName: Pchar); stdcall; external vecad_dll;
Function  CadImageGetX (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadImagePutX (hEnt: Integer; X: Double); stdcall; external vecad_dll;
Function  CadImageGetY (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadImagePutY (hEnt: Integer; Y: Double); stdcall; external vecad_dll;
Function  CadImageGetZ (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadImagePutZ (hEnt: Integer; Z: Double); stdcall; external vecad_dll;
Procedure CadImageGetPoint (hEnt: Integer; pX: Pdouble; pY: Pdouble; pZ: Pdouble); stdcall; external vecad_dll;
Procedure CadImagePutPoint (hEnt: Integer; X: Double; Y: Double; Z: Double); stdcall; external vecad_dll;
Function  CadImageGetScale (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadImagePutScale (hEnt: Integer; Scal: Double); stdcall; external vecad_dll;
Function  CadImageGetScaleX (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadImagePutScaleX (hEnt: Integer; Sx: Double); stdcall; external vecad_dll;
Function  CadImageGetScaleY (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadImagePutScaleY (hEnt: Integer; Sy: Double); stdcall; external vecad_dll;
Procedure CadImagePutSize (hEnt: Integer; Width: Integer; Height: Integer); stdcall; external vecad_dll;
Function  CadImageGetTransparent (hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadImagePutTransparent (hEnt: Integer; bTransp: Integer); stdcall; external vecad_dll;
Function  CadImageGetTColor (hEnt: Integer): COLORREF; stdcall; external vecad_dll;
Procedure CadImagePutTColor (hEnt: Integer; ColorRGB: COLORREF); stdcall; external vecad_dll;
Function  CadAddHatchPoint (hDwg: Integer; X: Double; Y: Double): Integer; stdcall; external vecad_dll;
Function  CadAddHatchPath (hDwg: Integer; hEnt: Integer): Integer; stdcall; external vecad_dll;
Function  CadAddHatch (hDwg: Integer; szFileName: Pchar; szPatName: Pchar; Scal: Double; Angle: Double): Integer; stdcall; external vecad_dll;
Function  CadEngrave (hDwg: Integer; bSelected: Integer; szBlockName: Pchar; Step: Double; Angle: Double): Integer; stdcall; external vecad_dll;
Procedure CadHatchPutPattern (hEnt: Integer; szFileName: Pchar; szPatName: Pchar); stdcall; external vecad_dll;
Procedure CadHatchGetName (hEnt: Integer; szName: Pointer); stdcall; external vecad_dll;
Function  CadHatchGetPattern (hEnt: Integer; szPattern: Pointer): Integer; stdcall; external vecad_dll;
Procedure CadHatchPutScale (hEnt: Integer; Scal: Double); stdcall; external vecad_dll;
Function  CadHatchGetScale (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadHatchPutAngle (hEnt: Integer; Angle: Double); stdcall; external vecad_dll;
Function  CadHatchGetAngle (hEnt: Integer): Double; stdcall; external vecad_dll;
Function  CadHatchGetSize (hEnt: Integer): Double; stdcall; external vecad_dll;
Function  CadAddDimPoint (Index: Integer; X: Double; Y: Double; Z: Double): Integer; stdcall; external vecad_dll;
Function  CadAddDim (hDwg: Integer; DimType: Integer): Integer; stdcall; external vecad_dll;
Function  CadDimGetStyleID (hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadDimPutStyleID (hEnt: Integer; Id: Integer); stdcall; external vecad_dll;
Procedure CadDimPutText (hEnt: Integer; szText: Pchar); stdcall; external vecad_dll;
Procedure CadDimGetText (hEnt: Integer; szText: Pointer); stdcall; external vecad_dll;
Procedure CadDimGetPoint (hEnt: Integer; Index: Integer; pX: Pdouble; pY: Pdouble; pZ: Pdouble); stdcall; external vecad_dll;
Procedure CadDimPutPoint (hEnt: Integer; Index: Integer; X: Double; Y: Double; Z: Double); stdcall; external vecad_dll;
Function  CadDimGetType (hEnt: Integer): Integer; stdcall; external vecad_dll;
Function  CadDimGetValue (hEnt: Integer): Double; stdcall; external vecad_dll;
Function  CadAddLeader (hDwg: Integer; szText: Pchar): Integer; stdcall; external vecad_dll;
Function  CadLeaderGetNumVers (hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadLeaderPutNumVers (hEnt: Integer; nVers: Integer); stdcall; external vecad_dll;
Procedure CadLeaderGetVer (hEnt: Integer; iVer: Integer; pX: Pdouble; pY: Pdouble; pZ: Pdouble); stdcall; external vecad_dll;
Procedure CadLeaderPutVer (hEnt: Integer; iVer: Integer; X: Double; Y: Double; Z: Double); stdcall; external vecad_dll;
Function  CadLeaderGetSpline (hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadLeaderPutSpline (hEnt: Integer; bSpline: Integer); stdcall; external vecad_dll;
Function  CadLeaderGetTextLen (hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadLeaderGetText (hEnt: Integer; szText: Pointer; MaxChars: Integer); stdcall; external vecad_dll;
Procedure CadLeaderPutText (hEnt: Integer; szText: Pchar); stdcall; external vecad_dll;
Function  CadLeaderGetTextH (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadLeaderPutTextH (hEnt: Integer; Height: Double); stdcall; external vecad_dll;
Function  CadLeaderGetArrSize (hEnt: Integer): Double; stdcall; external vecad_dll;
Procedure CadLeaderPutArrSize (hEnt: Integer; Size: Double); stdcall; external vecad_dll;
Function  CadAddFace (hDwg: Integer): Integer; stdcall; external vecad_dll;
Function  CadFaceGetNumVers (hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadFaceGetVer (hEnt: Integer; iVer: Integer; pX: Pdouble; pY: Pdouble; pZ: Pdouble); stdcall; external vecad_dll;
Procedure CadFacePutVer (hEnt: Integer; iVer: Integer; X: Double; Y: Double; Z: Double); stdcall; external vecad_dll;
Function  CadFaceGetEdge (hEnt: Integer; iEdge: Integer): Integer; stdcall; external vecad_dll;
Procedure CadFacePutEdge (hEnt: Integer; iEdge: Integer; bVisible: Integer); stdcall; external vecad_dll;
Function  CadAddVport (hDwg: Integer; X: Double; Y: Double; W: Double; H: Double): Integer; stdcall; external vecad_dll;
Function  CadAddCustom (hDwg: Integer; CustType: Integer; pData: Pointer; nBytes: Integer): Integer; stdcall; external vecad_dll;
Procedure CadCustomPutOwner (hEnt: Integer; pObject: Pointer); stdcall; external vecad_dll;
Function  CadCustomGetOwner (hEnt: Integer): Integer; stdcall; external vecad_dll;
Function  CadCustomGetType (hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadCustomPutData (hEnt: Integer; pData: Pointer; nBytes: Integer); stdcall; external vecad_dll;
Procedure CadCustomGetData (hEnt: Integer; pData: Pointer); stdcall; external vecad_dll;
Function  CadCustomGetSize (hEnt: Integer): Integer; stdcall; external vecad_dll;
Function  CadCustomGetDataPtr (hEnt: Integer): Integer; stdcall; external vecad_dll;
Procedure CadDrawSet (Mode: Integer; Value: Integer); stdcall; external vecad_dll;
Function  CadDrawGetDC : HDC; stdcall; external vecad_dll;
Procedure CadDrawAddVertex (X: Double; Y: Double; Z: Double); stdcall; external vecad_dll;
Function  CadDrawGenArc (Xcen: Double; Ycen: Double; Zcen: Double; Radius: Double; AngStart: Double; AngArc: Double; nVers: Integer): Integer; stdcall; external vecad_dll;
Function  CadDrawGenCircle (X: Double; Y: Double; Z: Double; Radius: Double; nVers: Integer): Integer; stdcall; external vecad_dll;
Function  CadDrawGenChar (X: Double; Y: Double; Z: Double; Height: Double; Angle: Double; ScaleW: Double; UCode: Integer; szFont: Pchar; nVers: Integer): Integer; stdcall; external vecad_dll;
Procedure CadDrawPolyline ; stdcall; external vecad_dll;
Procedure CadDrawPolygon ; stdcall; external vecad_dll;
Procedure CadDrawPolyPolygon (PlineSize: Pinteger; nPline: Integer); stdcall; external vecad_dll;
Procedure CadDrawLine (X1: Double; Y1: Double; Z1: Double; X2: Double; Y2: Double; Z2: Double); stdcall; external vecad_dll;
Procedure CadDrawPoint (X: Double; Y: Double; Z: Double; PtMode: Integer; PtSize: Double); stdcall; external vecad_dll;
Procedure CadDrawText (hDwg: Integer; szText: Pchar; X: Double; Y: Double; Z: Double); stdcall; external vecad_dll;
Procedure CadDrawBlock (hDwg: Integer; hBlock: Integer; X: Double; Y: Double; Z: Double; ScaleX: Double; ScaleY: Double; ScaleZ: Double; RotAngle: Double); stdcall; external vecad_dll;
Procedure CadDrawObject (Xcen: Double; Ycen: Double; Zcen: Double; W: Double; H: Double; fnDraw: Pointer; ptr: Pointer); stdcall; external vecad_dll;
Function  CadAddCustProp (IdProp: Integer; szName: Pchar; szValue: Pchar; ValType: Integer): Integer; stdcall; external vecad_dll;
Function  CadSetCustProp (IdProp: Integer; szValue: Pchar): Integer; stdcall; external vecad_dll;
Function  CadSetCustPropMode (IdProp: Integer; bReadOnly: Integer): Integer; stdcall; external vecad_dll;
Function  CadAddCommand (hDwg: Integer; Id: Integer; szCmdName: Pchar; szAlias: Pchar; hCurs: HCURSOR; pFunc1: Pointer; pFunc2: Pointer): Integer; stdcall; external vecad_dll;
Procedure CadCmdPutData (hDwg: Integer; pData: Pointer; nBytes: Integer); stdcall; external vecad_dll;
Procedure CadCmdGetData (hDwg: Integer; pData: Pointer); stdcall; external vecad_dll;
Function  CadCmdGetSize (hDwg: Integer): Integer; stdcall; external vecad_dll;
Procedure CadCmdPrompt (hDwg: Integer; szText: Pchar; szDefaultVal: Pchar); stdcall; external vecad_dll;
Procedure CadCmdPromptAdd (hDwg: Integer; szValue: Pchar); stdcall; external vecad_dll;
Function  CadCmdUserSelect (hDwg: Integer): Integer; stdcall; external vecad_dll;
Function  CadCmdUserGetEntity (hDwg: Integer): Integer; stdcall; external vecad_dll;
Function  CadCmdUserInput (hDwg: Integer): Integer; stdcall; external vecad_dll;
Procedure CadCmdGetInputPoint (hDwg: Integer; pX: Pdouble; pY: Pdouble; pZ: Pdouble); stdcall; external vecad_dll;
Procedure CadCmdGetInputStr (hDwg: Integer; szText: Pointer); stdcall; external vecad_dll;
Function  CadCmdStrToPoint (hDwg: Integer; szValue: Pchar; pX: Pdouble; pY: Pdouble; pZ: Pdouble): Integer; stdcall; external vecad_dll;
Procedure CadCmdSetBasePoint (hDwg: Integer; X: Double; Y: Double; Z: Double); stdcall; external vecad_dll;
Function  CadCmdAddPoint (hDwg: Integer; X: Double; Y: Double; Z: Double): Integer; stdcall; external vecad_dll;
Function  CadCmdGetPoint (hDwg: Integer; iPoint: Integer; pX: Pdouble; pY: Pdouble; pZ: Pdouble): Integer; stdcall; external vecad_dll;
Function  CadCmdCountPoints (hDwg: Integer): Integer; stdcall; external vecad_dll;
Procedure CadSelClear (hDwg: Integer); stdcall; external vecad_dll;
Procedure CadSelectEntity (hDwg: Integer; hEnt: Integer; bSelect: Integer); stdcall; external vecad_dll;
Function  CadSelectByLayer (hDwg: Integer; bSelect: Integer): Integer; stdcall; external vecad_dll;
Function  CadSelectByPage (hDwg: Integer; bSelect: Integer): Integer; stdcall; external vecad_dll;
Function  CadSelectByPolyline (hDwg: Integer; hEnt: Integer; bSelect: Integer): Integer; stdcall; external vecad_dll;
Function  CadSelectByPolygon (hDwg: Integer; hEnt: Integer; bCross: Integer; bSelect: Integer): Integer; stdcall; external vecad_dll;
Function  CadSelectByDist (hDwg: Integer; X: Double; Y: Double; Z: Double; Dist: Double; bCross: Integer; bSelect: Integer): Integer; stdcall; external vecad_dll;
Function  CadSelCount (hDwg: Integer): Integer; stdcall; external vecad_dll;
Function  CadSelGetFirstPtr (hDwg: Integer): Integer; stdcall; external vecad_dll;
Function  CadSelGetNextPtr (hDwg: Integer; hPtr: Integer): Integer; stdcall; external vecad_dll;
Procedure CadSelErase (hDwg: Integer); stdcall; external vecad_dll;
Procedure CadSelCopy (hDwg: Integer); stdcall; external vecad_dll;
Procedure CadSelMove (hDwg: Integer; dx: Double; dy: Double; dz: Double); stdcall; external vecad_dll;
Procedure CadSelScale (hDwg: Integer; x0: Double; y0: Double; z0: Double; Scal: Double); stdcall; external vecad_dll;
Procedure CadSelRotate (hDwg: Integer; x0: Double; y0: Double; z0: Double; Angle: Double); stdcall; external vecad_dll;
Procedure CadSelMirror (hDwg: Integer; x0: Double; y0: Double; z0: Double; x1: Double; y1: Double; z1: Double); stdcall; external vecad_dll;
Procedure CadSelExplode (hDwg: Integer); stdcall; external vecad_dll;
Function  CadSelJoin (hDwg: Integer; Delta: Double): Integer; stdcall; external vecad_dll;
Procedure CadSelColor (hDwg: Integer; Color: Integer); stdcall; external vecad_dll;
Procedure CadSelDraw (hDwg: Integer; hDC: HDC; WinLef: Integer; WinBot: Integer; WinW: Integer; WinH: Integer; ViewLef: Double; ViewBot: Double; ViewW: Double; ViewH: Double; idPage: Integer; FillColor: COLORREF; BordColor: COLORREF; LwScale: Double); stdcall; external vecad_dll;
Procedure CadSelMakeGrips (hDwg: Integer); stdcall; external vecad_dll;
Function  CadCbPaste (hDwg: Integer; hWnd: HWND; dx: Double; dy: Double; dz: Double): Integer; stdcall; external vecad_dll;
Function  CadCountEntities (hDwg: Integer): Integer; stdcall; external vecad_dll;
Procedure CadViewPutPoint (hDwg: Integer; hWin: HWND; X: Double; Y: Double; Z: Double); stdcall; external vecad_dll;
Procedure CadViewGetPoint (hDwg: Integer; hWin: HWND; pX: Pdouble; pY: Pdouble; pZ: Pdouble); stdcall; external vecad_dll;
Function  CadViewGetPointX (hDwg: Integer): Double; stdcall; external vecad_dll;
Function  CadViewGetPointY (hDwg: Integer): Double; stdcall; external vecad_dll;
Function  CadViewGetPointZ (hDwg: Integer): Double; stdcall; external vecad_dll;
Procedure CadViewPutAngles (hDwg: Integer; hWin: HWND; AngHor: Double; AngVer: Double); stdcall; external vecad_dll;
Function  CadViewGetAngleHor (hDwg: Integer): Double; stdcall; external vecad_dll;
Function  CadViewGetAngleVer (hDwg: Integer): Double; stdcall; external vecad_dll;
Procedure CadViewRect (hDwg: Integer; hWin: HWND; Xmin: Double; Ymin: Double; Xmax: Double; Ymax: Double); stdcall; external vecad_dll;
Procedure CadViewScale (hDwg: Integer; hWin: HWND; Scal: Double; Xcen: Integer; Ycen: Integer); stdcall; external vecad_dll;
Procedure CadCoordModelToDisp (hDwg: Integer; Xm: Double; Ym: Double; Zm: Double; pXd: Pdouble; pYd: Pdouble); stdcall; external vecad_dll;
Procedure CadCoordModelToWin (hDwg: Integer; Xm: Double; Ym: Double; Zm: Double; pXw: Pinteger; pYw: Pinteger); stdcall; external vecad_dll;
Procedure CadCoordDispToModel (hDwg: Integer; Xd: Double; Yd: Double; pXm: Pdouble; pYm: Pdouble; pZm: Pdouble); stdcall; external vecad_dll;
Procedure CadCoordDispToWin (hDwg: Integer; Xd: Double; Yd: Double; pXw: Pinteger; pYw: Pinteger); stdcall; external vecad_dll;
Procedure CadCoordWinToModel (hDwg: Integer; Xw: Integer; Yw: Integer; pXm: Pdouble; pYm: Pdouble; pZm: Pdouble); stdcall; external vecad_dll;
Procedure CadCoordWinToDisp (hDwg: Integer; Xw: Integer; Yw: Integer; pXd: Pdouble; pYd: Pdouble); stdcall; external vecad_dll;
Function  CadDistWinToModel (hDwg: Integer; Dwin: Integer): Double; stdcall; external vecad_dll;
Function  CadDistModelToWin (hDwg: Integer; Dmod: Double): Integer; stdcall; external vecad_dll;
Procedure CadPrintGetRect (pLeft: Pdouble; pBottom: Pdouble; pRight: Pdouble; pTop: Pdouble); stdcall; external vecad_dll;
Procedure CadPrintPutRect (Left: Double; Bottom: Double; Right: Double; Top: Double); stdcall; external vecad_dll;
Procedure CadPrintPutScale (Scal: Double); stdcall; external vecad_dll;
Function  CadPrintGetScale : Double; stdcall; external vecad_dll;
Procedure CadPrintPutScaleLW (bScaleLW: Integer); stdcall; external vecad_dll;
Function  CadPrintGetScaleLW : Integer; stdcall; external vecad_dll;
Procedure CadPrintPutOffset (DX: Double; DY: Double); stdcall; external vecad_dll;
Procedure CadPrintGetOffset (pDX: Pdouble; pDY: Pdouble); stdcall; external vecad_dll;
Procedure CadPrintPutColor (bColor: Integer); stdcall; external vecad_dll;
Function  CadPrintGetColor : Integer; stdcall; external vecad_dll;
Procedure CadPrintPutCopies (Ncopy: Integer); stdcall; external vecad_dll;
Function  CadPrintGetCopies : Integer; stdcall; external vecad_dll;
Procedure CadPrintPutOrient (Orient: Integer); stdcall; external vecad_dll;
Function  CadPrintGetOrient : Integer; stdcall; external vecad_dll;
Procedure CadPrintPutStampPos (Pos: Integer); stdcall; external vecad_dll;
Function  CadPrintGetStampPos : Integer; stdcall; external vecad_dll;
Procedure CadPrintPutStampSize (TextHeight: Double); stdcall; external vecad_dll;
Function  CadPrintGetStampSize : Double; stdcall; external vecad_dll;
Procedure CadPrintPutStampColor (Color: Integer); stdcall; external vecad_dll;
Function  CadPrintGetStampColor : Integer; stdcall; external vecad_dll;
Procedure CadPrintPutStampText (szText1: Pchar; szText2: Pchar); stdcall; external vecad_dll;
Procedure CadPrintGetStampText (szText1: Pointer; szText2: Pointer); stdcall; external vecad_dll;
Procedure CadPrintAtCenter (bCenter: Integer); stdcall; external vecad_dll;
Function  CadPrint (hDwg: Integer; bPrintStamp: Integer; hDC: HDC): Integer; stdcall; external vecad_dll;
Function  CadPrintSetup (hwParent: HWND): Integer; stdcall; external vecad_dll;
Function  CadPrintGetPaperW : Double; stdcall; external vecad_dll;
Function  CadPrintGetPaperH : Double; stdcall; external vecad_dll;
Procedure CadPrintGetPaperSize (pWidth: Pdouble; pHeight: Pdouble); stdcall; external vecad_dll;
Function  CadPrnRectAdd (hDwg: Integer; szName: Pchar; Xcen: Double; Ycen: Double; W: Double; H: Double; Angle: Double): Integer; stdcall; external vecad_dll;
Function  CadPrnRectDelete (hDwg: Integer; iRect: Integer): Integer; stdcall; external vecad_dll;
Function  CadPrnRectCount (hDwg: Integer): Integer; stdcall; external vecad_dll;
Function  CadPrnRectGet (hDwg: Integer; iRect: Integer; szName: Pointer; pXcen: Pdouble; pYcen: Pdouble; pW: Pdouble; pH: Pdouble; pAngle: Pdouble): Integer; stdcall; external vecad_dll;
Function  CadPrnRectPut (hDwg: Integer; iRect: Integer; szName: Pchar; Xcen: Double; Ycen: Double; W: Double; H: Double; Angle: Double): Integer; stdcall; external vecad_dll;
Function  CadPrnRectPrint (hDwg: Integer; iRect: Integer; hDC: HDC): Integer; stdcall; external vecad_dll;
Procedure CadPrnRectPutShow (hDwg: Integer; bShow: Integer); stdcall; external vecad_dll;
Function  CadPrnRectGetShow (hDwg: Integer): Integer; stdcall; external vecad_dll;
Procedure CadRegen (hDwg: Integer); stdcall; external vecad_dll;
Procedure CadUpdate (hDwg: Integer); stdcall; external vecad_dll;
Function  CadWndCreate (hDwg: Integer; hWndParent: HWND; CadStyle: Integer; X: Integer; Y: Integer; W: Integer; H: Integer): HWND; stdcall; external vecad_dll;
Function  CadWndResize (hWin: HWND; X: Integer; Y: Integer; W: Integer; H: Integer): Integer; stdcall; external vecad_dll;
Function  CadWndRedraw (hWin: HWND): Integer; stdcall; external vecad_dll;
Function  CadWndSetFocus (hWin: HWND): HWND; stdcall; external vecad_dll;
Procedure CadAccelSetKey (Command: Integer; VirtKey: Integer; Flags: Integer); stdcall; external vecad_dll;
Procedure CadAccelSetDefault ; stdcall; external vecad_dll;
Function  CadCWCreate (hwParent: HWND; Left: Integer; Top: Integer; Width: Integer; Height: Integer): HWND; stdcall; external vecad_dll;
Procedure CadCWDelete ; stdcall; external vecad_dll;
Function  CadCWResize (Left: Integer; Top: Integer; Width: Integer; Height: Integer): Integer; stdcall; external vecad_dll;
Procedure CadCWPutText (hDwg: Integer; szText: Pchar); stdcall; external vecad_dll;
Procedure CadMagPutSize (Size: Integer); stdcall; external vecad_dll;
Function  CadMagGetSize : Integer; stdcall; external vecad_dll;
Procedure CadMagPutScale (Scal: Integer); stdcall; external vecad_dll;
Function  CadMagGetScale : Integer; stdcall; external vecad_dll;
Procedure CadMagPutPos (Pos: Integer); stdcall; external vecad_dll;
Function  CadMagGetPos : Integer; stdcall; external vecad_dll;
Procedure CadMagPutShow (bShow: Integer); stdcall; external vecad_dll;
Function  CadMagGetShow : Integer; stdcall; external vecad_dll;
Function  CadNavCreate (hWndParent: HWND; X: Integer; Y: Integer; W: Integer; H: Integer; Flags: Integer): HWND; stdcall; external vecad_dll;
Procedure CadNavResize (X: Integer; Y: Integer; W: Integer; H: Integer); stdcall; external vecad_dll;
Function  CadNavGetParam (Prm: Integer): Integer; stdcall; external vecad_dll;
Procedure CadNavReturnFocus (bReturn: Integer; hWnd: HWND); stdcall; external vecad_dll;
Procedure CadNavSetLink (hVecWnd: HWND); stdcall; external vecad_dll;
Function  CadCboxCreate (CbType: Integer; hwParent: HWND; Left: Integer; Top: Integer; Width: Integer; Height: Integer; Hdown: Integer): HWND; stdcall; external vecad_dll;
Procedure CadCboxSetActive (CbType: Integer; hwCbox: HWND); stdcall; external vecad_dll;
Procedure CadMenuClear (MenuId: Integer); stdcall; external vecad_dll;
Procedure CadMenuAdd (MenuId: Integer; szItemText: Pchar; ItemCmd: Integer); stdcall; external vecad_dll;
Function  CadRecentLoad (szFileName: Pchar): Integer; stdcall; external vecad_dll;
Function  CadRecentSave : Integer; stdcall; external vecad_dll;
Function  CadRecentDialog (hWin: HWND; szOutFileName: Pointer; pbShowAtStartup: Pinteger): Integer; stdcall; external vecad_dll;
Function  CadRecentAdd (szFileName: Pchar): Integer; stdcall; external vecad_dll;
Function  CadDialogOpenFile (hwParent: HWND; szOutFileName: Pointer): Integer; stdcall; external vecad_dll;
Function  CadDialogSaveFile (hwParent: HWND; szOutFileName: Pointer): Integer; stdcall; external vecad_dll;
Procedure CadTipOfTheDay (hwParent: HWND; szFileName: Pchar; pbShowOnStartup: Pinteger; pTipIndex: Pinteger); stdcall; external vecad_dll;
Procedure CadHelp (hWin: HWND; szTopic: Pchar); stdcall; external vecad_dll;
Procedure CadTTF2VCF (hwParent: HWND); stdcall; external vecad_dll;
Procedure CadSHX2VCF (hwParent: HWND); stdcall; external vecad_dll;
Procedure CadFontsList (hwParent: HWND); stdcall; external vecad_dll;
Procedure CadPluginsDlg (hwParent: HWND); stdcall; external vecad_dll;
Function  CadGetError : Integer; stdcall; external vecad_dll;
Procedure CadGetErrorStr (ErrCode: Integer; szStr: Pointer); stdcall; external vecad_dll;
Procedure CadSetString (IdStr: Integer; szStr: Pchar); stdcall; external vecad_dll;
Function  CadPluginImageRead (szExt: Pchar; szLibName: Pchar; szFuncName: Pchar; Mode: Integer): Integer; stdcall; external vecad_dll;
Function  CadConvertAcadFile (szInFile: Pchar; szOutFile: Pchar): Integer; stdcall; external vecad_dll;
Function  CadExtractImage (szFileName: Pchar; Buffer: Pointer): Integer; stdcall; external vecad_dll;
Function  CadExtractImageMem (pMem: Pointer; Buffer: Pointer): Integer; stdcall; external vecad_dll;
Procedure CadGetVBString (Val: Integer; szStr: Pointer); stdcall; external vecad_dll;
Function  vuGetWindowSize (hWin: HWND; pW: Pinteger; pH: Pinteger): Integer; stdcall; external vecad_dll;
Function  CadGetWindowSize (hWin: HWND; pW: Pinteger; pH: Pinteger): Integer; stdcall; external vecad_dll;
Function  vuCompress (Dest: Pointer; DestMaxLen: Integer; Source: Pointer; SourceLen: Integer; Level: Integer): Integer; stdcall; external vecad_dll;
Function  vuExpand (Dest: Pointer; DestMaxLen: Integer; Source: Pointer; SourceLen: Integer): Integer; stdcall; external vecad_dll;
Procedure vuRotatePoint (pX: Pdouble; pY: Pdouble; pZ: Pdouble; Xcen: Double; Ycen: Double; Zcen: Double; Angle: Double; Plane: Integer); stdcall; external vecad_dll;
Procedure vuPolarPoint (pX: Pdouble; pY: Pdouble; pZ: Pdouble; Angle: Double; Dist: Double; Plane: Integer); stdcall; external vecad_dll;
Procedure vuScalePoint (pX: Pdouble; pY: Pdouble; pZ: Pdouble; Xcen: Double; Ycen: Double; Zcen: Double; ScaleX: Double; ScaleY: Double; ScaleZ: Double); stdcall; external vecad_dll;
Procedure vuMirrorPoint (pX: Pdouble; pY: Pdouble; pZ: Pdouble; A1: Double; B1: Double; Plane: Integer); stdcall; external vecad_dll;
Function  vuGetAngle (x1: Double; y1: Double; z1: Double; x2: Double; y2: Double; z2: Double; Plane: Integer): Double; stdcall; external vecad_dll;
Function  vuGetDist (x1: Double; y1: Double; z1: Double; x2: Double; y2: Double; z2: Double; Plane: Integer): Double; stdcall; external vecad_dll;
Function  vuNormalizeAngle (Angle: Double): Double; stdcall; external vecad_dll;
Procedure vuNumToStr (Val: Double; szOutStr: Pointer; MaxDec: Integer; bTrimZero: Integer; bRemainPoint: Integer); stdcall; external vecad_dll;

type //VC Types

TCMDPRM_INSERT_BLOCK =  Record
 bShowDialog: Integer; // if TRUE - "Insert Block" dialog will be shown, if FALSE - no
 idBlock: Integer;     // identifier of block
 bCoord: Integer;      // if TRUE - InsPnt is used, if FALSE - specify coords on-screen
 InsPntX: Double;     // insertion point
 InsPntY: Double;     //
 InsPntZ: Double;     //
 bScale: Integer;      // if TRUE - Scale is used, if FALSE - specify scale on-screen
 bUniScale: Integer;   // same scale as X for Y, Z
 ScaleX: Double;      // scale
 ScaleY: Double;      //
 ScaleZ: Double;      //
 bAngle: Integer;      // if TRUE - Angle is used, if FALSE - specify angle on-screen
 Angle: Double;       // rotation angle
 bExplode: Integer;    // if TRUE - explode block after insertion
 RowDist: Double;     // distance between rows. (0 for no array)
 ColDist: Double;     // distance between columns. (0 for no array)
 NumRows: Integer;     // number of rows. (1 for no array)
 NumCols: Integer;     // number of columns. (1 for no array)
end;


implementation
begin
CadRegistration(0);
end.
